=======================================================================
                  SIESTA CHANGES: TOP IS MOST RECENT
=======================================================================


** CHANGES ALONG trunk
-----------------------------------------------------------------------
2016-06-23                                                    trunk-525
Merged 4.0-500

* Update list of contributors.
* Electric-field/slab-dipole-correction fix.
* Fix to avoid ps reparametrization in bessel case
* Remove Util/pseudo-xml
* Other minor changes in README files


-----------------------------------------------------------------------
...
...
-----------------------------------------------------------------------
2016-05-29                                                    trunk-504
Update makefile in Util/Gen-basis after ldau inclusion

Some extra modules are needed in Gen-basis

modified:
  Util/Gen-basis/Makefile

-----------------------------------------------------------------------
2016-05-18                                                    trunk-503
Merged fix lp:1582978 (from rel-4.0)

-----------------------------------------------------------------------
2016-05-10                                                    trunk-502
Revise mentions to now-standalone ATOM program. Revert Tests/test.mk.

* The ATOM program is not bundled with Siesta due to licensing
  differences.  Mentions to it throughout the documentation and
  example files have been updated accordingly.

* The file Tests/test.mk has been reverted to the revno 488 version.
  Note that the proper way to run the tests for a given version is
  to descend into the 'Tests' directory directly below the compilation
  directory ('Obj' or other) rather than going to the top-level 'Tests'.

* Syntax changes for compiler complaints reported by Mariella Ippolito
  from CINECA.

* Completion of changes to licensing headers.

modified:
  Docs/siesta.tex
  Examples/README
  Examples/Vps/README
  Src/SiestaXC/vv_vdwxc.F90
  Src/fsiesta_mpi.F90
  Src/write_inp_wannier.F90
  Src/ldau.F
  Src/ldau_specs.f
  Tests/test.mk
  + Header changes in a number of files
  
-----------------------------------------------------------------------
2016-05-05                                                    trunk-501
Fix in 'fat' utility. Write spin info in 'eigfat2plot'

The 'fat' program in Util/COOP computes the projections of specific
band states onto sets of orbitals. Due to an error, the program did
not function correctly when a subset of upper bands was selected with
the '-b' and '-B' flags.

The 'eigfat2plot' utility in Util/Bands now prints an extra field giving
the spin of the state.

modified:
  Util/Bands/eigfat2plot.f90
  Util/COOP/fat.f90
  Util/COOP/main_vars.f90

-----------------------------------------------------------------------
2016-05-03                                                    trunk-500
Fix for handling of geometry info in bands/wfns calculation

The computation of bands and/or wavefunctions in 'siesta_analysis'
requires an initial setup of the k-point sets involved.  These are
input in ad-hoc fdf blocks with two possible options for the scaling:
'pi/a' and 'ReciprocalLatticeVectors'.

The 'pi/a' option needs a lattice constant, which is determined by
issuing an 'fdf_get' call, whereas the reciprocal lattice vector
option triggers a call to 'redcel' to determine the unit cell.

An immediate problem is the absence of lattice constant or unit-cell
information in the fdf file. This may happen, for example, when the
'use-struct-file' or 'use-save-xv' options are in effect. The program
would either stop when not finding the lattice constant, or, worse,
would implicitly compute a zero unit cell and crash later with
linear-algebra related errors such as faulty Cholesky
decompositions. (The zero-unit-cell case is an unfortunate consequence
of the implicit convention that an absent unit cell means that the
user wants an automatic one.)

A second problem is that, even if the required geometry information is
given in the fdf file, the band/wfn calculation might be happening at
the end of a cell relaxation or MD run, so the actual unit cell is not
that in the fdf file. This should be considered bad practice, but it
might happen.

The minimal solution adopted (encoded in routine get_kpoints_scale)
consists of attempting to read the lattice constant for the 'pi/a'
case, as before, but to use the unit-cell information in the
'siesta_geom' module for the reciprocal-lattice-vectors case.  This
information is not enough for the 'pi/a' option, since no record is
kept of any centering options for cubic systems, so 'a' cannot be
directly determined from the volume of the unit cell.  Note that the
setup information is handled at the beginning of the run (during the
initialization in 'siesta_init'.

A message is printed to warn the user about possible inconsistencies
if the unit-cell changes by the end of the run. In any case, the
practice of computing bands or wavefunctions at the end of a
geometry-changing run should be discouraged.

added:
  Src/get_kpoints_scale.f90
modified:
  Src/Makefile
  Src/bands.F
  Src/writewave.F
	
-----------------------------------------------------------------------
2016-05-02                                                    trunk-499
Allowed neglecting KB projectors with LDA+U

- The LDA+U projectors are now not dependent
  on the NeglNonOverlapInt option which only
  deals with KB projectors.

- Streamlined calculation of rmaxo/rmaxkb in
  hsparse, ldau, nlefsm,

  Basically they looped over the entire structure
  to find only the species orbital/projector
  ranges.
  Thus it is more efficient in those routines.

modified:
  Src/Makefile
  Src/hsparse.F
  Src/ldau.F
  Src/nlefsm.f
  Src/siesta_init.F
  Src/state_init.F

-----------------------------------------------------------------------
2016-05-02                                                    trunk-498
Fixed imports

modified:
  Src/ldau_specs.f
  Src/m_cite.F90

-----------------------------------------------------------------------
2016-05-01                                                    trunk-497
Added LDA+U citation of the implementation paper

modified:
  Src/ldau_specs.f
  Src/m_cite.F90

-----------------------------------------------------------------------
2016-04-29                                                    trunk-495
Fixed rmaxh for correct range of Hamiltonian elements

- The rmaxh was too short in case of LDAU projectors
  bigger than the KB projectors.

  This fixes the calculation of the correct rmaxh
  when the LDAU projectors are used.

modified:
  Src/atomlist.f
  Src/siesta_init.F

-----------------------------------------------------------------------
2016-04-29                                                    trunk-494
Cleaned LDA+U

- Moved H_ldau to sparse_matrices.
  This makes the global memory of "standard" matrix
  elements common in the common module.
  This requires that it is passed on every call to
  Hubbard_term.
  
- Moved several saved variables in the hubbard_term
  to the module level.
  This makes it easier to distinguish global variables.

- Removed all commented out debugging statements.

- Improved the logic of the options in the LDA+U implementation

  REMARK: The logic is exactly the same but clearer from the
          input options point of view.

  1. ldau_init is now forced to .true. if ldau_shift is true.
  2. There is no need to store the current geometry setup
     Now the H_ldau is reset when state_init is called.

- Removed a print-out of:

  "Adding Hamiltonian contribution."

  This is implicit in each SCF cycle (from after the
  initial occupations have been calculated).

  I have tested this on an MD run as well.

modified:
  Src/Makefile
  Src/final_H_f_stress.F
  Src/ldau.F
  Src/ldau_specs.f
  Src/scfconvergence_test.F
  Src/setup_hamiltonian.F
  Src/sparse_matrices.F
  Src/state_init.F

-----------------------------------------------------------------------
2016-04-29                                                    ldau-499
Cleaned up the ldau modules by moving variables

- The ldau_specs module had several variables defined
  as module variables while they where only needed
  in one subroutine.
  They have been moved there.

  Now also the projector arrays are deallocated after
  having created the actual projectors used.

  Thus saving additional memory.

modified:
  Src/ldau.F
  Src/ldau_specs.f

-----------------------------------------------------------------------
2016-04-28                                                    ldau-498
Removed _tmp/tmp_ in ldau shells, removed double references

- Removed all double references in the code of ldaushells
  from the derived type.

- Changed tmp names to standard conforming names.
  This is more intuitive to grasp.

modified:
  Src/Makefile
  Src/basis_types.f
  Src/ldau_specs.f

-----------------------------------------------------------------------
2016-04-28                                                    ldau-497
Die if requesting non-existing PAO LDAU projectors

- If the requested quantum number LDAU is not found
  in the list of PAO objects then siesta will die.

modified:
  Src/ldau_specs.f

-----------------------------------------------------------------------
2016-04-28                                                    ldau-496
Cosmetic update of ldau code

- Easier logistic in the loops in ldau

- Cosmetic changes for the interface of hubbard_term which
  now passes the local number of orbitals.

- Beautification of the DEBUG_PAO print-out.

modified:
  Src/final_H_f_stress.F
  Src/hsparse.F
  Src/ldau.F
  Src/register_rfs.F90
  Src/setup_hamiltonian.F

-----------------------------------------------------------------------
2016-04-28                                                    ldau-495
Fix possible double counting of Hldau

- If recompute_H_after_scf it is required that
  we use H_tmp in final_H_f_stress.

  This is now fixed.

modified:
  Src/final_H_f_stress.F

-----------------------------------------------------------------------
2016-04-28                                                    ldau-494
Almost fixed parallel version

- Implemented Alberto's fixes for the basis specifications
  in parallel with some minor corrections.
  
  This is because the basis_specs are only on Node == 0.
  However, the specifications should be broadcasted
  to the other nodes.

  This is now performed by dublicating the LDAU radial
  functions to the other nodes and retaining the
  data on all nodes.

  I have added the remaining Bcast which where required.

- Added bcast of the LDAU variables in broadcast_basis.
  Several variables are required Bcasted.

- Reduced memory requirements slightly

- Reverted globalization of DEldau as entered by
  Nick in r488.
  This is not needed as the DEldau is calculated
  from globalized occupations.

- Removed un-needed ldaushell in the basis_species.
  Only the *_tmp is used so we do not need the second.

- Fix for "SpinPolarized false" regarding occupations

- TODO move Hldau to sparse_matrices such that it may
  be calculated "one time" and stored in a generic place.

modified:
  Src/Makefile
  Src/atm_types.f
  Src/basis_types.f
  Src/broadcast_basis.F
  Src/final_H_f_stress.F
  Src/hsparse.F
  Src/ldau.F
  Src/ldau_specs.f
  Src/setup_hamiltonian.F

-----------------------------------------------------------------------
2016-04-28                                                    ldau-493
Fixed r491 with rofi array size

- Correspondance with Javier brought this
  fix.

modified:
  Src/ldau_specs.f

-----------------------------------------------------------------------
2016-04-27                                                    ldau-492
Added die when user reads basis + LDAU

- Reading the basis from NetCDF or ascii files
  is not allowed when using LDA+U.

  This feature is simply not implemented yet.
  (but could be)

modified:
  Src/initatom.f

-----------------------------------------------------------------------
2016-04-27                                                    ldau-491
Fixes for pointers and possible seg-fault

- Pointers in ldau.F where only nullified in
  the first run. However, they should be
  in each SCF.
  Fixed.

- Print-out of LDAU parameters in the basis-specification
  This makes easy identification of the used LDA+U
  basis.

- A possible seg-fault for accessing array elements beyond
  dimension was found in the ldau_specs.f.

  A possible fix has been added.

  TODO: Check validity for other systems.
  For Javier's initial test MnO the results are identical.

modified:
  Src/basis_types.f
  Src/ldau.F
  Src/ldau_specs.f

-----------------------------------------------------------------------
2016-04-25                                                    ldau-490
Second patches by Nick Andersen

* The files that have been added or modified are:

- hsparse.F:             Call to basis_parameters only if switch_ldau
- matel_registry.F90:    Cosmetic changes on show_pool
- register_rfs.F90:      Writing of part of the output only done if
                         the directive DEBUG_PAO is switched
- siesta_init.F:         Remove the call to test_register 

-----------------------------------------------------------------------
2016-04-25                                                    ldau-488
First patches by Nick Andersen

* The files that have been added or modified are:

- final_H_f_stress.F:    Globalization of the sum of DEldau added
- ldau.F:                Writing on some of the output only on Node 0,
                         globalization of dnmax
- siesta_init.F:         Initialization of Eldau and DEldau

-----------------------------------------------------------------------
2016-04-25                                                    ldau-487
Corrected version in the CHANGES file

-----------------------------------------------------------------------
2016-04-25                                                    ldau-486
Calculation of the Hubbard-like matrix elements, and their contribution
to forces and stresses

* The files that have been added or modified are: 

- atmfuncs.f:       New function ldau_gindex added
- basis_io.F:       The information of the LDA+U projectors is dumped into 
                    the corresponding files
- compute_energies.F90:  The Hubbard energy is added to the total energy
- compute_max_diff.F:    The maximum difference between the input and the 
                         output density matrices is saved in the public
                         variable dDmax_current, that is required within
                         the hubbard_term subroutine in order to know
                         whether the population of the LDA+U projector is 
                         updated or not.
- final_H_f_stress.F:    Last call to hubbard_term in order to compute the
                         forces and stresses once the self-consistency is 
                         achieved
- hsparse.F:        The eventual overlap with the LDA+U projectors is 
                    considered, as it was done with the KB projectors
- initatom.f:       Call to the subroutine ldau_proj_gen to generate the
                    LDA+U projectors
- m_energies.F90:   The Hubbard energies are included in the variables
- scfconvergence_test.F: The criterion on the convergence of the population of
                         the LDA+U is added to the requirements to determine
                         whether the SCF is achieved
- setup_hamiltonian.F:   Call to hubbard_term to add the contribution of the
                         Hubbard-like terms to the Hamiltonian
- write_subs.F:     The information of the Hubbard like energies is dumped
- ldau.F:           New subroutine that computes the Hubbard-like 
                    contribution to matrix elements, forces, and stresses
- Makefile:         Customaty changes to include the new files and dependencies
- Docs/siesta.tex:  A new section on the LDA+U calculations has been written

-----------------------------------------------------------------------
2016-02-22                                                    ldau-485
Generation of the LDA+U projections compatible with new matel

* The files that have been added or modified are: 
- ldau_specs.f:     Module ldau_specs to read the input file,
                    generate the projectors and populate the derived types.
- atm_transfer.f:   Call to populate_species_info_ldau to populate the 
                    variables in the species derived type related with the 
                    LDA+U projectors.
- atm_types.f:      New variables related with the LDA+U projectors 
                    defined in the derived type species. 
                    Essentially, they are a copy of the corresponding variables
                    for the KB projector
- atom.F:           The following subroutines declared public: 
                    schro_eq, rc_vs_e, build_vsoft
- basis_specs.f:    The subroutine label2species is declared public.
                    It will be used afterwards in read_ldau_specs.
- basis_types.f:    New derived type ldaushell_t defined, and the 
                    corresponding subroutines for initialization, print, etc 
                    are introduced.
- broadcast_basis.F:The broadcast of the species derived type has been 
                    generalized to include also the corresponding variables 
                    related with the LDA+U projectors
- initatom.f:       Here we read the info related with the LDA+U projs 
                    in the fdf file (calling the subroutine read_ldau_specs) 
                    and we call the subroutine in charge of generating them
                    (ldau_proj_gen)
- register_rfs.F90: Subroutine modified to include the LDA+U projectors 
                    in the pool
- Makefile:         Customaty changes to include the new files and dependencies


added:
  Src/ldau_specs.f
modified:
  Src/Makefile
  Src/atm_transfer.f
  Src/atm_types.f
  Src/atom.F
  Src/basis_specs.f
  Src/basis_types.f
  Src/broadcast_basis.F
  Src/initatom.f
  Src/register_rfs.F90


-----------------------------------------------------------------------
2016-03-21                                                    trunk-493
Merged Ramon SO changes + fixes

- Merged Ramon's SO changes.

- Changed alot of interfaces from Ramon initial
  commit.
  This is to better conform with the transiesta merge
  to happen shortly.

- Clarified a lot of output for the user when performing
  SO / non-collinear calculations.

- Reduce memory usage from Ramon's version considerably in
  terms of the sparsity pattern.
  In Ramon's implementation the H_kin/H_vkb/H_so where
  full spin-matrices.
  However, this is not needed.
  H_kin/H_vkb == same for all spin
  H_so == only has 6 components

- Fixed calculation of total energy if one requests mixing charge

- Fixed potential memory overflow in dfscf where V was
  allocated on the stack.

- Moved spin-spiral options to m_spin module

- Enabled one flag for controlling the spin-configuration

    Magnetization non-polarized/polarized/non-collinear/spin-orbit

  with some variations of short-hands.
  These are merely added for consistency

    Magnetization NP/P/NC/SO

  This removes the obscure choice of several options for _one_
  selection of computational type.

  For backwards compatibility the old flags still exist and are
  the basis for the initial option for Magnetization.

- Diagonalization options moved to a common module
  TODO extend this to streamline r/c-diag.
  TODO externalize the diagonalization modules for easier
       abstraction.

removed:
  Src/m_diagon.F
added:
  Src/diag3g.F
  Src/diag3k.F
  Src/m_diagon_opt.F90
  Src/moments.F
  Src/pdos2g.F
  Src/pdos2k.F
  Src/pdos3g.F
  Src/pdos3k.F
  Src/spinorbit.f
  Tests/SpinOrbit/
  Tests/SpinOrbit/FePt-L1_0-so/
  Tests/SpinOrbit/FePt-L1_0-so/README
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/x-axis/
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/x-axis/Fe.psf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/x-axis/Pt.psf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/x-axis/fept.fdf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/x-axis/fept.out
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/y-axis/
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/y-axis/Fe.psf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/y-axis/Pt.psf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/y-axis/fept.fdf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/y-axis/fept.out
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/z-axis/
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/z-axis/Fe.psf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/z-axis/Pt.psf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/z-axis/fept.fdf
  Tests/SpinOrbit/FePt-L1_0-so/X-alignment/z-axis/fept.out
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/x-axis/
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/x-axis/Fe.psf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/x-axis/Pt.psf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/x-axis/fept.fdf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/x-axis/fept.out
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/y-axis/
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/y-axis/Fe.psf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/y-axis/Pt.psf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/y-axis/fept.fdf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/y-axis/fept.out
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/z-axis/
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/z-axis/Fe.psf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/z-axis/Pt.psf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/z-axis/fept.fdf
  Tests/SpinOrbit/FePt-L1_0-so/Z-alignment/z-axis/fept.out
  Tests/SpinOrbit/FePt-L1_0-so/config
  Tests/SpinOrbit/FePt-L1_0-so/makefile
  Tests/SpinOrbit/FePt-L1_0-so/script-fept.sh
  Tests/SpinOrbit/Pt2-so-bis/
  Tests/SpinOrbit/Pt2-so-bis/README
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/x-axis/
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/x-axis/Pt.psf
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/x-axis/pt2.fdf
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/x-axis/pt2.out
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/y-axis/
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/y-axis/Pt.psf
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/y-axis/pt2.fdf
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/y-axis/pt2.out
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/z-axis/
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/z-axis/Pt.psf
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/z-axis/pt2.fdf
  Tests/SpinOrbit/Pt2-so-bis/X-alignment/z-axis/pt2.out
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/x-axis/
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/x-axis/Pt.psf
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/x-axis/pt2.fdf
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/x-axis/pt2.out
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/y-axis/
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/y-axis/Pt.psf
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/y-axis/pt2.fdf
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/y-axis/pt2.out
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/z-axis/
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/z-axis/Pt.psf
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/z-axis/pt2.fdf
  Tests/SpinOrbit/Pt2-so-bis/Z-alignment/z-axis/pt2.out
  Tests/SpinOrbit/Pt2-so-bis/config
  Tests/SpinOrbit/Pt2-so-bis/makefile
  Tests/SpinOrbit/Pt2-so-bis/script-pt2.sh
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/bands.F
  Src/born_charge.F
  Src/cdiag.F
  Src/compute_dm.F
  Src/compute_energies.F90
  Src/compute_norm.F
  Src/compute_rhog.F
  Src/dfscf.f
  Src/dhscf.F
  Src/diag2g.F
  Src/diag2k.F
  Src/diagg.F
  Src/diagk.F
  Src/diagon.F
  Src/final_H_f_stress.F
  Src/grdsam.F
  Src/initatom.f
  Src/iodm_netcdf.F90
  Src/ioeig.f
  Src/local_DOS.F
  Src/m_broyden_mixing.f
  Src/m_energies.F90
  Src/m_fire_mixing.f
  Src/m_pulay.F90
  Src/m_spin.F90
  Src/mixer.F
  Src/new_dm.F
  Src/pdos.F
  Src/periodic_table.f
  Src/post_scf_work.F
  Src/projected_DOS.F
  Src/rdiag.F
  Src/reoptical.F
  Src/rhoofd.F
  Src/save_density_matrix.F
  Src/scfconvergence_test.F
  Src/setup_H0.F
  Src/setup_hamiltonian.F
  Src/siesta_analysis.F
  Src/siesta_init.F
  Src/sparse_matrices.F
  Src/state_analysis.F
  Src/state_init.F
  Src/vmat.F
  Src/write_subs.F
  Src/writewave.F
  Src/xc.f

-----------------------------------------------------------------------
2016-03-07                                                    trunk-492
Initial k-displacements are now 0

modified:
  Src/kgridinit.F
  Src/kpoint_grid.F90
  Src/kpoint_pdos.F90
  Src/m_ts_kpoints.F90
  Src/setup_kscell.F

-----------------------------------------------------------------------
2016-03-07                                                    trunk-491
Fixed k-grid displacement reading

- There was no need for not reading 0 as a displacement
  in the kgrid_monkhorst_pack block.

  Previously siesta would error when:
   %block kgrid_monkhorst_pack
    1 0 0 0
    0 1 0 0
    0 0 1 0
   %endblock
  while now this will works

modified:
  Src/kgridinit.F
  Src/kpoint_grid.F90
  Src/kpoint_pdos.F90
  Src/m_ts_kpoints.F90
  Src/setup_kscell.F

-----------------------------------------------------------------------
2016-03-05                                                    trunk-490
Automatic reading of #atoms, and species without denoting count

- The NumberOfSpecies flag is now not needed any more.

  This reflects an easier usage as it first reads the lines
  in the ChemicalSpeciesLabel block and counts the number
  of species from this block.

  A small bug has also been fixed in that the first
  number is now correctly inserted in the slot
  that it intents.

  The NumberOfSpecies flag still has precedence in case
  you want a reduced number of elements.

  +manual

- The NumberOfAtoms is now not needed any more.

  Similar to the NumberOfSpecies flag we now count the
  number of atoms from the block by default.

  The NumberOfAtoms flag still has precedence in case
  you want a reduced number of atoms.

  +manual

- Output of chemical species is now more concise and aligned.
  This is just a visual change.

modified:
  Docs/siesta.tex
  Src/chemical.f
  Src/coor.F

-----------------------------------------------------------------------
2016-03-03                                                    trunk-489
[merge] Tests fix, REFERENCE_DIR and SIESTA

- After having build siesta in the Obj directory
  a natural procedure would be to go to Tests
  and run the tests:
      make
  However, the default SIESTA is not pointing to
  the Obj.
  Further the REFERENCE_DIR is not pointing to the
  correct reference directory when in the top Tests
  directory.

  Hence the procedure is:
  1. cd Obj
  2. ../Src/obj_setup.sh
  3. <create arch.make>
  4. make
  5. cd ../Tests/
  6. make

modified:
  Tests/test.mk

2016-02-26                                                    trunk-488
Add generic citation helper

- It was previously difficult to figure
  out which papers where of significance when
  using SIESTA.
  This addition adds the capability of on-the-fly
  creation of .bib files for users to easier find
  the papers that are being used in their corresponding
  run.

added:
  Src/m_cite.F90
modified:
  Src/Makefile
  Src/m_efield.F
  Src/siesta_init.F
  Src/ts_init.F90

-----------------------------------------------------------------------
2016-02-17                                                    trunk-486
Fixed auxiliary array usage for ksv and optical

- ksv:
  This routine used Hkin as a work-array for calculating
  certain quantities for polarization calculations.

  This may lead to inadvertently destroying reliance
  across calculations which are not intended.

  This bug has been fixed by introducing the allocation
  of the work-array in the ksv routine, directly.

  Furthermore, we have explicitly added the => null()
  when initializing several of the pointers.

- optical:
  This routine used Eold, Dold and Hkin as
  work-arrays for calculating optical properties.

  We have fixed these issues and moved allocation into
  the routine.

  Furthermore there were several "saved" variables
  which were not needed to be saved.

  All variables were re-calculated on each entry-point.
  This has also been fixed.

  Streamlined the algorithm for calculating transition-rates.

- phirphi_opt:
  Reduced memory by ENDLESS.
  It allocated an enourmous amount of memory of which only 1 element
  was used at a time.
  If the full matrix is going to be needed, then re-instantiate the
  comments !N.
  The si-optical test yields the same result and I see no problem
  in the current algorithm.

modified:
  Src/born_charge.F
  Src/ksv.f
  Src/optical.F
  Src/phirphi_opt.f
  Src/siesta_analysis.F

-----------------------------------------------------------------------
2016-02-17                                                    trunk-485
Add GPL notices and headers

* Include proper headers
* Add Docs/Contributors.txt and NOTICE.txt files.
* Update READMEs and LICENSE files in several directories.
* Remove Pseudo/atom, Util/test-xml
* Remove DOM files from Src/xmlparser
* Replace old copyright notice in Src/Confs

This revision touches a large number of files due to the
change in licensing and copyright.

The other major change is the removal of the Pseudo/atom subtree,
which is now distributed independently.

-----------------------------------------------------------------------
2016-02-05                                                    trunk-484
Merge fixes from rel-4.0 branch

* Fix Tests/test.mk and Genbasis makefile

The reference directory's path was incorrect in Tests/test.mk

In Util/Gen-basis/Makefile, the treatment of COMP_LIBS can be improved
with a form suggested by Pedro Brandimarte, which will work even if
there are multiple files in COMP_LIBS.

* Fix peak alloc report in MPI

When alloc-report-level is 1 or 3, a report should be printed at every
peak. This hanged in MPI runs. Now only the root node peaks are
printed.

(Thanks to Nick R. Papior)
  
* Some older .CHANGES files have been moved to the 'branch-changes'
  directory, and older release notes moved to the
  'older-release-notes' directory.

modified:
  Tests/test.mk
  Util/Gen-basis/Makefile
  Src/alloc.F90
  Docs/siesta.tex
added:
  Docs/branch-changes/
  Docs/older-release-notes/

-----------------------------------------------------------------------
2015-12-18   10:25:00 GMT                                     trunk-483
Add lapack and blas code in Libs to support OMM and SVD

* To enable quick compilation with no external libraries, some
  lapack/blas routines have been added to the Src/Libs directory.

  A minimal example of arch.make: Src/Sys/nolibs.make

  Note that some optional features do depend on the availability of
  external libraries, such as netCDF and fftw.
  
added:
  Src/Libs/svd_omm_lapack.f
modified:
  Src/Libs/blas.f
  Src/Libs/makefile
  Src/Sys/nolibs.make
  Util/Gen-basis/Makefile  

-----------------------------------------------------------------------
2015-12-17   16:25:00 GMT                                     trunk-482
New versions of grid2cube and gnubands. Laplacian of grid functions

* Updated new.gnubands in Util/Bands to enhance spin processing
  and optional production of labels in tick marks.

  (Nick R. Papior)
  
* A new experimental program g2c_ng in Util/Grid offers extended
  and cleaner functionality over the classic grid2cube.

* A new program cdf_laplacian in Util/Grid computes the laplacian
  of a grid function in netCDF format.

  (A. Garcia)
  
added:
  Util/Grid/cdf_laplacian.F90
  Util/Grid/g2c_ng.f
  Util/Grid/m_gridfunc.F90
  Util/Grid/m_struct.f90
modified:
  Util/Bands/Makefile
  Util/Bands/README
  Util/Bands/new.gnubands.f90
  Util/Grid/README
  Util/Grid/makefile
  Util/build_all.sh
		    

-----------------------------------------------------------------------
2015-11-26   15:10:00 GMT                                     trunk-481
Increase the number of allowed iterations in minvec

The default value of 100 was inadequate for the needs of
k-point supercells for large multipliers.

modified:
  Src/minvec.f
      
-----------------------------------------------------------------------
2015-11-26   13:50:00 GMT                                     trunk-480
Fix bug in heapsort routine

(Thanks to Nick Papior)

* The recent re-implementation of the heapsort algorithm in routine
  'ordix' in 'sorting.f' (trunk revno 468)  was buggy.

  This affected:

  - The siesta.BONDS file, which did not have optimal ordering of the
    bond-lengths.

  - Some calculations using k-points, as routine 'minvec', used in the
    definition of the effective k-point supercell, calls 'ordix'.
    (The reference outputs for the 'var_cell' and 'si2x1h' tests have
    been modified.)

  - (probably) The re-use of density-matrix information, as the ordering
    of interactions in 'hsparse' also depended on 'ordix' through calls to
    'ordvec'.

  - (maybe) The operation of the "rho-mixing" routines, which use 'ordix'
    for the sorting of stars.

modified:
  Src/sorting.f
  Tests/Reference/si2x1h.out
  Tests/Reference/var_cell.out

-----------------------------------------------------------------------
2015-10-04   00:40:00 GMT                                     trunk-479
Assorted fixes and cleanup. Update reference outputs

- Replace pointers by allocatables in {zm,cell}_broyden_optim.
- Split-off read_options from siesta_options to reduce
  dependencies and clarify hidden symbol associations.
- Remove dependency in sparse_matrices
- Fix dependencies in makefiles in Util
- Remove Reference-xml
- Update Reference-out files
- Provide a simple-minded mechanism to flag differences in the
  test outputs ('make check').

removed:
  Tests/Reference-xml/
  Tests/Reference/partial.out
added:
  Src/read_options.F90
  Tests/Reference/TranSiesta-TBTrans/ts_au_100/au_100.AVTRANS
  Tests/Reference/TranSiesta-TBTrans/ts_au_100/au_100.TEIG
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_0.25V/au_100.AVTRANS
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_0.25V/au_100.TEIG
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_repetition/au_100.AVTRANS
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_repetition/au_100.TEIG
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_repetition_0.25V/au_100.AVTRANS
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_repetition_0.25V/au_100.TEIG
  Tests/TranSiesta-TBTrans/copy_to_reference.sh
  Tests/TranSiesta-TBTrans/run_tests.sh
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/cell_broyden_optim.F
  Src/diagon.F
  Src/final_H_f_stress.F
  Src/obj_setup.sh
  Src/projected_DOS.F
  Src/proximity_check.F
  Src/siesta_analysis.F
  Src/siesta_forces.F
  Src/siesta_init.F
  Src/siesta_move.F
  Src/siesta_options.F90
  Src/sparse_matrices.F
  Src/state_analysis.F
  Src/state_init.F
  Src/struct_init.F
  Src/write_md_record.F
  Src/write_subs.F
  Src/zm_broyden_optim.F
  Tests/Makefile
  Tests/README
  Tests/Reference/*
  Tests/cmp_digest.sh
  Tests/partial/README
  Tests/test.mk
  Util/Denchar/Src/Makefile
  Util/Gen-basis/Makefile
  Util/STM/ol-stm/Src/Makefile
  Util/SiestaSubroutine/README
  Util/TBTrans/Makefile
  Util/TBTrans_rep/Makefile
  Util/VCA/Makefile
  Util/build_all.sh
      


	  


-----------------------------------------------------------------------
2015-09-29   10:25:00 GMT                                     trunk-478
Fixes: OCCS file, pdoskp, processorY

* The OCCS file, containing the occupation at each k-point,
  is now created only during the scf cycle, in 'diagon'. This
  fixes problems that appeared when 'diagk' was called from
  other routines.
  
* Some arrays in pdoskp were not dimensioned correctly on
  input in pdoskp.

* Added a sanity check for the user-entered ProcessorY.

(Thanks to Nick P. Andersen)

modified:
  Src/diagk.F
  Src/diagk_file.F
  Src/diagon.F
  Src/initparallel.F
  Src/pdoskp.F

-----------------------------------------------------------------------
2015-09-17   13:25:00 GMT                                     trunk-477
Fixes: pi/a mode in bands; low-n interpolation; others

* Fix handling of n<3 cases in interpolation.f90 
* Made global variable 'saved' in matel_registry
  (J. Soler, with thanks to Nick P. Andersen)

* Fix uninitialized variable in interpolation.f90.
* Proper check on number of atoms in zmatrix.F.
* Avoid underflow in sorting.f.

  (Thanks to P. Brandimarte)

* In bands.F, only check for LatticeConstant input
  in the "pi/a" case.

modified:
  Src/bands.F
  Src/interpolation.f90
  Src/matel_registry.F90
  Src/sorting.f
  Src/zmatrix.F

-----------------------------------------------------------------------
2015-07-16   15:05:00 GMT                                     trunk-476
Fix the geometry and DM and H logic for consistency in analysis

-*-*-*-*-* 
IMPORTANT NOTE: This patch will slightly change the output
of most calculations and the detailed results of any
post-processing. Keep this in mind if you need to maintain coherency
within a project. See the rest of the text for ways to restore
backward compatibility.  The reference output files in Tests/Reference
have *not* been updated yet.
-*-*-*-*-*
  
This is the initial patch in a long-overdue clarification work related
to the "outer geometry loop" in Siesta and its interaction with the
analysis of the electronic structure.

The most important changes, following the actual refactoring logic, are:

* Superfluous calls to 'superx' to propagate the new coordinates to
  the auxiliary supercell in 'siesta_move' have been removed, as they
  are already done by 'state_init'.

* The above change has the side effect of leaving inconsistent sets of
  unit cell and supercell coordinates in 'siesta_analysis' if the unit
  cell coordinates used in the latter are those 'moved' by the
  geometry-update routines. To avoid this, and to do the analysis
  using the actual coordinates used in the computation of the
  electronic structure, the coordinates are reset to those values
  (using the *_last arrays) in 'siesta_analysis'.  The old behavior
  can be recovered by using by setting the backward compatibility
  switch 'compat-pre-v4-dynamics' to 'true'.


* To guarantee that the DM and H used in the analysis correspond to
  the latest electronic structure computed, there should be no mixing
  at the end of the scf loop. This behavior, which was optional until
  now (controlled by the value of scf-mix-after-convergence) is now
  the default. The use of DM_out instead of DM_mixed provides also a
  truly variational total-energy and more consistent forces. If the
  scf cycle is carried out mixing H, H(DM_in) is recovered by
  re-setting H to Hold in siesta_forces at the end of the cycle.

  Also, to preserve the right H for analysis it is necessary to
  avoid overwriting it in post_scf_work. This is now done by default,
  except if the option 'scf-recompute-h-after-scf' is 'true'.

  There is another switch for pre-v4.0 compatibility in this context:
  If 'compat-pre-v4-dm-h' is 'true', the 'scf-mix-after-convergence'
  and 'scf-recompute-h-after-scf' options are activated too.

  Some comments have been added to siesta_forces to document possible
  further clarifications.

* For clarity, each MD or geometry-optimization flavor has now its own
  self-contained logic block in 'siesta_move'. This has uncovered a
  few issues that have been corrected:

  - The quenched forms of the Verlet and Parrinello-Rahman (PR)
    schemes, which are actually relaxations, did not check for
    convergence before moving the atoms (PR did not check at any
    point).  Now the 'constrained' forces and stress are checked
    before invoking the routines. In the case of PR, a 'target stress'
    can optionally be subtracted from the constrained stress (a
    further form of constraint that was previously only available
    (internally) in the standard relaxation routines). A future update
    might put all these constraint conditions in 'fixed', but care
    should be taken to study their interaction with the MD
    variable-cell routines. A future revision might look into the
    effectiveness of the variable-cell routines.
    There is a new example in Tests for quenched MD relaxation.

  - The geometry output in 'siesta_move' is now exclusively done for
    checkpointing purposes, and typically involves the 'moved'
    geometries.  The current geometry output is done in 'state_init',
    and any final output in 'siesta_analysis'.

  - Some output calls have been removed where they did not make much
    sense (as in the FC or server blocks).

  - The deprecated 'phonon' support has been removed.

* Siesta_analysis outputs the 'current' final geometry, and not the
  'moved' one. The old behavior can be recovered by using the
  'compat-pre-v4-dynamics' switch.

* The default 'dynamics' option has been changed from 'verlet' to 'CG'.
  There should really be a new 'single-point' default which completely
  avoids 'siesta_move'. The old behavior can be recovered by using the
  'compat-pre-v4-dynamics' switch.

* Single-point calculations do not write .STRUCT_NEXT_ITER files, and
  the coordinates in the XV file are the current ones, unmoved.
  Extra output in siesta_options is avoided for this case.

* The headings for the beginning of the dynamics blocks are now
  more concrete.

Other minor changes:

* Fix the IO field widths in the bonds routine to support more atoms.

* Add a few more deallocations in several routines, and change the
  'routine' field in some deallocations to match the allocations
  (notably for arrays in the 'sparse_matrices' module)

* Cosmetic changes in the output format for dynamics headings

* Atomic displacements for force-constant runs are output in Ang.

removed:
  Src/phonon.F
added:
  Src/m_target_stress.F
  Tests/si2x1h-quench/
  Tests/si2x1h-quench/makefile
  Tests/si2x1h-quench/si2x1h-quench.fdf
  Tests/si2x1h-quench/si2x1h-quench.pseudos
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/atomlist.f
  Src/bonds.f
  Src/dhscf.F
  Src/diag2g.F
  Src/diag2k.F
  Src/final_H_f_stress.F
  Src/fixed.F
  Src/ioxv.F
  Src/m_check_supercell.f
  Src/m_pulay.F90
  Src/new_dm.F
  Src/post_scf_work.F
  Src/save_density_matrix.F
  Src/siesta_analysis.F
  Src/siesta_forces.F
  Src/siesta_init.F
  Src/siesta_move.F
  Src/siesta_options.F90
  Src/sparse_matrices.F
  Src/state_analysis.F
  Src/state_init.F
  Src/write_subs.F

-----------------------------------------------------------------------
2015-07-08   11:00:00 GMT                                     trunk-475
Minor fixes and cosmetic changes after Wannier merge

* Associate auxiliary array auxloc in slave nodes even if
  not used in mpi_reduce call (Nick P. Andersen).

* Add missing files in Test/wannier.

* Streamline the wannier interface output.

added:
  Tests/wannier/makefile
  Tests/wannier/wannier.pseudos
modified:
  Src/compute_pw_matrix.F90
  Src/m_digest_nnkp.F90
  Src/write_inp_wannier.F90

-----------------------------------------------------------------------
2015-07-07   08:30:00 GMT                                     trunk-474
Merge code for interoperation with Wannier90

(Javier Junquera, after work by Richard Korytar, and Alberto Garcia)

Siesta can now read the .nnkp file produced by Wannier90 and output
the *.amn, *.mmn, *.eig (see below), and UNK* files needed by
post-processing with that program, which generates maximally-localized
Wannier functions.

The most relevant changes in the code needed to support this
functionality are detailed below. For practical guidance, see the
manual, the simple test in Tests/wannier, and the suite of Wannier90
examples adapted for Siesta in

   http://personales.unican.es/junqueraj/Wannier-examples.tar.gz


* To implement support for "projection functions", which might not be
  pure radial functions, but hybrids with mixed angular momentum and
  varying spatial orientation, as well as to provide support of
  arbitrary kinds of radial functions for future developments, the
  'matel' framework has been extended:

  Matel (actually renamed to 'new_matel') now accepts two generalized
  indexes instead of the two pairs of indexes previously used. The
  generalized indexes can represent either a normal "radial function",
  as in previous Siesta usage, or a "projection function". The indexes
  are obtained via a "check-in" into a registry of functions, which
  keeps track of the nature of the functions and provides the needed
  evaluators and accessors for 'new_matel'.

  The relevant code is in 'matel_registry', 'new_matel', and
  'register_rfs'. The latter shows how to "register" the usual radial
  functions for PAOs, KB projectors, etc. 

* Bloch states are computed and saved, instead of being recomputed as
  needed, to avoid problems with irreproducible random phases and
  linear combinations within degenerate subspaces.

* At this point the parallelization of the new code is only "over
  orbitals". It is not yet possible to parallelize the operations over
  the k-points on the grid. The production of the UNK* files can be
  slow if there are many k-points and bands.

* There is not yet support for "spinor wavefunctions". In the case of
  spin-polarized calculations, separate spin-up and spin-down
  processings are needed.

* There is not yet support for interaction with Wannier90 in "library
  mode", due to licensing issues.

* The "eigenvalue file" for Wannier90 has extension .eigW to avoid
  clashes with the standard Siesta eigenvalue file in case-insensitive
  filesystems.

removed:
  Src/matel.f
added:
  Src/amn.F90
  Src/broadcast_projections.F
  Src/compute_pw_matrix.F90
  Src/delk.F
  Src/diagonalizeHk.F90
  Src/m_digest_nnkp.F90
  Src/m_noccbands.f
  Src/m_orderbands.F
  Src/m_overkkneig.F90
  Src/m_planewavematrix.F90
  Src/m_planewavematrixvar.F90
  Src/m_trialorbitalclass.f90
  Src/m_writedelk.F
  Src/matel_registry.F90
  Src/mmn.F90
  Src/new_matel.f
  Src/register_rfs.F90
  Src/reordpsi.F
  Src/siesta2wannier90.F90
  Src/write_inp_wannier.F90
  Tests/wannier/		-- New test
  Tests/wannier/wannier.fdf
  Tests/wannier/wannier.nnkp
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/alloc.F90		-- New z3 and z4 generics
  Src/m_mpi_utils.F
  Src/atm_types.f       -- Fields for global index storage
  Src/atmfuncs.f        -- Global index management
  Src/dhscf.F           -- New routine to compute PW matrix elements
  Src/mneighb.f         -- Added 'x0' module variable
  Src/parallelsubs.F	-- Catch special blocksize case
  Src/mesh.F		-- Extra bookeeping
  Src/meshdscf.F
  Src/meshsubs.F
  Src/kinefsm.f		-- New matel
  Src/naefs.f
  Src/nlefsm.f
  Src/overfsm.f
  Src/overlap.f
  Src/phirphi.f
  Src/phirphi_opt.f
  Src/siesta_analysis.F		-- Actual w90 processing
  Src/siesta_init.F
  Src/siesta_options.F90
  Src/spher_harm.f		-- Two implementations of YLMEXP.

    
-----------------------------------------------------------------------
2015-06-29   15:20:00 GMT                                     trunk-473
Merge code for 'server' operation via sockets and i-PI interface

(Michele Ceriotti, Jose Soler)

* A new infrastructure for socket handling in f90 has been
implemented by Michele Ceriotti (EPFL), who is also the author
of the i-PI framework. From its web-page:

  i-PI is a Path Integral Molecular Dynamics (PIMD) wrapper code
  designed to be used together with ab initio evaluation of the
  interactions between the atoms. i-PI should be run as a separate
  program, and communicates with one or more instances of an
  electronic structure code using internet (or UNIX) sockets. The
  communication is regulated by a simple protocol, and requires
  patching the client code to handle the exchange of data with i-PI.

This revision implements the interface to the i-PI protocol. In
Siesta, the new socket functionality can also be used as a new form of
'server' operation.

See Util/Sockets for examples of the f90 socket interface,
Util/SiestaSubroutine for examples of the server operation (including
via sockets) and Tests/i-pi-test for a simple test of interoperability
with i-PI.

added:
  Src/fsiesta_sockets.F90
  Src/fsockets.f90
  Src/iosockets.F90
  Src/sockets.c
  Tests/ipi-test/
  Util/SiestaSubroutine/SimpleTest/README
  Util/SiestaSubroutine/SimpleTest/socket.fdf
  Util/SiestaSubroutine/SimpleTest/sockets.sh
  Util/Sockets/
renamed:
  Util/SiestaSubroutine/SimpleTest/Src/simple_pipes_parallel.f90 => 
    Util/SiestaSubroutine/SimpleTest/Src/simple_parallel.f90
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/fsiesta_mpi.F90
  Src/fsiesta_pipes.F90
  Src/siesta_master.f90
  Src/siesta_options.F90
  Src/struct_init.F
  Util/README
  Util/SiestaSubroutine/FmixMD/Src/para.f90
  Util/SiestaSubroutine/README
  Util/SiestaSubroutine/SimpleTest/Src/Makefile
  Util/SiestaSubroutine/SimpleTest/h2o.fdf
  Util/SiestaSubroutine/SimpleTest/test.sh
  Util/SiestaSubroutine/SimpleTest/Src/simple_parallel.f90

-----------------------------------------------------------------------
2015-06-22   9:35:00 GMT                                     trunk-472
Revert previous change affecting FA and FC files. FAC/FCC files.

* At revno 464, a change was introduced to output the constrained
  forces to the FA and FC files.  This had unintended consequences for
  some analysis tools.

  The change has been reverted, and the FC/FA files are now created as
  before. In addition, if constraints are used, new FCC/FAC files
  will be created with the constrained forces.

  The vibra utility will default to use the FCC files if the
  GeometryConstraints block exists, and in any case the
  force-constants file to use can be specified with the Vibra.FC fdf
  option.

  To support these changes, the write_forces subroutine has now 
  the geometry step as an additional argument.

  The writing of forces has been moved to its appropriate place in the
  write_subs modules.

* Some more cosmetic changes in the Vibra package.

modified:
  Docs/siesta.tex
  Src/Makefile
  Src/iofa.f
  Src/ofc.f
  Src/siesta_analysis.F
  Src/siesta_forces.F
  Src/state_analysis.F
  Src/write_subs.F
  Util/Vibra/Docs/CHANGES
  Util/Vibra/Docs/vibra.tex
  Util/Vibra/Examples/README
  Util/Vibra/Examples/si54.bands
  Util/Vibra/Examples/si54.fdf
  Util/Vibra/Src/Makefile
  Util/Vibra/Src/fcbuild.f
  Util/Vibra/Src/recoor.f
  Util/Vibra/Src/vibra.f

-----------------------------------------------------------------------
2015-06-17   8:50:00 GMT                                     trunk-471
Fix SiestaXC makefile. Clarifiy docs for WriteDenchar

* Fix a typo in SiestaXC/makefile that was preventing
  the correct processing of the "dist" target.
  (J. Soler)

* Update the WriteDenchar documentation in the Siesta manual.
  (G. Huhs)

modified:
  Docs/siesta.tex
  Src/SiestaXC/makefile

-----------------------------------------------------------------------
2015-06-10  12:30:00 GMT                                     trunk-470
Build fixes in Util and SiestaXC

* Bring up to date the code in STM/ol-stm.

* Fixes for compilation of various programs
  in Util after the NR changeover.

added:
  Util/Gen-basis/local_die.F
  Util/STM/ol-stm/Src/handlers.f
modified:
  Src/SiestaXC/atomxc.F90
  Src/SiestaXC/mesh1d.f90
  Util/Denchar/Src/Makefile
  Util/Gen-basis/Makefile
  Util/Gen-basis/gen-basis.F
  Util/STM/ol-stm/Src/Makefile
  Util/STM/ol-stm/Src/atompla.f
  Util/STM/ol-stm/Src/extrapolate.f
  Util/STM/ol-stm/Src/fftw3_mymod.f90
  Util/STM/ol-stm/Src/readstm.f
  Util/STM/ol-stm/Src/reinitstm.f
  Util/STM/ol-stm/Src/stm.f
  Util/SiestaSubroutine/FmixMD/Src/Makefile
  Util/build_all.sh*

-----------------------------------------------------------------------
2015-06-02  09:45:00 GMT                                     trunk-469
Cosmetic fix for errorf.f

Put proper end statements

modified:
 Src/errorf.f

-----------------------------------------------------------------------
2015-06-02  07:10:00 GMT                                     trunk-468
Replacement of NR routines. Fix for charge-conf variables.

* Replaced FFT 1d routine by a version based on Temperton's GPFA
  
  Calls to the 'four1' routine have been replaced by calls to
  'fft_gpfa_ez' with the same arguments. This routine lives
  in a new module in 'm_fft_gpfa.F', which also contains the
  legacy code by Temperton and the original entry points.
  
  The cdf_fft program in Util/Grid now uses Temperton's GPFA package.

  (A. Garcia)

* Replaced tred2/tqli by Lapack calls in m_filter (E. Artacho)
  
* Replaced derf/derfc by Netlib versions          (E. Artacho)

* Replaced random number routine                  (E. Artacho)
  
* Some routines from Numerical Recipes reimplemented
  
  Some routines from Numerical Recipes have been reimplemented with
  (mostly) the same algorithms.
  
  (Jose Soler, with minor changes by A. Garcia)
  
    - spline interpolation routines rewritten and moved to interpolation module
    - polint Lagrange interpolation rewritten and moved to interpolation module
    - ordix subroutine recoded
    - chebfd re-styled to remove remaining similarities with NR chebft
    - choldc and cholsl fully re-styled and renamed as cholDcmp and cholLinSys
    - zbrent substituted by a simple bisection root finder
    - amoeba method re-implemented
  
  (+ Interface to external routine 'die' simplified: it now
     requires a string argument) (A. Garcia)
  
* Bugfix for soft confinement charge
  
    A shell was not initialized properly if the PAO.Basis block was
    not defined. Now the initialization routine is called before
    setting up the orbital.
  
    Also changed the comments about the magnitude of the charge
    confinement width.
  
    (Nick P. Andersen)
  
----------------(Inserted missing records)-----------------------------
2015-03-04 11:47:32 +0100                            [trunk-467]
Fix import of idyn in save_density_matrix (rc-4.0) 
  
  * The idyn variable was not imported from siesta_options 
    in standard "siesta" mode
  
  (thanks to J. Junquera)
  
  modified:
    Src/save_density_matrix.F
------------------------------------------------------------
2015-02-03 15:28:00 +0100                            [trunk-466]
Fixed IO statements for molecularmechanics module 
  
  (Nick .P. Andersen)
  
  * IO print-outs was still abundant in parallel runs.
    Now only the IO node will print out.
  
  * The manual has been corrected to correctly state
    that any unit is allowed in the MM.* block.
  
  modified:
    Docs/siesta.tex
    Src/molecularmechanics.F90
------------------------------------------------------------
2015-01-07 11:35:12 +0100                        [trunk-465]
Merge fix from rc-4.0: MPI tag in SiestaXC/mesh3d
  
  * The variable Mpitag was not initialized, leading to problems whenever
    its value was not zero or considered as MPI_ANY_TAG in a Recv operation.
  
  (Nick P. Andersen)
  
  modified:
    Src/SiestaXC/mesh3d.F90
------------------------------------------------------------
2014-11-08 17:26:37 +0100                             [trunk-464]
Merge fixes from rc-4.0: constr. forces, MPI compilation, mm.potentials
  
  -- Fabiano Corsetti: Fix output to show constrained forces
  
  * Changed the calling of the iofa and ofc routines inside write_subs,
    so that the forces with constraints are written to file in each case
    instead of the uncorrected forces. 
  
  modified:
    Src/write_subs.F
  
  
  -- Alberto Garcia:   Fix 'clean' rule in  MPI Makefile
  
  The interface library libmpi_f90.a was not removed when issuing a
  'make clean', possibly leading to strange errors if the MPI
  compilation environment was later changed.
  
  modified:
    Src/MPI/Makefile
  
  -- Nick P Andersen:  Fix shortcomings in reading of empirical potential block
  
  * The number of potential lines is now arbitrary.
  * Units handling has been improved, to allow arbitrary
    length and energy units.
  
  modified:
    Src/molecularmechanics.F90

-----------------------------------------------------------------------
2014-11-08  16:15:00 GMT                                     trunk-463
Added restart file for smooth continuation of annealing runs

* Added the writing and reading of an .ANNEAL_RESTART file, along the
  same lines of the .VERLET_RESTART file. This fixes a small problem
  for restarting annealing calculations when a continuous smooth run
  is desired.

(Fabiano Corsetti)

added:
  Tests/anneal-cont/
  Tests/anneal-cont/README
  Tests/anneal-cont/makefile
  Tests/anneal-cont/script.sh
modified:
  Docs/siesta.tex
  Src/dynamics.f

-----------------------------------------------------------------------
2014-05-29  12:40:00 GMT                                     trunk-462
Improved MPI version of siesta as a subroutine (J.M.Soler)

* The MPI version of fsiesta now creates a directory for each siesta
  process, and writes in it all output and continuation files

* New example Util/SiestaSubroutine/ProtoNEB/

added:
  Util/SiestaSubroutine/ProtoNEB/
  Util/SiestaSubroutine/ProtoNEB/NH3-point01.fdf
  Util/SiestaSubroutine/ProtoNEB/NH3-point02.fdf
  Util/SiestaSubroutine/ProtoNEB/NH3-point03.fdf
  Util/SiestaSubroutine/ProtoNEB/NH3.fdf
  Util/SiestaSubroutine/ProtoNEB/Src/
  Util/SiestaSubroutine/ProtoNEB/Src/Makefile
  Util/SiestaSubroutine/ProtoNEB/Src/protoNEB.F90
modified:
  Src/fsiesta_mpi.F90
  Util/SiestaSubroutine/README

-----------------------------------------------------------------------
2014-05-29  10:45:00 GMT                                     trunk-461
%files added to Util/JobList options (J.M.Soler)

added:
  Util/JobList/Examples/Ice/dummyFile
modified:
  Util/JobList/Examples/Ice/iceChecks.jobs
  Util/JobList/README
  Util/JobList/Src/jobList.f90

-----------------------------------------------------------------------
2014-05-29  10:30:00 GMT                                     trunk-460
New GGA and VDW functionals (M.Fritz & J.M.Soler)

* Added 4 GGA functionals by Capelle et al
  Refs: L.S.Pedroza et al, PRB 79, 201106 (2009) and
        M.M.Odashima et al, J. Chem. Theory Comp. 5, 798 (2009)

* Added 2 VDW-DF functionals of 
        V.R.Cooper, PRB 81, 161104(R) (2010)
        K. Berland and P. Hyldgaard, PRB 89, 035412 (2014)

* Fixed PW91 and BLYP GGA functionals 

* Corrected a minor bug in vdwxc.F90 (parameter nq->mq)

* Updated and extended XC testers

* Added some test outputs in SiestaXC/Testers/Reference

* m_timer.F90 added to SIESTA_SRCS in SiestaXC/makefile

(+ fix syntax error in Pseudo/atom/pxf.F90)
(+ increase patch level in Pseudo/atom/version.h)

added:
  Docs/gga.CHANGES
  Src/SiestaXC/Testers/Reference/
  Src/SiestaXC/Testers/Reference/test1.out
  Src/SiestaXC/Testers/Reference/test2.out
  Src/SiestaXC/Testers/Reference/test3.out
  Src/SiestaXC/Testers/Reference/test4.out
  Src/SiestaXC/Testers/test6.f90
  Src/SiestaXC/Testers/test6.m
renamed:
  Src/SiestaXC/Testers/test2.f90 => Src/SiestaXC/Testers/test2.F90
modified:
  Docs/siesta.tex
  Pseudo/atom/Docs/atom.tex
  Pseudo/atom/pseudoXML.f
  Pseudo/atom/pxf.F90
  Pseudo/atom/velect.f
  Pseudo/atom/version.h
  Src/SiestaXC/Testers/makefile
  Src/SiestaXC/Testers/test1.f90
  Src/SiestaXC/Testers/test3.F90
  Src/SiestaXC/Testers/test4.F90
  Src/SiestaXC/Testers/test5.f90
  Src/SiestaXC/atomxc.F90
  Src/SiestaXC/cellxc.F90
  Src/SiestaXC/ggaxc.f
  Src/SiestaXC/ldaxc.f
  Src/SiestaXC/makefile
  Src/SiestaXC/siestaxc.F90
  Src/SiestaXC/vdwxc.F90
  Src/SiestaXC/vv_vdwxc.F90
  Src/SiestaXC/xcmod.f90
  Src/atom.F
  Src/xc.f
  Src/SiestaXC/Testers/test2.F90

-----------------------------------------------------------------------
2014-03-25  12:40:00 GMT                                     trunk-459
Fix bug when reading spin-polarized deformation charge

When reading a spin-polarized deformation charge (in netCDF form)
the added atomic-superposition charge was too large by a factor of two.

modified:
  Src/dhscf.F

-----------------------------------------------------------------------
2014-03-05  09:15:00 GMT                                     trunk-458
Fixes and new features in fdf

* Fix handling of empty value for fdf_string

When a line contains only a label, fdf_string incorrectly tried to
read beyond the first token.  It has now been fixed, assigning an
empty string to the function value.

* Nullify fdf buffer pointer at declaration

(+ fix the assignment of the name for the debug file)

* New list functionality in fdf (Nick P Andersen)

See Src/fdf/sample.F90 and sample.fdf for examples.

* A more flexible fdf_init (JM Soler)

The routine fdf_init can be called without arguments in the most
common case when reading from standard input (unit 5). See the new
code in fdf.F90 for details. Note that Siesta does not yet use the new
possibilities.

added:
  Docs/fdf.CHANGES
modified:
  Src/fdf/fdf.F90
  Src/fdf/parse.F90
  Src/fdf/sample.F90
  Src/fdf/sample.fdf
  version.info

-----------------------------------------------------------------------
2014-03-05  09:10:00 GMT                                     trunk-457
Fix printed charges for transiesta in spin-polarized case

* When using spin the shown charges were wrong, however, the computations
  are correct.
  The charges are now consistent.
  (Thanks to Paula Abufager and Nicolas Lorente for pointing this out)
  
modified:
  Src/m_ts_in_siesta.F

-----------------------------------------------------------------------
2014-02-20  11:30:00 GMT                                     trunk-456
Bug fixes and feature changes in charge-density mixing

* The criterion for participation of a node in the DIIS procedure was
faulty.

* For spin-polarized systems, the rho(G=0) components were not mixed,
  as they should.

* Several option labels have changed:

The "old"  ThomasFermiK2  option has been renamed to

SCF.Kerker.q0sq  [ physical energy ]

The default remains 0.0 Ry, although the program now prints several
possible heuristic values:

- The actual Thomas-Fermi wavevector squared
- The square of 2*pi/L, where L is the length of the longest cell vector.

SCF.RhoG.DIIS.Cutoff  (physical energy)

determines the sub-set of G vectors which will undergo the DIIS
procedure.  Default: 9 Ry.

SCF.RhoG.DIIS.Depth

determines the maximum number of previous steps considered in the DIIS
procedure. Default: 0

SCF.RhoG.Metric.Preconditioner.Cutoff (physical energy)

determines the value of "q1^2" in the weighing of the different G
components in the scalar products among residuals in the DIIS
procedure. Following the KF ansatz, this parameter is chosen so that
the smallest (non-zero) G has a weight 20 times larger than that of
the smallest G vector in the DIIS set.  Default: The KF prescription.

SCF.DebugRhogMixing

controls the level of debugging output in the mixing procedure
(basically whether the first few stars worth of Fourier components are
printed). Default: False.  Note that this feature will only display
the components in the master node...

* By default, the DIIS procedure uses a method based on
  singular-value-decomposition to find the coefficients.  

  To turn off SVD, use 'SCF.RhoG.DIIS.UseSVD F'

  To modify the threshold for removal of small singular values (set by
  default to a ratio of 1.0e-8 with respect to the maximum
  sing. value) use 'SCF.RhoG.DIIS.RcondSVD <value>'

  Use 'debug-diis T' to see debugging information. 

modified:
  Docs/siesta.tex
  Src/Makefile
  Src/m_rhog.F90
  Src/m_diis.F90
  Tests/h2o-rhog-mixing/h2o-rhog-mixing.fdf

-----------------------------------------------------------------------
2014-02-10  09:40:00 GMT                                     trunk-455
Charge-density mixing

With the fdf option

    MixCharge T

the self-consistent-field convergence acceleration will be carried out
by mixing the charge density (actually the Fourier-components of the
charge). Both a simple Kerker-preconditioning and a DIIS procedure with
a subset of the Fourier components are implemented.

The implementation follows the ideas in Kresse+Furthmuller,
Comp.Mat.Sci. 6, 15-50 (1996), KF in what follows).

Relvant parameters:

  ThomasFermiK2   (physical energy)

determines the Thomas-Fermi wavevector squared (in Ry) featuring in
the Kerker mixing, which is always performed on all components of
rho(G), even those treated with the DIIS scheme. Default: 0 Ry.


  RhoGMixingCutoff  (physical energy)

determines the sub-set of G vectors which will undergo the DIIS
procedure.  Only those with kinetic energies below this cutoff will be
considered.  The optimal extrapolation of the rho(G) elements will be
replaced in the fourier series before performing the Kerker
mixing. Default: 9 Ry.

  RhoG-DIIS-Depth

determines the maximum number of previous steps considered in the DIIS
procedure. Default: 0

  RhoG-SP-Preconditioner-Cutoff (physical energy)

determines the value of "q1^2" in the weighing of the different G
components in the scalar products among residuals in the DIIS
procedure. Following the KF ansatz, this parameter is chosen so that
the smallest (non-zero) G has a weight 20 times larger than that of
the smallest G vector in the DIIS set.  Default: The KF prescription.

  DebugDIIS

controls the level of debugging output in the DIIS procedure. Default:
False.

  DebugRhogMixing

controls the level of debugging output in the mixing procedure
(basically whether the first few stars worth of Fourier components are
printed). Default: False.  Note that this feature will only display
the components in the master node...

  SCF.MixCharge.SCF1

controls whether mixing is done in the first scf step. Default:
false. (This seems to speed up convergence in some cases. More data is
needed.)

 The information about rhog_in and rhog_out in first scf iteration is
not added to the DIIS history. This seems to improve the convergence.

* Added h2o-rhog-mixing test

Note that the default convergence criteria remains based on the
differences in the density matrix, but in this case the differences
are from step to step, not the more fundamental DM_out-DM_in. Perhaps
some other criterion should be made the default (max |Delta rho(G)|,
convergence of the free-energy...)

Note that with charge mixing the Harris energy as it is currently
computed in Siesta loses its meaning, since there is no "DM_in". The
program prints zeroes in the Harris energy field.

Note that the KS energy is correctly computed throughout the scf cycle,
as there is an extra step for the calculation of the charge stemming from
DM_out, which also updates the energies. Forces and final energies are
correctly computed with the final DM_out, regardless of the setting of 
the option for mixing after scf convergence.

The program now prints a more accurate summary of the criterion used
for scf cycle termination.

Note that the criterion for total-energy convergence now uses the free
electronic energy, which is the appropriate magnitude to monitor in
the general case of possibly fractional occupancies.

The mixing flavor should be made into a first-class option variable,
instead of being encoded in two separate logicals (mix_charge,
mixH)...

The new code uses a circular stack implemented using a
"reference-counting" paradigm.

-----------------------------------------------------------------------
2014-01-31  15:15:00 GMT                                     trunk-454
Allow the handling of ghosts of synthetic atoms

Species with "atomic number" < -200 are now correctly treated as
ghosts of synthetic atoms.

(Thanks to A. Vozny and A. Suarez)

modified:
  Docs/siesta.tex
  Src/atm_transfer.f
  Src/atom.f
  Src/chemical.f
  Src/periodic_table.f

-----------------------------------------------------------------------
2014-01-16  15:35:00 GMT                                     trunk-453
Added a simple ps-->inp converter for ATOM

This program is useful when the INP file is no longer available.

It has a few limitations: note in particular that it cannot possibly
reconstruct the partial core radius.

(A. Garcia)

added:
  Pseudo/atom/Util/Ps2Inp/
  Pseudo/atom/Util/Ps2Inp/die.F
  Pseudo/atom/Util/Ps2Inp/flib_spline.f90
  Pseudo/atom/Util/Ps2Inp/make_ps_input.f90
  Pseudo/atom/Util/Ps2Inp/pseudopotential.f

-----------------------------------------------------------------------
2014-01-15  11:40:00 GMT                                     trunk-452
Fixed a wrong threshold for the bias for transiesta runs

* Due to a programming error, at low bias the Voltage was considered
  to be too low at 0.1 V instead of at 10^(-4) V.
  
modified:
  Src/m_ts_options.F90

-----------------------------------------------------------------------
2013-12-04  14:00:00 GMT                                     trunk-451
Use electronic entropy from current SCF step. EHarris update fix.

* The electronic entropy is computed (in 'compute_dm') once the
  electronic structure is known. The -TS term in the electronic free
  energy was previously computed using the information from the
  previous SCF step (by having it added to Etot in
  'setup_hamiltonian', using an intermediate variable). Now it is
  added in 'scfconvergence_test' and it corresponds to the current SCF
  step. (The last entropy computed in the scf cycle is also added to
  the final Etot in 'post_scf_work'.) There is not much theoretical
  justification for the previous choice, and the new one looks more
  appropriate in general, and notably if E_KS(out) is computed (as
  with H mixing).

* The Harris energy update DEharr is computed in 'compute_dm', and
  corresponds to Tr(H*(DM_out-DM_in)).
  
  In 'post_scf_work' there was a statement
  
        Eharrs = Etot + DEharr

  Since this Etot is computed with DM_mixed (the DM predicted by
  'mixer' for a hypothetical next SCF iteration) or with DM_out
  (depending on whether a final mixing is done at the end of the
  cycle) this value for Eharrs is suspect. This value was never
  actually printed, since printing routines used 'Eharrs1', which is
  the last value of Eharrs computed in the SCF cycle (set in
  'scfconvergence_test'). To reproduce that behavior, the above
  statement has been removed, and Eharris1 replaced by Eharrs
  everywhere.

* Added a message detailing which DM is used in 'post_scf_work',
  and suggesting the use of "SCF.MixAfterConvergence F"

modified:
  Src/Makefile
  Src/compute_dm.F
  Src/final_H_f_stress.F
  Src/local_DOS.F
  Src/m_energies.F90
  Src/post_scf_work.F
  Src/scfconvergence_test.F
  Src/setup_hamiltonian.F
  Src/siesta_init.F
  Src/write_md_record.F
  Src/write_subs.F

-----------------------------------------------------------------------
2013-11-22  15:30:00 GMT                                     trunk-450
Fix SiestaXC/mesh3d to avoid overflow of distributions and/or tasks

(Thanks to Nick P. Andersen)

Due to two bugs in mesh3d.F90, the number of mesh distributions 
and/or communication tasks overflowed in some cases, specially
when using vdW and a variable cell. Fixed.

modified:
  Src/SiestaXC/cellxc.F90 : improved output to debugXC
  Src/SiestaXC/mesh3d.F90 : bug fixes + improved debugXC output

-----------------------------------------------------------------------
2013-11-15  15:20:00 GMT                                     trunk-449
Fix Tbtrans runs at Gamma when using Transiesta k-point data

(Thanks to Nick P. Andersen)

When a calculation was performed with k-points in transiesta and a
subsequent tbtrans calculation was performed ONLY at the Gamma point,
the calculated transmission was wrong.

This has now been fixed.

modified:
  Util/TBTrans_rep/tbtrans.F90

-----------------------------------------------------------------------
2013-10-31  19:30:00 GMT                                     trunk-448
Minor fixes in XC library (JMS)

- Due to roundoff errors, the first mesh point generated by mesh1d
  might be slightly outside the given range. This has been fixed.
- The maximum number of mesh distributions in mesh3d has been increased.
- To reduce the executable file, the allocation of some large arrays in 
  vdwxc.F90 and vv_vdwxc.F90 has changed from static to dynamic.
- To avoid compiler warnings, some real-to-integer conversions in
  vv_vdwxc.F90 have been changed from implicit to explicit.

modified:
  Src/SiestaXC/makefile
  Src/SiestaXC/mesh1d.f90
  Src/SiestaXC/mesh3d.F90
  Src/SiestaXC/vdwxc.F90
  Src/SiestaXC/vv_vdwxc.F90

-----------------------------------------------------------------------
2013-10-22  14:10:00 GMT                                     trunk-447
Improve the estimation of the orbital distribution blocksize

For small problems or a too-large number of processors (heuristically,
when nprocs*24 > norbs), the estimation of the default blocksize for
orbital distribution could lead to some processors being idle, or to a
large imbalance in the distribution.

This has been fixed. The imbalance (the ratio of maximum to minimum
number of orbitals assigned to a processor) is now not larger than 2 for
those badly designed runs.

The imbalance is printed to the output file.

(A. Garcia)

modified:
  Src/initparallel.F
  Src/m_dminim.F90
  Src/m_zminim.F90
  Src/parallelsubs.F
  Docs/siesta.tex

-----------------------------------------------------------------------
2013-10-16  12:30:00 GMT                                     trunk-446
Output file names for dhscf packed in a derived type (JMS)

   The file names passed to dhscf, for output densities and potentials 
on the grid, have been packed into a derived type defined in files.f
   Also, a new density file .RHOXC, with the density passed to cellxc
(i.e. including the nonlocal core corrections), can be written by 
activating SaveRhoXC in the .fdf file.
   As a minor point, file .VNA was being written in every call to
dhscf (provided that SaveNeutralAtomPotential was active). Now it is
written only when dhscf is called by siesta_analysis, as the other
output files.
   
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/dhscf.F
  Src/files.f
  Src/grdsam.F
  Src/local_DOS.F
  Src/setup_hamiltonian.F
  Src/siesta_analysis.F
  Src/siesta_options.F90

-----------------------------------------------------------------------
2013-09-30  10:30:00 GMT                                     trunk-445
New mixing options and simplification of scf loop

* If the option

   MixHamiltonian T

is used, the program will mix the Hamiltonian instead of the density
matrix to achieve self-consistency.

Note that the "dDmax" column in the output will reflect the changes in
H, not in the DM.

The Kohn-Sham energy will converge more uniformly, as it is computed
using a DM_out, instead of a (mixed) DM_in.


* Optionally avoid mixing DM or H after scf-convergence

If the option

   SCF.MixAfterConvergence F

is used, the program will exit the scf loop without a final mixing.
The DM coming out of the cycle will then be DM_out (regardless of
whether we are mixing H or the DM).  The hamiltonian coming out of the
cycle is H_out (generated with DM_out), but H_in ("Hold" in the code)
is also kept if the option is set, so it could be reset if needed in
the future.

Not mixing after convergence will improve the quality of the final
Kohn-Sham energy and forces in calculations that use DM mixing.
The effect should be very small for well-converged calculations.

The DM is saved during the scf cycle for restarting purposes (unless
overridden by the user). If there is no mix after convergence, the
final DM_out is saved.


* A number of options have been added to control the behavior of the
Pulay mixer:

- Pulay mixing might kick in only after a specified number of history
steps have been built up:

    pulay_minimum_history = fdf_get("SCF.PulayMinimumHistory",2)

- Pulay mixing might not work well if far from the fixed point. This
option will avoid inserting the current X_in, X_out pair in the
history stack if the maximum difference is above the specified number.

    max_dmax_for_pulay = fdf_get("SCF.PulayDmaxRegion",1000.0_dp) 

There is no effect by default.

- The "damping" term applied after the DIIS minimization can be
different from that used for linear mixing:

    alpha_pulay = fdf_get("SCF.Pulay.Damping",-1.0_dp) 

By default, alpha_pulay would be set to the linear-mixing parameter.

- The damping of the DIIS-predicted X_in is done to avoid introducing
linear dependencies into the Pulay history stack. Alternatively (or
simultaneously) one can use the most recent X_in, X_out pair in a
linear mixing step, and use a possibly different mixing
parameter. This would be akin to a "kick", but without removing all
the history information.

    linear_mixing_after_pulay = fdf_get("SCF.LinearMixingAfterPulay",.false.)
    alpha_after_pulay = fdf_get("SCF.MixingWeightAfterPulay",0.5_dp)

- Instead of direct matrix inversion, the more robust SVD algorithm can
be used to perform the DIIS extrapolation:

    use_svd_in_pulay = fdf_get("SCF.Pulay.UseSVD",.false.)
    debug_svd_in_pulay = fdf_get("SCF.Pulay.DebugSVD",.true.)
    ! Note that 1.0e-6 seems too conservative
    rcond_svd_pulay = fdf_get("SCF.Pulay.RcondSVD",1.0e-8_dp)


* The loop logic in 'siesta_forces' has been revised to make it more
clear, maintaining the old behavior with the exception of:

- The maximum number of scf iterations is that set by the user,
instead of one less, since the final forces phase is not counted as an
iteration.

- Upon the beginning of a GF TranSiesta run, when mixing H, the
hamiltonian will be recomputed with the proper bias, instead of
inheriting H from the previous normal Siesta initialization. 

(+ The DM is now normalized in 'compute_dm' and 'new_dm')

(+ replaced the "siesta:" prefix by "scf:" in the relevant scf cycle
output)

(+ changed the order of the monitor_forces_in_scf block, so that it is
executed before mixing).


added:
  Src/compute_max_diff.F
  Src/m_svd.F90
  Src/save_density_matrix.F
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/compute_dm.F
  Src/final_H_f_stress.F
  Src/m_pulay.F90
  Src/m_ts_global_vars.f90
  Src/m_ts_options.F90
  Src/mixer.F
  Src/new_dm.F
  Src/normalize_dm.F
  Src/post_scf_work.F
  Src/scfconvergence_test.F
  Src/setup_hamiltonian.F
  Src/siesta_forces.F
  Src/siesta_options.F90
  Src/sparse_matrices.F
  Src/state_init.F
  Src/write_subs.F

-----------------------------------------------------------------------
2013-08-28  10:30:00 GMT                                     trunk-444
Bug fixes to the preconditioner in the OMM modules
(Fabiano Corsetti)

modified:
  Docs/siesta.tex
  Src/m_dminim.F90
  Src/m_zminim.F90

-----------------------------------------------------------------------
2013-07-31  16:05:00 GMT                                     trunk-443
Update to gnubands program
                                                              
(Nick P. Andersen)

Added a fermi shift flag (-F), and energy range flags (-e -E) to
specify in which range one needs the window. This energy range
specification can be used at the same time as the band-index
specification.

Fixed a bug when printing for spin-polarized calculations.

modified.
  Util/Bands/new.gnubands.f90

-----------------------------------------------------------------------
2013-07-31  16:00:00 GMT                                     trunk-442
Synch patch-logs from siesta-3.0 branch up to siesta-3.2 release

Did a "merge" followed by a "revert ." to keep only the patch logs, to
maintain the ability to merge fixes applied initially to the
siesta-3.0 branch.

(no changes)

-----------------------------------------------------------------------
2013-07-05  15:40:00 GMT                                     trunk-441
Cosmetic fixes to please Cray compiler. Arch.make files for PRACE computers

(Fabiano Corsetti)

* Some cosmetic changes for Cray compiler.

* Added some arch.make files for PRACE computers to Src/Sys

added:
  Src/Sys/arch.make.curie
  Src/Sys/arch.make.fermi
  Src/Sys/arch.make.hermit
  Src/Sys/arch.make.juqueen
  Src/Sys/arch.make.marenostrum
  Src/Sys/arch.make.supermuc
modified:
  Src/m_partial_charges.F
  Src/rhoofd.F
  Src/vmat.F

-----------------------------------------------------------------------
2013-07-04  16:00:00 GMT                                     trunk-440
Avoid allocation of auxiliary index arrays in the general case

* Some auxiliary index arrays intended only for O(N) calculations were
  allocated unconditionally. This has been fixed.

modified:
  Src/initparallel.F

-----------------------------------------------------------------------
2013-06-21  11:10:00 GMT                                     trunk-439
Siesta as subroutine using MPI. Vydrov-VanVoorhis vdW functional

(Implemented by Jose Soler)

* Siesta as a subroutine using MPI.

A new version of fsiesta (siesta forces as a subroutine) that uses MPI
to keep different siesta jobs, with their corresponding memory
allocations, separated as different MPI processes. Each siesta job can
itself run in parallel using its own MPI communicator.

See Util/SiestaSubroutine for more information.

* Implementation of Vydrov-VanVoorhis (VV) vdW functional.

Ref: O.A.Vydrov & T.vanVoorhis, JCP 133, 244103 (2010)
Conditions have been added in vdwxc to trap the VV case, calling the 
corresponding routines in vv_vdwxc, where most of the new code is.


* Minor changes:

Array copy in mesh3d expanded in do loops to circunvent an apparent
compiler bug

Incresed length of some character strings that hold file names

Increased parameter minloc in rhoofd and vmat for better efficiency

Two minor bugs corrected in vdwxc.f90

vdw_exchng changed to vdw_localxc in m_vdwxc

The coefficients for interpolation of phi(d1,d2) in the upper boundary
of d1 and d2 have been corrected in vdwxc:bcucof. But since these
boundary values may be never encountered, this correction is probably
irrelevant.  Additionally, a couple of comments have been corrected,
and the reference output of the graphite_vdw_df test has been updated.

A trap has been added in rdiag and cdiag to handle the trivial
eigenvalue problem for matrices of dimension one, which was not
treated correctly by the LAPACK routines.

Consistency of array names in calls to re_alloc and de_alloc

added:
  Src/SiestaXC/Testers/test2.m
  Src/SiestaXC/Testers/test5.f90
  Src/SiestaXC/Testers/test5.m
  Src/SiestaXC/vv_vdwxc.F90
  Src/fsiesta_mpi.F90
  Src/siesta_master.f90
  Util/SiestaSubroutine/SimpleTest/
  Util/SiestaSubroutine/SimpleTest/Src/
  Util/SiestaSubroutine/SimpleTest/Src/Makefile
  Util/SiestaSubroutine/SimpleTest/Src/phonons.f90
  Util/SiestaSubroutine/SimpleTest/Src/simple_mpi_parallel.f90
  Util/SiestaSubroutine/SimpleTest/Src/simple_pipes_parallel.f90
  Util/SiestaSubroutine/SimpleTest/Src/simple_serial.f90
  Util/SiestaSubroutine/SimpleTest/h2o.fdf
  Util/SiestaSubroutine/SimpleTest/h2o.out
  Util/SiestaSubroutine/SimpleTest/test.sh
renamed:
  Src/fsiesta.F90 => Src/fsiesta_pipes.F90
modified:
  Docs/siesta.tex
  Pseudo/atom/pseudoXML.f
  Pseudo/atom/velect.f
  Src/MPI/mpi_siesta.f90
  Src/Makefile
  Src/SiestaXC/Testers/makefile
  Src/SiestaXC/Testers/test2.f90
  Src/SiestaXC/Testers/test3.F90
  Src/SiestaXC/Testers/test4.F90
  Src/SiestaXC/atomxc.F90
  Src/SiestaXC/cellxc.F90
  Src/SiestaXC/lib-00-README
  Src/SiestaXC/lib-makefile
  Src/SiestaXC/makefile
  Src/SiestaXC/mesh3d.F90
  Src/SiestaXC/siestaxc.F90
  Src/SiestaXC/vdwxc.F90
  Src/SiestaXC/xcmod.f90
  Src/atmfuncs.f
  Src/cdiag.F
  Src/fft.F
  Src/m_timer.F90
  Src/moreParallelSubs.F90
  Src/new_dm.F
  Src/pxf.F90
  Src/rdiag.F
  Src/reinit.F
  Src/rhoofd.F
  Src/setspatial.f
  Src/siesta_end.F
  Src/siesta_forces.F
  Src/siesta_init.F
  Src/siesta_move.F
  Src/struct_init.F
  Src/vmat.F
  Tests/Reference/graphite_vdw_df.out
  Tests/graphite_vdw_df/graphite_vdw_df.fdf
  Util/SiestaSubroutine/README
  Util/Vibra/Src/outbands.f
  Util/Vibra/Src/vibrator.f
  version.info
  Src/fsiesta_pipes.F90


-----------------------------------------------------------------------
2013-06-10  14:20:00 GMT                                     trunk-438
Bug fixes in constraints routine

* Make sure that the atomic indices are in the correct range.

* Add code to guarantee the enlargement of an array in the
general case.

(Thanks to Nick P. Andersen)

modified:
  Src/fixed.F

-----------------------------------------------------------------------
2013-06-10  14:10:00 GMT                                     trunk-437
New option for KB projector generation (J. Junquera)

With the option

KB.New.Reference.Orbitals  T

the routine to generate KB projectors will use slightly different
parameters for the construction of the reference orbitals involved
(Rmax=60 bohr both for integration and normalization).

modified:
  Docs/siesta.tex
  Src/atom.F
  Src/atom_options.F90

-----------------------------------------------------------------------
2013-06-05  13:00:00 GMT                                     trunk-436
Charge confinement and filteret basis generation options

Two experimental features related to basis-set generation:

* Charge confinement feature for basis set generation
(Emilio Artacho)

Present soft confinement produces bad polarisation orbitals if the
original atomic orbitals are unbound or very wide (automatic
polarisation still gives too wide orbitals).

A Q/r potential with Yukawa decay can now be added to the atomic and
soft-confinement potentials. Soft-confinement sshould now be used only
for the soft tail cutting with r_in ~ 0.9 r_c.

See the manual for more details.

* New 'filteret' basis-set scheme.  
(Julian Gale)

New options to use the filterets (functions appearing in the filtering
mechanism proposed by Anglada and Soler) as a systematic basis
set. The size of the basis set is controlled by the filter cut-off for
the orbitals.  

See the manual for more details.

(Thanks to Tristana Sondon for help in merging)

added:
  Tests/Reference/chargeconf-h2o.out
  Tests/Reference/h2o_filteret_basis.out
  Tests/chargeconf-h2o/
  Tests/chargeconf-h2o/chargeconf-h2o.fdf
  Tests/chargeconf-h2o/chargeconf-h2o.pseudos
  Tests/chargeconf-h2o/makefile
  Tests/h2o_filteret_basis/
  Tests/h2o_filteret_basis/h2o_filteret_basis.fdf
  Tests/h2o_filteret_basis/h2o_filteret_basis.pseudos
  Tests/h2o_filteret_basis/makefile
modified:
  Docs/siesta.tex
  Src/atm_transfer.f
  Src/atm_types.f
  Src/atmparams.f
  Src/atom.F
  Src/basis_specs.f
  Src/basis_types.f
  Src/initatom.f
  Src/m_filter.f90
  Src/old_atmfuncs.f

-----------------------------------------------------------------------
2013-06-05  12:40:00 GMT                                     trunk-435
Compilation fixes for tbtrans. Cosmetic changes

The old symbol "DAT_double" was still being used in one of the
routines of the new tbtrans program (in Util/TBTrans_rep).  References
related to new timer_tree module were missing in both versions of
tbtrans.

In parallel operation, the "bye" routine now produces output only
in the master node.

In runs which are requested to end after the initial processing of
the structure, XMOL output is produced if requested.

modified:
  Src/siesta_init.F
  Src/sys.F
  Util/TBTrans/Makefile
  Util/TBTrans_rep/Makefile
  Util/TBTrans_rep/m_tbt_iotshs.F90
  Util/TBTrans_rep/m_tbt_read_tshs.F90

-----------------------------------------------------------------------
2013-03-31  19:00:00 GMT                                     trunk-434
Experimental timer with call-tree awareness

A new timer, based on wall time in the master node, and keeping track
of the tree-structure of the timed sections, can be enabled by setting

UseTreeTimer T

in the fdf file.

It works in tandem with the default timer, and it currently produces a
report at the end of the output file in which the parent-child
relationships are represented by simple indentation.

Some new timing calls have been added in the code.

added:
  Src/die.F
  Src/timer_tree.f90
modified:
  Src/Makefile
  Src/SiestaXC/makefile
  Src/fft.F
  Src/m_hsx.F
  Src/m_iodm.F
  Src/m_timer.F90
  Src/m_walltime.f90
  Src/matel.f
  Src/molecularmechanics.F90
  Src/setup_H0.F
  Src/setup_hamiltonian.F
  Src/siesta_forces.F
  Src/siesta_init.F
  Src/timer.F90


-----------------------------------------------------------------------
2013-03-26  12:35:00 GMT                                      trunk-433
Implemented the non-O(N) version of the Ordejon-Mauri functional

(Work by Fabiano Corsetti)

* This re-implementation of Ordejon-Mauri will be referred to as the Orbital
  Minimization Method (OMM); it is now a third available option for the keyword
  SolutionMethod, alongside diagon and OrderN.
* The OMM is not an O(N) functional at present, since no localization is imposed
  on the trial orbitals; in future, it can be extended to include this option
* The functional is contained in two new modules: m_dminim (double
  precision routines) and m_zminim (double complex routines)
* The modules works in serial with LAPACK, or in parallel with MPI and
  ScaLAPACK
* The double precision module (for Gamma point calculations) has the option of
  using sparse matrix-dense matrix multiplications, with custom-coded algorithms
  that interface between SIESTA's native sparse matrix scheme and (Sca)LAPACK's
  dense matrix scheme
* The SIESTA manual has been updated to include a list of all OMM-related
  keywords, with detailed explanations and notes to the user

added:
  Docs/CHANGES.minim
  Src/m_dminim.F90
  Src/m_zminim.F90
  Tests/OMM_h2o/
  Tests/OMM_h2o/Makefile
  Tests/OMM_h2o/OMM_h2o.fdf
  Tests/OMM_h2o/OMM_h2o.pseudos
  Tests/OMM_si/
  Tests/OMM_si/Makefile
  Tests/OMM_si/OMM_si.fdf
  Tests/OMM_si/OMM_si.pseudos
  Tests/Reference-xml/OMM_h2o.xml
  Tests/Reference-xml/OMM_si.xml
  Tests/Reference/OMM_h2o.out
  Tests/Reference/OMM_si.out
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/compute_dm.F
  Src/local_DOS.F
  Src/post_scf_work.F
  Src/projected_DOS.F
  Src/siesta_analysis.F
  Src/siesta_options.F90
  Src/write_subs.F
  Tests/Makefile

-----------------------------------------------------------------------
2013-01-24  14:30:00 GMT                                      trunk-432
Export some MPI symbols explicitly. Remove obsolete symbols

Author: A. Garcia

Some PGI compilers do not consider symbols public by default
when they are inherited through a chain of module 'uses'. This
affected in particular some MPI symbols in the mpi_siesta module.
The symbols are now made 'public' explicitly.

The symbols DAT_single, DAT_double, etc, which were necessary to
deal with machines (old Crays) with different meanings for single
and double precision, have now been removed from the MPI interface
modules. They still appear in some routines as aliases for imports.

modified:
  Src/MPI/mpi.F
  Src/MPI/mpi_siesta.f90
  Src/m_glob_sparse.F90
  Src/m_ts_electrode.F90
  Src/m_ts_gf.F90
  Src/m_ts_in_siesta.F
  Src/m_ts_scattering.F

-----------------------------------------------------------------------
2013-01-21  11:15:00 GMT                                      trunk-431
Fix possible problems in temporary file name

Author: A. Garcia

The name of the temporary file used to dump the contents of the fdf file
could be malformed in certain situations. The algorithm has now been
changed.

(Thanks to Romuald Carpentier)

(+ Remove fossil DEBUG sections)

modified:
  Src/reinit.F

-----------------------------------------------------------------------
2013-01-21  10:45:00 GMT                                      trunk-430
Rationalize fdf logging and debugging

Author: A. Garcia

In runs with many processors, the default logging behavior was affecting
performance. The policy is now as follows.

* Debugging and logging.

By default, all the fdf requests are logged, printing the final value
extracted (if it is the default value, it is identified as such).
In MPI operation, only the master node does the logging, unless the
"output-level" is set to a value >= 2. This can be done directly in
the fdf file:

fdf-output 2  # Turn on logging for all nodes
fdf-output 0  # Turn off logging completely

No debugging is done, unless the "debug-level" is set to a value greater
than zero. The most meaningful way to use this feature is to set the
debugging level before the fdf data structures are built. This can be
achieved by calling the routine fdf_setdebug with the appropriate level
and file name *before* the call to fdf_init.  This gives full control
over the behavior. This is not currently used in Siesta.

Alternatively, if the library is compiled with the pre-processor symbol
FDF_DEBUG defined, it will set the debug level to 2 (exhaustive) for all
nodes in the system. (It will also set the output level to 2 (all nodes)).

If the debugging level (>=2) is only specified in the fdf file itself,
the library will provide a print-out of the final data structure generated
(in all nodes).

fdf-debug 2

(+ Support for FDF_DEBUG in the Makefile)
(+ Cosmetic improvement to the numerical field in the log files)

modified:
  Src/Makefile
  Src/fdf/fdf.F90
  Src/fdf/fdf.Standard
  Src/reinit.F

-----------------------------------------------------------------------
2013-01-18  10:30:00 GMT                                      trunk-429
JobList utility to organize and run multiple jobs 

Author: J. Soler

The JobList directory contains utilities to organize, to run or queue,
and to collect results of multiple siesta jobs. It is particularly
suited for preliminary convergence tests, and it uses only fortran
codes and minimal shell scripts.
  
added:
  Util/JobList/
modified:
  Src/siesta_end.F
  Src/siesta_init.F
  Util/README
-----------------------------------------------------------------------
2012-12-13  17:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-428
Bugfix in spin calculations for TBTrans_rep

(This fixes a problem in the new TBtrans by N.P. Andersen)

* The current and the averaged arrays were not initialized correctly
  for the case of spin:

  - TAv, TEigAv, TDOSAv, PDOSAv, Current
  
modified:
  Util/TBTrans_rep/tbtrans.F90

-----------------------------------------------------------------------
2012-12-10  09:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-427
More fixes and tests for new transiesta/tbtrans_rep code

Several new bug fixes and clarifications have been added to the new
TranSiesta/TBTrans code, as well as more tests. Be sure to see the file
Docs/TranSiestaUpdate.pdf for information about the new features and
behavior changes.

* Added deallocation routine to glob_sparse module
* Added preliminary code for doing calculations in TBtrans without
  inner cell distances (for now this has no importance but provides
  a stepping stone for future development)
* Bugfix for 'forces' run (bcast of coordinates was not performed)
* Wrap mulliken-charges message in MPI runs

* Added new test cases:

  - The voltage test case au_111_capacitor sometimes exhibits problems of 
    accuracy, dependent on compiler and execution options, due to the small
    conductance. More rigorous tests have been added:

    + ts_au_100
    + ts_au_100_repetition
    + ts_au_100_0.25V
    + ts_au_100_repetition_0.25V

    which optionally exercise both the new "repetition" option and the
    applied bias. They are based on an Au-chain in between gold 100 surfaces.
    
  - These tests are quite large and thus take a significant amount of CPU 
    time. They might not be needed if the old tests still perform well and
    the outputs agree with those in the Tests/Reference.

added:
  Tests/Reference/TranSiesta-TBTrans/ts_au_100/
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_0.25V/
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_repetition/
  Tests/Reference/TranSiesta-TBTrans/ts_au_100_repetition_0.25V/
  Tests/TranSiesta-TBTrans/ts_au_100/
  Tests/TranSiesta-TBTrans/ts_au_100_0.25V/
  Tests/TranSiesta-TBTrans/ts_au_100_repetition/
  Tests/TranSiesta-TBTrans/ts_au_100_repetition_0.25V/
modified:
  Docs/TranSiestaUpdate.pdf
  Src/iopipes.F90
  Src/m_glob_sparse.F90
  Src/m_hs_matrix.f90
  Src/m_ts_electrode.F90
  Src/m_ts_gf.F90
  Src/m_ts_in_siesta.F
  Src/mixer.F
  Src/ts_init.F90
  Util/TBTrans_rep/m_tbt_options.F90
  Util/TBTrans_rep/tbtrans.F90


-----------------------------------------------------------------------
2012-11-20  09:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-426
Bug fixes for new transiesta/tbtrans_rep code

Several bug fixes and clarifications have been added to the new
TranSiesta/TBTrans code. Be sure to see the file
Docs/TranSiestaUpdate.pdf for information about the new features and
behavior changes.

* Corrected the DOS calculations with spin factors
* Bugfix for units in AtomPDOS and COOP calculations (TBtrans_rep)
* Renamed FDF-option TS.ReUseGF to TS.TBT.ReUseGF (TBtrans_rep)
* Fixed options not being seen (TS.TBT.CalcIEig)
* Added all output files to the documentation
* Added Header information for all TBtrans_rep data files
* Added dummy routine in m_glob_sparse for non-MPI compilations
* Avoid f2003 features for pointer handling
* Use alloc module in m_hs_matrix
* Handling of FDF-log files corrected in TBtrans_rep (late merge)

modified:
  Docs/TS-npa.CHANGES
  Docs/TranSiestaUpdate.pdf
  Docs/siesta.tex
  Src/Makefile
  Src/m_glob_sparse.F90
  Src/m_hs_matrix.f90
  Src/m_ts_contour.f90
  Src/m_ts_electrode.F90
  Src/m_ts_gf.F90
  Src/ts_init.F90
  Util/TBTrans_rep/atompdos.F90
  Util/TBTrans_rep/coop.F90
  Util/TBTrans_rep/m_tbt_options.F90
  Util/TBTrans_rep/m_tbt_out.f90
  Util/TBTrans_rep/tbt_reinit.F90
  Util/TBTrans_rep/tbtrans.F90

-----------------------------------------------------------------------
2012-11-14  18:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-425
Use scratch fdf log files for non-master nodes

Unless the FDF_DEBUG preprocessor compilation option is in effect,
non-master nodes in MPI operation do not use named log files. Instead,
they use "scratch" files which the operating system opens in
appropriate places.  This will reduce clutter.

(Note that this feature is in general dangerous if the files are
large, as they can inadvertently fill up filesystems or otherwise
create havoc. However, the fdf log files are quite small.)

(Contributed by Nick P. Andersen)

(+ rearranged the statements that update INCFLAGS in the fdf
makefile. This could trap some incorrect settings of this variable in
the top arch.make)

modified:
  Src/fdf/fdf.F90
  Src/fdf/makefile

-----------------------------------------------------------------------
2012-10-31   9:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-424
Bug fixes for array bounds 

There were array bounds problems in:

- The new code to print the initial spin polarization, for the case
  of non-collinear spin.

- The 'transition_rate' routine: ek and ek_local were wrongly
  dimensioned to no_l, instead of no_u.

- The mesh1d file in SiestaXC

(+ removed old debugging code in 'domain_decomposition')

modified:
  Src/domain_decom.F
  Src/new_dm.F
  Src/transition_rate.F
  Src/SiestaXC/mesh1d.f90

-----------------------------------------------------------------------
2012-10-30   9:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-423
Transiesta and TBTrans enhancements by Nick P. Andersen

A number of enhancements to the TranSiesta and TBTrans subsystems have
been added by Nick Papior Andersen, of the Technical Univ. of Denkmark.

A full list of the changes follows. Users are advised to read the file
Docs/TranSiestaUpdate.pdf, as well as the manual, to get a primer on
the new features and things to watch out for and explore in the new
version.

* Added the repetition of the electrode unit cells to limit the Transiesta
  calculation time.
  - Through the options:
    + TS.ReplicateA1Left
    + TS.ReplicateA2Left
    + TS.ReplicateA1Right
    + TS.ReplicateA2Right
  - We take advantage of Bloch's theorem to accomplish this.

* All contour related variables have been assigned a contour type which 
  gathers the information about the energy points. This will provide a cleaner
  interface for those wishing to extend the contour method.

* Changed the contour energy points to be shown in eV, rather than Ry
  - I.e. they can not be compared in the out-file directly

* Simplified the contour distribution so as to not have any parallel arrays

* The surface Green's function files are now created during option reading
  This accomodates two important things:
  1. The GF files are now entirely moved out of the transiesta routine for
     clarity,
  2. Any wrong setup of the system will be caught immediately instead of after
     the diagon run.

* The GF files have been renamed using <systemlabel>.TSGF[L|R]

* Added proper checks of the atomic coordinates when using the electrodes,
  will now exit if not correctly setup. (checks down to 1e-4)

* Added checks of the unit cell setup, so that in transiesta runs the
  unitcell must have a distinct z-direction 

* Added checks of the electrodes to show a warning if the electrodes extend
  into a third neighbouring cell in the transport direction.

* Clarified the fermi level in the electrodes, it was in fact the electrode
  fermi level shift

* Added a lot of systematic output for clarification about the Transiesta
  parsing of the system. It will provide how the systems are setup in buffer
  regions, electrode region and scattering region.

* Informational output regarding the charge re-distribution during the SCF 
  cycles.

* Fully parallelized the Greens function creation.

* Bugfix in the Transiesta package regarding the DM.UseSaveDM T

* Added a general operator which yields the parallelised number of iterations
  of an arbitrary loop (.PARCOUNT.), see parallel.F90

* Memory-optimized several routines in the transiesta package

* GFGammaGF has recieved an overhaul which speeds it up by a factor of two 
  and limits memory substantially!

* Renamed <systemlabel>.CONTOUR to <systemlabel>.TSCC

* Added a ts_init routine for gathering of the required initializations

* Added notices to users about the use of non-optimal energy points in 
  transiesta runs.

* In case of electrodes not matching with the Transiesta setup it will print
  out a high-precision block which can be used for the FDF block.

* Added 'chargecorrection' feature, maybe not exact enough to be used,
  however, it can be used to force the charges to be "correct"

* Changed the Transiesta k-points to be written to file <systemlabel>.TSKP
  instead of overwriting the <systemlabel>.KP

* Cleaned up a lot of code in all transiesta modules. 
  One can still clean up some more code, however, we have made good ground.

* Added a precision for transiesta in precision.F90
  - Currently not used, however, could be the future of limiting Transiesta memory  

* Added -DTRANSIESTA_DEBUG statements to also debug Transiesta

* Added a new TBTrans utility which can be found in Util/TBTtrans_rep
  - Fully parallel across energy points and forward parallel across k-points
  - This is tightly integrated with transiesta
  - Has all the features in Transiesta (parallel GF creation, repetition, etc.)
  - Has reenabled the calculation of Atomic PDOS
    + Needs to be checked
  - Has reenabled the calculation of COOP
    + Needs to be checked
  - Prepared to automatically add flags for user defined formats.
  - The GF files have been renamed using <systemlabel>.TBTGF[L|R]
  - The regions output also shows which atoms are in the PDOS region
  - Added a tbt_kgrid_Monkhorst_Pack block which is only read by TBtrans,
    if it does not exist, it will read kgrid_Monkhorst_Pack instead.

* Bugfix in Tests/script_ts to be able to use bash

* Added a new test:
  - Tests/TranSiesta-TBTrans/ts_au_repetition/
    This will default to use the new TBTrans_rep code.

*** General SIESTA changes:

* Added a new fdf option MinSCFIterations to prevent the second iteration
  jump in MD simulations.

* Increased the width of the output field for dDmax, to improve
  the monitoring of the convergence of the density matrix.

* Added IPO flags for the Makefile to be able to abstract from that.
  Libraries should not be compiled with IPO for obvious reasons.
* Bugfix in the configure command upon checking the NetCDF linking (netcdf
  is now generally a two library linking, which requires "-marks)
* Added 'obsolete' and 'deprecated' keys for the FDF library

* For creating the Hamiltonian at various k-points new modules have been added:
  - m_hs_matrix.f90 
    + Used to generate a square (dense) matrix from the sparse matrix.
      Supplying a k-point will create the equivalent k-point Hamiltonian
    + One can also use this to acquire the transfer matrices
    + Symmetrizing the hamiltonian and trimming it is also enabled.
  - m_glob_sparse.f90
    + Will globalize any arrays which are distributed in SIESTA mpi runs
    + Used in MPIruns in combination with m_hs_matrix.

* Added a makefile for the manual (make siesta, make final, make extra)
* Added hyperref to the manual

* Added note about GCC 4.7.1 not being compatible with the forces type run,
  they have disregarded the piped files in the compiler. Revert to GCC 4.6
  or older.

removed:
  Docs/siesta.ind
  Src/m_ts_contour.F
added:
  Docs/Makefile
  Docs/TS-npa.CHANGES
  Docs/TranSiestaUpdate.pdf
  Src/kpoint_convert.f90
  Src/m_glob_sparse.F90
  Src/m_hs_matrix.f90
  Src/m_ts_cctype.f90
  Src/m_ts_contour.f90
  Src/m_ts_gf.F90
  Src/m_ts_voltage.F90
  Src/ts_init.F90
  Src/ts_show_regions.f90
  Tests/Reference/TranSiesta-TBTrans/ts_au_repetition/
  Tests/Reference/TranSiesta-TBTrans/ts_au_repetition/au_111_capacitor.AVTRANS
  Tests/Reference/TranSiesta-TBTrans/ts_au_repetition/au_111_capacitor.TEIG
  Tests/Reference/TranSiesta-TBTrans/ts_au_repetition/au_111_capacitor.TRANS
  Tests/Reference/TranSiesta-TBTrans/ts_au_repetition/au_111_capacitor.out
  Tests/Reference/TranSiesta-TBTrans/ts_au_repetition/elec_au_111_abc.out
  Tests/Reference/TranSiesta-TBTrans/ts_au_repetition/tbt_au_111_capacitor.out
  Tests/TranSiesta-TBTrans/ts_au_repetition/
  Tests/TranSiesta-TBTrans/ts_au_repetition/Au.psf
  Tests/TranSiesta-TBTrans/ts_au_repetition/au_111_capacitor.fdf
  Tests/TranSiesta-TBTrans/ts_au_repetition/elec_au_111_abc.fdf
  Tests/TranSiesta-TBTrans/ts_au_repetition/makefile
  Tests/TranSiesta-TBTrans/ts_au_repetition/script.sh
  Util/TBTrans_rep/
  Util/TBTrans_rep/Makefile
  Util/TBTrans_rep/atompdos.F90
  Util/TBTrans_rep/coop.F90
  Util/TBTrans_rep/m_lowdin.f90
  Util/TBTrans_rep/m_tbt_iotshs.F90
  Util/TBTrans_rep/m_tbt_kpoints.F90
  Util/TBTrans_rep/m_tbt_options.F90
  Util/TBTrans_rep/m_tbt_out.f90
  Util/TBTrans_rep/m_tbt_read_tshs.F90
  Util/TBTrans_rep/tbt_init.F90
  Util/TBTrans_rep/tbt_reinit.F90
  Util/TBTrans_rep/tbtrans.F90
  Util/TBTrans_rep/transmission.f90
  Util/TBTrans_rep/tt_eig.f90
modified:
  Docs/README
  Docs/siesta.tex
  Src/MPI/Makefile
  Src/Makefile
  Src/compute_dm.F
  Src/configure
  Src/dhscf.F
  Src/diagkp.F
  Src/fdf/fdf.F90
  Src/m_ts_aux_rout.F
  Src/m_ts_electrode.F90
  Src/m_ts_in_siesta.F
  Src/m_ts_io.F90
  Src/m_ts_kpoints.F90
  Src/m_ts_options.F90
  Src/m_ts_scattering.F
  Src/parallel.F
  Src/precision.F
  Src/scfconvergence_test.F
  Src/siesta_forces.F
  Src/siesta_init.F
  Src/siesta_options.F90
  Src/version.F90
  Src/write_subs.F
  Tests/TranSiesta-TBTrans/README
  Tests/script_ts.mk
  Util/SiestaSubroutine/README
  Util/TBTrans/Makefile

-----------------------------------------------------------------------
2012-10-25  10:45:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-422
Fix handling of debugging preprocessor symbol in fdf

The generic DEBUG symbol has been replaced by FDF_DEBUG.  

The declaration of the recently added 'filedebug' local variable has
been moved out of a preprocessor block.

modified:
  Src/fdf/fdf.F90

-----------------------------------------------------------------------
2012-10-24  14:45:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-421
Add rp and rv options to XML pseudopotential handling

The RPBE and revPBE XC flavors were not correctly handled by
the XML routines.

modified:
  Pseudo/atom/pseudoXML.f
  Util/pseudo-xml/xml2psf_helper.f

-----------------------------------------------------------------------
2012-10-24  13:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-420
Enable MD continuation runs even if the restart file is not available

(Fabiano Corsetti)

If the user has selected MD.UseSaveXV to continue an MD run from a
previously computed set of positions and velocities (in the XV file),
but the appropriate restart file is not found, the positions x(t) and
velocities v(t-dt) are read from the XV file, and the positions are
then backward-propagated by one time step using the Euler method to
start the MD run from time (t-dt) with a consistent set of positions
and velocities.

In previous versions the program complained if the appropriate restart
file was not available. This patch enables cross-restarts (i.e., an
Annealing calculation followed by a Nose simulation) within the simple
"reuse-the-XV-file" framework. The last point computed in the previous
simulation will be basically repeated in the continuation run. For
"seamless" continuations, the flavor-specific restart file is needed.

N.B.: The value of the time step of the previous run (from which the
XV file has been generated) should be equal to that of the current
run. This information is not saved in the XV file, and so it is not
possible for the code to tell whether the two runs are consistent.

N.B. 2: The backward-propagation is only used for runs with more than
one time step, and is done in routine 'struct_init'.

This fix applies to Verlet, Nose, PR, and NPR runs.

* New tests:  

   md-single-run, md-cont, md-cont-no-restart-file

   md-anneal-cont

(+ used correct fdf option for annealing flavor in md_anneal test)

added:
  Tests/md-anneal-cont/
  Tests/md-anneal-cont/README
  Tests/md-anneal-cont/makefile
  Tests/md-anneal-cont/script.sh
  Tests/md-cont/
  Tests/md-cont-no-restart-file/
  Tests/md-cont-no-restart-file/README
  Tests/md-cont-no-restart-file/makefile
  Tests/md-cont-no-restart-file/script.sh
  Tests/md-cont/README
  Tests/md-cont/makefile
  Tests/md-cont/script.sh
  Tests/md-single-run/
  Tests/md-single-run/README
  Tests/md-single-run/makefile
  Tests/md-single-run/script.sh
modified:
  Docs/siesta.ind
  Docs/siesta.tex
  Src/Makefile
  Src/dynamics.f
  Src/iomd.f
  Src/struct_init.F
  Tests/md_anneal/md_anneal.fdf

-----------------------------------------------------------------------
2012-10-24  13:30:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-419
Add option to turn off time-reversal symmetry for k-points

If the fdf option TimeReversalSymmetryForKpoints is set to "false",
the program will keep all the k-points in the BZ, without using the (k,-k)
implicit symmetry which is valid in the absence of external magnetic
fields or spin-orbit coupling. This feature is added for completeness and
test purposes.

In spin-polarized calculations, the code now prints a summary of the
initial spin polarization when the density-matrix is initialized.

modified:
  Docs/siesta.tex
  Src/Makefile
  Src/find_kgrid.F
  Src/kpoint_grid.F90
  Src/kpoint_pdos.F90
  Src/new_dm.F

-----------------------------------------------------------------------
2012-10-24  13:20:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-418
Use actual number of electrons in optical calculations

The 'optical' routine now uses the actual number of electrons (rather
than the nominal number of valence electrons) for non-spin-polarized
calculations. This affects only systems with a net charge. Note that
spin-polarized calculations were already using the actual number
of electrons.

(Thanks to Alexander Vozny)

modified:
  Src/Makefile
  Src/optical.F

-----------------------------------------------------------------------
2012-10-23  14:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-417
Allow doping feature for all systems

The "SimulateDoping" option is now enabled for "bulk" systems, in the
interest of generality and to fix an inconsistency in the logic for
charge removal. (Thanks to N. P. Andersen)

modified:
  Src/dhscf.F

-----------------------------------------------------------------------
2012-10-23  14:05:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-416
Fix spin loop in initialization in Eig2DOS program

The initialization code was missing a loop over spin.

(+ changes to fix compiler-dependent complaints)

(Thanks to N.P. Andersen)

( + Update reference outputs for si_fatbands test )


modified:
  Tests/Reference-xml/si_fatbands.xml
  Tests/Reference/si_fatbands.out
  Util/Eig2DOS/Eig2DOS.f90

-----------------------------------------------------------------------
2012-10-23  14:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-415
New options for wavefunction output. 'Fatbands' analysis. Mprop enhancements

(A. Garcia)

* Enhanced 'bands' routine to write out the wavefunctions

If the fdf symbol

WFS.Write.For.Bands

is set to .true., the program will write out the wavefunctions
corresponding to the bands specified in the BandLines block.

There are now different file names for wavefunction output:

SystemLabel.bands.WFSX      : produced by BandLines + WFS.Write.For.Bands
SystemLabel.fullBZ.WFSX     : for COOP/COHP-related use
SystemLabel.selected.WFSX   : produced by WaveFuncKPoints

Note that for down-stream processing, some of these files might have
to be renamed to simply 'SystemLabel.WFSX'.

A subset of the bands (for both the BandLines and COOP/COHP cases) can
be specified by the fdf keywords:

WFS.Band.Min  (int, default: 1)
WFS.Band.Max  (int, default: number of orbitals)

The energy window options 

WFS.Energy.Min
WFS.Energy.Max

are not in effect for BandLines.


* New 'Fatbands' functionality

A new utility program ('fat') has been added to generate 'fatband'
information. It processes .WFSX files (typically produced during a
"bands" calculation) and .HSX files to produce 'EIGFAT' files
containing both the eigenvalues ("eig") and the value of the
projection of the wavefunction on a given orbital set ("fat"). Most of
the code is shared with the PDOS/COOP/COHP program mprop, hence its
location in the Util/COOP directory.

A new plotting converter, eigfat2plot, has been placed in the
Util/Bands directory. It is suitable for simple 'gnuplot' use.

Added Tests/si_fatbands


* Modified Denchar to read WFSX files

Denchar now reads directly the newer-format WFSX files,
which are more compact.

Also, added a new full example in Util/Denchar/Examples, and
two python scripts for contour plots, courtesy of Pablo Aguado.

* Moved gnubands.f program to new directory Util/Bands
* Added new 'gnubands' program, with more options (Util/Bands/new.gnubands)

* Mprop enhancements

- New energy-range and band-index options in mprop.

* Upgrade of the Util/COOP/mprop program, with new options and
  clarification of existing ones:

- Allow specification of subsets of bands in Util/COOP/mprop

New options "-b min_band -B max_band" to allow the use of restricted
band sets in the generation of PDOS, COOP, and COHP curves.

- Clearer energy-range options in mprop program

The -m/-M options now refer to eigenvalues.  Together with the band
options (-b/-B), they determine the eigenvectors actually taken into
account.

- Add plotting window options to mprop. Cosmetics

The plotting window can now be specified with the -w/-W options. By
default it is determined on the basis of the eigenvalue range.

(+ add missing declaration to dm_creator.f90)

added:
  Tests/Reference-xml/si_fatbands.xml
  Tests/Reference/si_fatbands.out
  Tests/si_fatbands/
  Tests/si_fatbands/makefile
  Tests/si_fatbands/si_fatbands.fdf
  Tests/si_fatbands/si_fatbands.pseudos
  Util/Bands/
  Util/Bands/Makefile
  Util/Bands/README
  Util/Bands/eigfat2plot.f90
  Util/Bands/f2kcli.F90
  Util/Bands/fat.gplot
  Util/Bands/m_getopts.f90
  Util/Bands/new.gnubands.f90
  Util/COOP/Tests/si_fatbands/
  Util/COOP/Tests/si_fatbands/README
  Util/COOP/Tests/si_fatbands/fatbands.mpr
  Util/COOP/fat.f90
  Util/Denchar/Examples/2dplot.py
  Util/Denchar/Examples/FullExample.fdf
  Util/Denchar/Examples/Si.psf
  Util/Denchar/Examples/surf.py
  Util/Denchar/Src/readwavesx.f
renamed:
  Util/gnubands.f => Util/Bands/gnubands.f
modified:
  Docs/siesta.ind
  Docs/siesta.tex
  Src/Makefile
  Src/bands.F
  Src/diagk.F
  Src/siesta_analysis.F
  Src/writewave.F
  Util/COOP/Makefile
  Util/COOP/README
  Util/COOP/Tests/README
  Util/COOP/dm_creator.F90
  Util/COOP/main_vars.f90
  Util/COOP/mprop.f90
  Util/COOP/subs.f90
  Util/Denchar/Docs/CHANGES
  Util/Denchar/Docs/denchar.tex
  Util/Denchar/Src/Makefile
  Util/Denchar/Src/denchar.f
  Util/Eig2DOS/Eig2DOS.f90
  Util/README

-----------------------------------------------------------------------
2012-10-23  13:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-414
Hirshfeld and Voronoi charges. Bader analysis output

The Hirshfeld and Voronoi methods are partial-charge estimations based
directly on the charge density. They thus complement the Mulliken analysis
which depends on the density-matrix.

Relevant fdf keywords:

WriteHirshfeldPop T
WriteVoronoiPop T

See the manual for details.

(Code for Hirshfeld and Voronoi analysis contributed by P. Ordejon.
Integrated into the dhscf workflow by A. Garcia.)

* Implementation of Bader charge output

If the option

  SaveBaderCharge T

is used, the program will write the electronic charge density with an
extra set of model core charges, useful for post-processing by a Bader
"atoms in molecules" analysis. See the manual for important details.

The grid2cube program in Util has been extended to deal with the .BADER
file.

* New test: h2o-pop

-----------------------------------------------------------------------
2012-09-25  10:12:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-413
Use a 'unique' string in fdf log files

In MPI operation, the fdf subsystem writes log files (and optionally
debug files) to the /tmp filesystem. Up to now the file names were not
unique across jobs, which led to failures. Now a string based on the
5 least significant digits of the current time is added to the file
prefix. 

Also, removed the printing of a log message regarding the number of
lines processed while setting up the fdf data structures, which could
potentially confuse some systems.

modified:
  Src/reinit.F
  Src/fdf/fdf.F90

-----------------------------------------------------------------------
2012-08-27  10:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-412
Nullify pointers in diagkp

Pointers were not properly nullified in diagkp.

(Thanks to Nick P. Andersen)

(+ clean up extra path dependencies in Denchar Makefile)

modified:
  Src/diagkp.F

-----------------------------------------------------------------------
2012-06-21  10:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-411
Fix bug in fdf_bbackspace. No .ion.nc files for ghosts

A bug in fdf_bbackspace made it take two steps back when at the end of
an fdf block. This has now been fixed, removing also the superfluous
'pline' argument.

When dealing with ghost atoms, the .ion.nc files containing ionic
information in netCDF format cannot yet be read back properly. Their
generation has been deactivated for now. Users can still use the
standard .ion files in ASCII format with the option 'UserBasis T'.

modified:
  Docs/siesta.tex
  Src/basis_io.F
  Src/basis_specs.f
  Src/fdf/fdf.F90

-----------------------------------------------------------------------
2012-06-15  15:09:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-410
Improved the estimation of the size of the automatic cell

If not specified, Siesta generates automatically a unit cell for
"molecular" or "atomic" systems. The criterion is that the cell is big
enough to avoid interactions between orbitals in two different cells.

Up to now, the estimation of the size of the orbitals was given by
the cutoff of Vna. But if the basis set contains large orbitals which
are not occupied in the ground state, this estimate is too short.

The "size of the atom" is now estimated as the largest of rc(Vna) and
the cutoffs of all the orbitals. 

modified:
  Src/Makefile
  Src/automatic_cell.f

-----------------------------------------------------------------------
2012-04-13  15:05:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-409
Extended the functionality of the 'eig2dos' program

A new directory Util/Eig2DOS holds an updated version of the
venerable 'eig2dos' program, with a new command-line interface
that allows to specify all the parameters and new capabilities:

-- Optional use of the k-point weight information in a .KP file.
-- Selection of a range of bands for the calculation of the DOS.

Invoke the program as  'Eig2DOS -h' for a synopsis.

(A. Garcia)

added:
  Util/Eig2DOS/
  Util/Eig2DOS/Eig2DOS.f90
  Util/Eig2DOS/Makefile
  Util/Eig2DOS/m_getopts.f90
renamed:
  Util/eig2dos.f => Util/Eig2DOS/original.eig2dos.f
modified:
  Docs/siesta.ind
  Docs/siesta.tex
  Util/README

-----------------------------------------------------------------------
2012-04-04  10:40:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-408
Close netCDF file descriptors for DM and DMHS files

The descriptors for the DM.nc and DMHS.nc netCDF files are kept open
during the SCF cycle, but should be closed at the end of it to avoid
resource exhaustion in, say, MD runs. This was not done due to a
programming error.  They are now closed at the beginning of the next
SCF cycle.

(Thanks to Nick Papior Andersen)

modified:
  Src/iodm_netcdf.F90
  Src/iodmhs_netcdf.F90

-----------------------------------------------------------------------
2012-03-09  15:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-407
Extend DM normalization diagnostics

In order to conserve the number of electrons N, the density matrix
(DM) has to be normalized: Tr[S*DM]=N, where S is the overlap matrix.

The DM might not be normalized because it has been re-used (and
re-arranged) from a previous geometry step, or because of some error
in its computation during the scf cycle.  The two cases are now
reported differently:

In the first scf step, the fractional tolerance is 0.001 (tighter than
the previous default of 0.01), and a "Note" is printed.

In subsequent steps, the fractional tolerance can be specified
by means of the fdf symbol

DM.Normalization.Tolerance  Tol

and is 1.0e-5 by default.  The program now aborts if this threshold is
breached.

NOTE: The DM might not be normalized upon entry to the (first
geometry) scf loop because of a possible "folding" of the overlap
matrix in gamma-point calculations with small unit cells: the overlaps
of a given unit-cell orbital with multiple images are accumulated
instead of being kept separate. Then, the trace Tr[S*DM_atomic] will
not give the number of electrons.
The folding (which is reported if detected by the program) is done for
efficiency reasons, but might cause problems for further analysis
(i.e., Mulliken charges, or COOP/COHP calculations).

modified:
  Src/Makefile
  Src/normalize_dm.F
  Src/setup_hamiltonian.F
  Src/siesta_options.F90

-----------------------------------------------------------------------
2012-03-08  16:55:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-406
Fix reading of position constraints in block

In %block GeometryConstraints, the simple option

  position  i  j  k  l ...

to list atoms to be kept fixed, was not implemented correctly.

(Thanks to J. Junquera for the bug report and fix)

modified:
  Src/fixed.F

-----------------------------------------------------------------------
2012-03-08  10:40:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-405
Change position of force-monitoring block

The optional calculation of forces inside the scf loop is now done
after printing the current energies. Otherwise the output for etot
would correspond to that for the following iteration, and EHarris
would be wrong.

modified:
  Src/siesta_forces.F

-----------------------------------------------------------------------
2012-03-07  14:25:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-404
Add force convergence diagnostic

When the option to monitor the forces during the SCF cycle is in effect, the
program will print the maximum absolute value of the change in forces from one
step to the next. Other statistics could be implemented.

modified:
  Src/siesta_forces.F

-----------------------------------------------------------------------
2012-03-06  15:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-403
Allow monitoring of forces during SCF cycle

Using the fdf symbol

MonitorForcesInSCF T

the program will compute the forces and stresses at every scf step. 
Use in combination with WriteForces.

modified:
  Src/Makefile
  Src/siesta_forces.F
  Src/siesta_options.F90

-----------------------------------------------------------------------
2012-02-23  9:40:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-402
Update of Andrei Postnikov's utilities to V0.4

Added also the fmpdos program, an alternative to pdosxml.

added:
  Util/Contrib/APostnikov/00README
  Util/Contrib/APostnikov/fmpdos.f
  Util/Contrib/APostnikov/test_mdc.f
modified:
  Util/Contrib/APostnikov/Makefile
  Util/Contrib/APostnikov/README
  Util/Contrib/APostnikov/eig2bxsf.f
  Util/Contrib/APostnikov/md2axsf.f
  Util/Contrib/APostnikov/rho2xsf.f
  Util/Contrib/APostnikov/vib2xsf.f
  Util/Contrib/APostnikov/wraxsf1.f
  Util/Contrib/APostnikov/wraxsf2.f

-----------------------------------------------------------------------
2012-02-22  13:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-401
Assorted cosmetic and compilation fixes

* Include missing LDFLAGS symbol in some Util makefiles

modified:
  Util/COOP/Makefile
  Util/Contrib/APostnikov/Makefile
  Util/test-xml/makefile

* Obsolete debug information was still being written to unit 23 in
  domain_decom, including a call to "flush".
  
modified:
  Src/domain_decom.F

* Fix makefile symbols in Util/STM/ol-stm
  The new domain_decomposition symbols and dependencies were missing.

modified:
  Util/STM/ol-stm/Src/Makefile

* Updated bug reporting guidelines

added:
  Docs/REPORTING_BUGS
modified:
  Docs/siesta.tex
  README

* Do not count ghost atoms when printing ionic charge

This was purely cosmetic, but misleading: the variable
zvaltot now records only the sum of (pseudo)protons in
non-ghost species.

(+ cosmetic fix in the printing of lmxkb for ghosts
species in .ion files)

modified:
  Src/atomlist.f
  Src/basis_types.f

* Fix the script in Tests/partial
  Now it can automatically compile the 'fractional' program

modified:
  Tests/partial/script.sh

* Add Util/clean_all.sh script
* Remove scratch fdf directories in Util/GenBasis and Util/Vibra

removed:
  Util/Gen-basis/fdf/
  Util/Vibra/Src/fdf/
added:
  Util/clean_all.sh



-----------------------------------------------------------------------
2012-02-21  17:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-400
Assorted bugfixes and cosmetics

Bugfixes for recent features:

* Include support for domain_decom in Denchar makefile

Cosmetic changes:

 - State that the units for mprop distances are Ang
 - Clarify error message in ts_iohs regarding nspin
 - Write eigenvalues in eV in CML file (ioeig)
 - Use $(AR) instead of 'ar' in all makefiles
 - Specify Ry units for H in DMHS netcdf files
 - Fix call to 'memory' in Denchar/stsofr.f

modified:
  Src/Libs/makefile
  Src/MPI/Makefile
  Src/Sys/DOCUMENTED-TEMPLATE.make
  Src/iodmhs_netcdf.F90
  Src/ioeig.f
  Src/m_ts_io.F90
  Src/wxml/makefile
  Src/xmlparser/makefile
  Util/COOP/subs.f90
  Util/Denchar/Src/Makefile
  Util/Denchar/Src/stsofr.f

-----------------------------------------------------------------------
2012-02-21  17:05:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-399
Some cleanup and new options for O(N) solver code

The O(N) solver code is being cleaned up, and more options are being
added, but should still be used with care and for systems for which
it is appropriate.

* More documentation and better variable names and structure in some
  files.

* Stop if O(N) chemical potential calculation is requested in parallel
  
  The code in chempot is not correctly parallelized yet.  Now the
  program stops at the beginning of the run if any of the relevant fdf
  options is enabled.
  
* Implement graph-based domain decomposition for O(N) routines
  
  Based on code by Rogeli Grima (BSC).
  
  It is enabled by defining
  
  UseDomainDecomposition T
  
  in the fdf file. NOTE that if you use NetCDF you also need:
  
  WriteDMNetcdf F
  WriteDMHS-netcdf F
  
  until a non-local call to LocalToGlobalOrb is fixed.
  
  The METIS library (www.cs.umn.edu/~metis) is also needed. Calls to
  this library are wrapped in preprocessor blocks controlled by the
  symbol
  
  ON_DOMAIN_DECOMP
  
  which needs to be specified at (parallel) compile time if domain
  decomposition is desired.

  Now, by default, Julian's Gale spatial decomposition code is
  bypassed, unless the fdf variable

        UseSpatialDecomposition 

  is set.  The default is now to use block-cyclic decomposition, but
  any serious calculation should use one of the two more sophisticated
  approaches. A further refinement is in the pipeline.

* Add the Util/ON directory with lwf2cdf program

  This utility program converts the information in the LWF file 
  to netCDF format.

(A. Garcia, May-July 2011, Feb 2012)
(Backported from 3.1)

-----------------------------------------------------------------------
2012-02-21  14:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-398
Avoid broadcast after fdf operation in m_ts_options

With the new fdf interface all nodes get the appropriate values
without a broadcast. There was a fossil mpi_bcast in m_ts_options.

modified:
  Src/m_ts_options.F90

-----------------------------------------------------------------------
2012-02-20  16:45:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-397
More documentation for tests. New .make file.

* Added a new README file for the Tests directory and for the
  new-style Transiesta-TBTrans tests

* Add arch.make file for Marenostrum IBM supercomputer using ESSL
    
  Added the necessary LAPACK libraries in order to compile using ESSL on IBM.
  ESSL are a set of system-optimized BLAS functions and subroutines.
    
  Use the following lines in your arch.make:
    COMP_LIBS = essl_lapack.a
    LIBS      = -lessl
  
  The new file Src/Sys/marenostrum-mpi-essl-netcdf-64.make is appropriate
  for 64 bit operation.
    
  (Thanks to Oscar Paz)
  
  added:
    Src/Sys/marenostrum-mpi-essl-netcdf-64.make
    Src/Libs/essl_lapack.f
  modified:
    Src/Libs/makefile
    Src/Makefile

* Make sure 'partial' is compiled in test
  
  The 'partial' test is not completely set up for transparent operation,
  and the needed executable in Util/VCA needs to be pre-compiled.
  
  The script stops with a message if this is not done (note that this
  test is not executed by default from the top Makefile).
  
  modified:
    Tests/partial/script.sh

-----------------------------------------------------------------------
2012-02-20  16:30:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-396
Fixes: pointer initialization, logical assignment

In cgvc_zmatrix, two scratch pointers were not properly initialized
before use.

In nlefsm, two logical arrays were initialized with '0', instead of
'.false.' (Thanks to Carlos Sanz for pointing this out).

modified:
  Src/cgvc_zmatrix.F
  Src/nlefsm.f

-----------------------------------------------------------------------
2012-02-20  15:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-395
Avoid broadcast after fdf operation in tbtrans

With the new fdf interface all nodes get the appropriate values
without a broadcast. Tbtrans (in routine reinit_tb) still called
mpi_bcast. This led to errors in some systems.

modified:
  Util/TBTrans/reinit_tb.F

-----------------------------------------------------------------------
2012-02-20  13:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-394
Update TranSiesta tests. Cosmetics

*  Update the TranSiesta-TBTrans test directories
  
  TranSiesta-TBTrans specific tests now reside in
  Tests/TranSiesta-TBTrans. These tests (currently ts_fast and ts_au)
  only make sense if the "transiesta" flavor of Siesta has been compiled
  in (by executing "make transiesta" in a fresh build directory), so
  they are not executed by default.
  
  Reference outputs can now be found in
  Tests/Reference/TranSiesta-TBTrans.  Note that these reference
  outputs have not yet been updated: they correspond to siesta-3.1.
  
  The manual has been updated to refer to the Examples/TranSiesta
  directory (which has been created) for the guided calculation.
  
  removed:
    Tests/transiesta/Fast/
    Tests/transiesta/au_111_capacitor/
    Tests/transiesta/bulk_au_111/
    Tests/transiesta/elec_au_111_abc/
  added:
    Tests/Reference/TranSiesta-TBTrans/
    Tests/Reference/TranSiesta-TBTrans/ts_au/
    Tests/Reference/TranSiesta-TBTrans/ts_fast/
    Tests/TranSiesta-TBTrans/ts_au/
    Examples/TranSiesta
  renamed:
    Tests/transiesta/ => Tests/TranSiesta-TBTrans/
    Tests/ts_fast/ => Tests/TranSiesta-TBTrans/ts_fast/
  modified:
    Tests/TranSiesta-TBTrans/ts_fast/makefile
    Tests/TranSiesta-TBTrans/ts_fast/script.sh
    Tests/Makefile
    Tests/script_ts.mk
    Docs/siesta.tex

*  Removed call to BLAS routine zdotc in tbtrans. Replaced it
   by an explicit loop.

*  Clarify the mention of "hybrid" functionals in the manual
  
  modified:
    Docs/siesta.tex

*  Remove order-N test from standard list. Add note.

  As it does not run well in parallel, the order-N
  test has been removed from the standard list
  in the Makefile for the Tests directory.
  
  added:
    Tests/h2o_orderN/000README
  modified:
    Tests/Makefile

-----------------------------------------------------------------------
2012-02-16  15:25:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-393
Fix pointer initialization in moremeshsubs

Two workspace pointers were not properly nullified before allocation.

Thanks to Olivier Coulaud for the report and the fix.

modified:
  Src/moremeshsubs.F

-----------------------------------------------------------------------
2012-02-16  10:35:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-392
Proper closing of files in m_iorho

Due to a programming error, the calls to io_close in read_rho and
check_rho were incorrectly placed.

Thanks to Carlos Sanz for the report and the fix.

modified:
  Src/m_iorho.F

-----------------------------------------------------------------------
2012-02-15  18:05:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-391
Clarify flow of data in setup_H0

The routine setup_H0 pre-computes the matrix elements of the kinetic
and non-local pseudopotential pieces of the Hamiltonian, which do not
depend on the density matrix.

Routines kinefsm and nlfesm also compute Ekin and Enl, respectively,
but since they are not called anymore in the SCF cycles, Ekin and Enl
are not updated, and are only printed at the first and last
iterations.

In order to make this more explicit, H0 has been substituted by two
arrays, H_kin and H_vkb, to hold the pieces of H. Ekin and Enl are now
computed in setup_hamiltonian, with the appropriate density matrix.  A
minor cosmetic issue now is that, in setup_H0, the routines 'kinefsm'
and 'nlefsm' must be called with a value of 1 for nspin, as befits the
structure of H_kin and H_vkb. The density matrix array is not
referenced.

Other changes:

* The variable 'nh' has been substituted by its equivalent maxnh
throughout the code.

* The use of H0 as a work array in calls to the ksv_pol routine has
been made clearer by importing H_kin and renaming it 'Work'.

modified:
  Docs/KNOWN.ISSUES.BSC-patch
  Src/Makefile
  Src/born_charge.F
  Src/compute_dm.F
  Src/final_H_f_stress.F
  Src/hsparse.F
  Src/kinefsm.f
  Src/nlefsm.f
  Src/normalize_dm.F
  Src/post_scf_work.F
  Src/setup_H0.F
  Src/setup_hamiltonian.F
  Src/siesta_analysis.F
  Src/siesta_init.F
  Src/sparse_matrices.F
  Src/state_init.F

-----------------------------------------------------------------------
2011-10-28  10:45:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-390
Avoid temporary arrays in SiestaXC/mesh3d

Calls with a re-shaped array as argument, and with
array-section arguments, were inducing some compilers
to create temporary arrays.

modified:
  Src/SiestaXC/mesh3d.F90

-----------------------------------------------------------------------
2011-10-28  10:35:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-389
Re-instate reading of charge netcdf files

This feature had been turned off after the BSC merge pending
clarification.

modified:
  Src/dhscf.F

-----------------------------------------------------------------------
2011-10-28  10:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-388
Grid file utilities. User-specified mesh sizes

Two new programs are available to generate grid files
(density, potential):

-- grid_rotate: cyclically rotates the coordinates of
                a grid file.
-- grid_supercell: generates the grid file appropriate
                   for a supercell.

The user can now specify the mesh sizes to be used
by the program, by inserting a block definition in 
the fdf file:

%block Mesh-sizes
  40 56 120
%endblock Mesh-sizes

This feature is useful when coupled to the above utilities,
since the "magic" fft numbers might not be appropriate.

added:
  Docs/Grid.CHANGES
  Util/Grid/grid_rotate.F90
  Util/Grid/grid_supercell.F90
modified:
  Src/Makefile
  Src/meshsubs.F
  Util/Grid/makefile

-----------------------------------------------------------------------
2011-09-16  09:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-387
Fix bug in BandLines processing

The processing of the BandLines block was faulty, resulting
in most cases in the skipping of the 'bands' calculation.

modified:
  Src/bands.F

-----------------------------------------------------------------------
2011-09-12  09:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-386
Fix fdf_defined to take blocks into account

The new version of fdf_defined was only checking
for the existence of single labels. It has been
fixed to check for blocks too.

modified:
  Src/fdf/fdf.F90
  Src/fdf/sample.F90

-----------------------------------------------------------------------
2011-08-30  09:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-385
Fix two minor bugs in Denchar

Some compilers had trouble with a block pointer. It has
been made into a normal variable.

An attempt was made to close an I/O unit that had not
ben opened in the spin-unpolarized case.

(Thanks to T. Sondon)

modified:
  Util/Denchar/Src/atompla.f
  Util/Denchar/Src/rhoofr.f

-----------------------------------------------------------------------
2011-08-26  12:40:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-384
Print information about grid distributions

New code has been added to show information about
the different grid data distributions.

modified:
  Src/moremeshsubs.F

-----------------------------------------------------------------------
2011-05-19  15:20:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-383
Fix and clarify code for KB projector orthogonalization

In routine kbproj, a saved variable was used to keep track
of the number of previous KB projectors with the same l. This
variable was only reset upon a change in l. This can lead
to errors if a species with a single l=0 KB complex is used.

The code has been streamlined, passing explicitly an index
that determines the sequence number of the projector.

modified:
  Src/atom.f

-----------------------------------------------------------------------
2011-05-03  16:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-382
Fix declaration in cgwf.F

A previous commit introduced a spurious dummy argument
"node", which should really be imported from a module.

modified:
  Src/cgwf.F

-----------------------------------------------------------------------
2011-05-03  14:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-381
Clarify mixing code in TranSiesta mode

If the TranSiesta code is compiled in, the user can choose between two
mixing options in the self-consistent cycle: density-matrix, or
Hamiltonian. The option chosen takes effect both for the initial
normal Siesta-style calculation, if needed, and for the "transiesta
mode" section.

The code in mixer.F and elsewhere has been streamlined, to make it
clear what the mixed objects are and avoid extraneous global
dependencies.

modified:
  Src/Makefile
  Src/m_ts_global_vars.f90
  Src/mixer.F
  Src/new_dm.F
  Src/state_init.F

-----------------------------------------------------------------------
2011-05-03  14:05:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-380
Make auxiliary variable double precision in line minimization

In routine linmin4, the complex variable "c" was declared
as single-precision. It is now a double.

modified:
  Src/cgwf.F

-----------------------------------------------------------------------
2011-05-03  13:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-379
Fix mixing bug in Transiesta + tbtrans wrap + pulayx warnings

* Fix mixing bug in TranSiesta

In TranSiesta mode, the program first might carry out a calculation at
zero bias and with periodic boundary conditions, just as a normal
Siesta calculation. Then the program goes into "transiesta mode"
proper, during which a new mixing cycle takes place.

In late June 2010, a change in the structure of the mixing code
introduced a bug: the counter holding the number of history records
was not properly initialized upon the ending of the preliminary
siesta-style calculation.

The mixing counter is now properly reset.

modified:
  Src/scfconvergence_test.F

* In tbtrans some auxiliary files were written to by all the nodes.

(+ Also, make sure that the transiesta capability appears at
the top of the transiesta output file)

modified:
  Src/Makefile
  Util/TBTrans/tbtrans.F

* Avoid reporting unstable inversion in pulayx

Typically, inversion problems in the DIIS procedure occur when the
error estimate for a step is very small compared to the previous
ones. This is harmless, and the reporting of a failure in the output
file is confusing.

In case it is needed, a hook to allow a full diagnosis 
can be compiled in with the preprocessor flag

DEBUG_PULAY_INVERSE

(+ Also, initialize "found" variable in new_dm.F in transiesta mode)

modified:
  Src/m_pulay.F90
  Src/new_dm.F

* Increase field sizes in OCCS file

Some fields overflowed when a large number of k-points was used.

modified:
  Src/diagk.F
  Src/diagk_file.F

-----------------------------------------------------------------------
2011-05-03  12:45:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-378
Fix manual re: non-collinear GGA and zmatrix input. FoX cosmetics

* The manual incorrectly stated that GGA was not compatible with
non-collinear-spin calculations.

The order of the spherical coordinates for the second atom in the
zmatrix format input is now explicitly stated.

modified:
  Docs/siesta.tex

* Cosmetic changes to avoid xlf compiler diagnostics in dummy FoX

If the "trap undefined variables" option is enabled in the xlf
compiler, some stray symbols in the dummy version of the FoX library
produce diagnostics. They have been re-wrapped.

(Thanks to Oscar Paz)

modified:
  Src/FoX/common/m_common_attrs.F90
  Src/FoX/utils/fox_m_utils_uri.F90

-----------------------------------------------------------------------
2011-04-14  09:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-377
Avoid the creation of temporary and log files for fdf in parallel

The standard mode of operation of the new fdf library is "cluster", in
which the root node reads and processes the fdf file(s) and sends
relevant information to the rest of the nodes. At the end of the setup
process every node has a private copy of a pre-parsed fdf structure
that can be consulted quickly.

In the first version by Raul de la Cruz the root node sent raw text
information to the other nodes, and these used a temporary scratch
file to dump it to. Later these nodes invoked the digesting routine on
the scratch file to create the memory structure.

Now the root node serializes its own memory structure and sends it
over to the other nodes. These just need to de-serialize the
information and re-create the memory structure.

Log files were also produced by all nodes by default. Now non-root
nodes create the log files under "/tmp", with names of the form
"tmp/fdf.log.N", where N is a representation of the MPI rank. Only
the root node creates a "fdf.log" file in the working directory.
This is useful for cluster settings in which non-root nodes might not
be able to write efficiently to common areas.

Any debug files are created in the same way, with names of the form
"tmp/fdf.debug.N". At the end of the run they will contain a dump
of the fdf memory structure.

Alberto Garcia, April 2011

modified:
  Docs/KNOWN.ISSUES.BSC-patch
  Src/fdf/fdf.F90
  Src/fdf/parse.F90


-----------------------------------------------------------------------
2011-03-29  13:30:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-376
Remove earlier patch for calculation of chemical potential

Undo the changes to chempot (and the calling sequences in ordern and
compute_dm) introduced in November 2007 by P. Ordejon, as they are not
completely correct. This routine determines an approximate chemical
potential for O(N) calculations. Note that parallel operation is still
not possible.

(Did not take back the changes in denmat.F and denmatlomem.F, which
simply force an unconditional rescaling of the density matrix to
produce the correct charge density.)

(+ Fixed the code so that arbitrarily large Chebyshev's orders
are in principle possible in Chempot)

(+ Instrumented the O(N) line-minimization routine to print extra
information if the preprocessor symbol DEBUG_LINMIN4 is used)

modified:
  Src/cgwf.F
  Src/chempot.F
  Src/compute_dm.F
  Src/ordern.F

-----------------------------------------------------------------------
2011-03-22  10:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-375
Clarify folding warning for gamma-point calculations

For gamma-point calculations with unit cells not large enough to avoid
interactions with images, a warning was produced even though it was
only relevant for calculations intended for COOP/COHP analysis. The
warning now appears only in that case.

The manual has been updated to cover the point above, and also to make
it clear that the Use.New.Diagk option is not compatible with the
Diag.Parallel.Over.K mode.

(+ cosmetic changes to avoid compiler warnings related to duplicate
use statements)

modified:
  Docs/siesta.ind
  Docs/siesta.tex
  Src/Makefile
  Src/hsparse.f
  Src/m_ts_scattering.F

-----------------------------------------------------------------------
2011-03-14  10:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-374
Experimental output comparison tool

A simple "output digest" script in awk extracts key information fields from the output
file with default precisions, and generates a small file. These digest files can then
be compared to check for differences.

This is an experimental feature. It is not yet integrated in the automatic test
framework. Note that the reference output files in Tests/Reference have not yet
been updated, pending a review.

added:
  Tests/cmp_digest.sh               ! Script to compare digest files
  Tests/out_digest.awk              ! Digest generator
  Tests/out_digest_template.awk     ! Template for optional precision changes
modified:
  Src/obj_setup.sh                  ! It now creates a symbolic link to the ref directory.

-----------------------------------------------------------------------
2011-03-09  16:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-373
Fix two bugs in Vibra package

The code to read the coordinates-and-masses block did not process the
masses properly. It now also warns when there are not enough values in
each line (a common error).

Variable 'nlines' was not properly set in routine 'klines'.

modified:
  Util/Vibra/Src/klines.f
  Util/Vibra/Src/recoor.f

-----------------------------------------------------------------------
2011-03-04  14:45:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-372
Re-enable write_rho routine

The write_rho routine had been modified for debugging purposes, but
was not re-enabled. It now has been brought back to normal.

modified:
  Src/m_iorho.F

-----------------------------------------------------------------------
2011-02-25  10:20:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-371
Fixes in pdosxml and denchar

(Ported from siesta-3.0 branch)

*Some compilers might have trouble with the shorthand
array syntax used in the update of data arrays in m_pdos.f90.
The bounds are now explicitly indicated.

(Thanks to Miguel Pruneda)

modified:
  Util/pdosxml/m_pdos.f90

* In 2D wavefunction mode, denchar was printing two blank lines
between coordinate blocks.

modified:
  Util/Denchar/Src/denchar.f  -- removed duplicate 'use' statement
  Util/Denchar/Src/rhoofr.f   -- interblock spacing
  Util/Denchar/Src/wavofr.f   --   "

-----------------------------------------------------------------------
2011-02-18  15:55:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-370
Re-initialize data array in timer routine

Apparently it fixes some strangeness with some compilers.

(by Jose Soler)

modified:
  Src/m_timer.F90

-----------------------------------------------------------------------
2011-02-18  15:50:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-369
Remove mentions to SLEPC

The mentions to SLEPC were fossils from a side branch and they have been
removed.

modified:
  Src/siesta_init.F

-----------------------------------------------------------------------
2011-02-03  11:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-368
Incorporation of BSC code: mesh optimization; parallel fdf library

* The ongoing collaboration with the Barcelona Supercomputer Center
(through the department of Computer Applications in Science and
Engineering) has resulted in two new main enhancements:

- New code to improve the load-balance among processors in the
operations carried out in the real-space mesh (involved in the
computation of charge density, exchange-correlation potential, and
matrix elements of the hamiltonian, among others).

Since the different operations have different work-load patterns, it
has been necessary to define and handle three separate data
distributions, with appropriately optimized communication patterns.
Most of the new code is contained in new specialized modules, and
there are calls for data distribution handling in higher-level
modules, notably dhscf.

An overview of the rationale and implementation of the new functionality
can be found in

An efficient implementation of a QM-MM method in SIESTA,
C. F. Sanz-Navarro, R. Grima, A. Garcia, E. A. Bea, A. Soba,
J.M. Cela, and P. Ordejon, 
Theoretical Chemistry Accounts. Online pub Sep 2010. 
DOI: 10.1007/s00214-010-0816-5

We are working on a set of developer-oriented notes to facilitate
future enhancements.

- A new fdf library which avoids the 'master node bottleneck': each
MPI processor now holds a copy of the relevant information, and can
satisfy fdf queries without the need for interprocess communication or
file access.

The most noticeable change is in the processing of fdf blocks. The previous
version of the library provided a Fortran unit number from which the
user code could read the block contents. Now the user is given an
abstract handle with which to perform explicitly the operations of reading
lines, parse, and extract useful information. This paradigm was already
present as a wrapper in previous versions of Siesta, but it is now mandatory.

The two new developments, while formally independent, have been merged
at the same time due to historical and logistical reasons. Even though
the mesh enhancements affect directly only a relatively small number
of files, many others have been modified: some by changes in memory
allocation syntax and indentation, and some to clarify code patterns
or interfaces (see below). The new treatment of fdf blocks and the
removal of the explicit broadcast step in some existing fdf calls has
meant changes to many other files. In all, this patch affects several
dozen files in the Siesta distribution.

* Other significant changes

- The interface to the spherical-harmonics module in matel has been
changed to avoid the creation of temporary arrays at run time. Also,
some internal arrays in the spherical-harmonics module are now
pre-allocated to avoid overhead.

- Throughout the code most 'allocatable' arrays have been turned into
pointers, to be able to exploit the functionality in the alloc module
to resize them concisely. It can be argued that we have gone too far
in some cases.

We have invested a lot of effort in this work, but it is very likely
that some issues have escaped us. A list of those known at this
time can be found in the file Docs/KNOWN.ISSUES.BSC-patch

removed:
  Src/FoX/arch.make
  Src/doping.F
  Src/fdf/fdf.f
  Src/fdf/fdf.h
  Src/fdf/fdf_mod.f
  Src/fdf/fdfdefs.h
  Src/fdf/io_for_fdf_tests.f
  Src/fdf/io_sample.f
  Src/fdf/parse.f
  Src/fdf/sample.f
  Src/m_efield.F
  Tests/bsc-compare.sh
  Tests/std-compare.sh
  Util/Denchar/Src/fdf/.dummy_dir
  Util/Gen-basis/fdf/.dummy_directory
  Util/TBTrans/Libs/
  Util/TBTrans/Libs/.dummy_directory
  Util/TBTrans/MPI/
  Util/TBTrans/MPI/.dummy_dir
  Util/TBTrans/fdf/
  Util/VCA/fdf/.dummy_directory
  Util/Vibra/Src/fdf/.dummy_directory
added:
  .bzrignore
  Docs/BSC.CHANGES
  Docs/KNOWN.ISSUES.BSC-patch
  Src/FoX/arch.make
  Src/Libs/dgetrs_lapack.f
  Src/Libs/dspev_lapack.f
  Src/Sys/altix-32b-par.make
  Src/Sys/altix-32b-ser.make
  Src/Sys/atto-pgf95-openmpi.make
  Src/Sys/finisterrae.make.moved
  Src/Sys/g95-macosx-netcdf.make
  Src/Sys/gfortran-macosx-netcdf.make
  Src/Sys/intel-mpi-checks-metis.make
  Src/Sys/intel10-openmpi.make
  Src/Sys/intel11-openmpi.make
  Src/Sys/macosx-openmpi.make
  Src/Sys/marenostrum-lanczos.make
  Src/Sys/marenostrum-mpi-metis-64.make
  Src/Sys/mn-32b-par.make
  Src/Sys/mn-32b-ser.make
  Src/Sys/mn-openmp.make
  Src/Sys/nano-intel10-mvapich.make
  Src/Sys/pgf95-pgimpi.make
  Src/Sys/rogeli-intel-par.make
  Src/bsc_cellxc.F
  Src/bsc_xcmod.F
  Src/cellxc_mod.F
  Src/debugmpi.F
  Src/doping_uniform.F
  Src/fdf.Standard
  Src/fdf/XY.fdf
  Src/fdf/arch.make
  Src/fdf/fdf.F90
  Src/fdf/hostfile
  Src/fdf/io_fdf.F90
  Src/fdf/iso_fortran_env.F90
  Src/fdf/parse.F90
  Src/fdf/prec.F90
  Src/fdf/sample.F90
  Src/fdf/submit.sh
  Src/fdf/tags
  Src/fdf/utils.F90
  Src/final_H_f_stress.F
  Src/m_diagon.F
  Src/m_dscfcomm.F
  Src/m_efield.F
  Src/mesh.F
  Src/meshcomm.F
  Src/meshphi.F
  Src/moremeshsubs.F
  Src/qsort.F
  Src/schecomm.F
  Src/setup_H0.F
  Src/walltime.c
  Src/xc.f
  Tests/mgc-force/
  Tests/mgc-force/makefile
  Tests/mgc-force/mgc-force.fdf
  Tests/mgc-force/mgc-force.pseudos
  Util/Denchar/Src/timer_local.f
renamed:
  Src/atom.f => Src/atom.F
  Src/forhar.f => Src/forhar.F
  Src/hsparse.f => Src/hsparse.F
  Src/meshmatrix.F => Src/meshdscf.F
  Src/parallelsubs.f => Src/parallelsubs.F
  Src/rhooda.f => Src/rhooda.F
  Src/rhoofd.f => Src/rhoofd.F
  Src/sparse_matrices.F90 => Src/sparse_matrices.F
  Src/timer.f90 => Src/timer.F90
  Src/vmat.f => Src/vmat.F
modified:
  Docs/siesta.ind
  Docs/siesta.tex
  Src/MPI/generate.sh
  Src/MPI/mpi.F
  Src/MPI/mpi__include.f90
  Src/Makefile
  Src/SiestaXC/lib-makefile
  Src/SiestaXC/makefile
  Src/Sys/finisterrae.make
  Src/Sys/gfortran-netcdf.make
  Src/Sys/marenostrum-mpi-32.make
  Src/Sys/nano-intel-mpi-cdf.make
  Src/Sys/nano-intel-mpi.make
  Src/alloc.F90
  Src/arw.f
  Src/atm_transfer.f
  Src/atm_types.f
  Src/atmfuncs.f
  Src/atomlist.f
  Src/atomlwf.F
  Src/bands.F
  Src/basis_io.F
  Src/basis_specs.f
  Src/basis_types.f
  Src/bonds.f
  Src/born_charge.F
  Src/broadcast_basis.F
  Src/broyden_optim.F
  Src/cdiag.F
  Src/cell_broyden_optim.F
  Src/cell_fire_optim.F
  Src/cgvc.F
  Src/cgvc_zmatrix.F
  Src/cgwf.F
  Src/chemical.f
  Src/chempot.F
  Src/compute_dm.F
  Src/conjgr.f
  Src/constr.f
  Src/coor.F
  Src/denmat.F
  Src/denmatlomem.F
  Src/densematrix.f
  Src/detover.F
  Src/dfscf.f
  Src/dhscf.F
  Src/diag2g.F
  Src/diag2k.F
  Src/diagg.F
  Src/diagk.F
  Src/diagk_file.F
  Src/diagkp.F
  Src/diagon.F
  Src/diagpol.f
  Src/diagsprl.F
  Src/dipole.F
  Src/dnaefs.f
  Src/dynamics.f
  Src/egandd.F
  Src/eggbox.F
  Src/electrostatic.f
  Src/ener3.F
  Src/ener3lomem.F
  Src/fdf/Otherfile
  Src/fdf/README
  Src/fdf/coords.fdf
  Src/fdf/fdf.Standard
  Src/fdf/makefile
  Src/fdf/sample.fdf
  Src/fermid.F
  Src/fft.F
  Src/find_kgrid.F
  Src/fire_optim.F
  Src/fixed.F
  Src/get_target_stress.f
  Src/globalise.F
  Src/gradient.F
  Src/gradientlomem.F
  Src/grdsam.F
  Src/initatom.f
  Src/initparallel.F
  Src/iocg.f
  Src/iodm.F
  Src/iodm_netcdf.F90
  Src/iodmhs_netcdf.F90
  Src/ioeig.f
  Src/iofa.f
  Src/iogrid_netcdf.F90
  Src/iokp.f
  Src/iolwf.F
  Src/iomd.f
  Src/iopipes.F90
  Src/ioxv.F
  Src/iozm.F
  Src/kgrid.F
  Src/kgridinit.F
  Src/kinefsm.f
  Src/kpoint_grid.F90
  Src/kpoint_pdos.F90
  Src/ksv.f
  Src/ksvinit.F
  Src/linpack.F
  Src/listsc.f
  Src/local_DOS.F
  Src/m_broyden_mixing.f
  Src/m_fire_mixing.f
  Src/m_history.f90
  Src/m_iodm.F
  Src/m_iorho.F
  Src/m_iostruct.f
  Src/m_memory.F
  Src/m_mpi_utils.F
  Src/m_pulay.F90
  Src/m_sparse.F
  Src/m_spin.F90
  Src/m_ts_in_siesta.F
  Src/m_ts_kpoints.F90
  Src/m_ts_options.F90
  Src/matel.f
  Src/memory.F
  Src/memoryinfo.F
  Src/meshsubs.F
  Src/metaforce.F
  Src/mixer.F
  Src/mneighb.f
  Src/molecularmechanics.F90
  Src/moreParallelSubs.F90
  Src/mulliken.F
  Src/naefs.f
  Src/new_dm.F
  Src/nlefsm.f
  Src/normalize_dm.F
  Src/obc.f
  Src/old_atmfuncs.f
  Src/optical.F
  Src/ordern.F
  Src/outcoor.f
  Src/overfsm.f
  Src/overlap.f
  Src/pdos.F
  Src/pdosg.F
  Src/pdosk.F
  Src/pdoskp.F
  Src/phirphi.f
  Src/phirphi_opt.f
  Src/phonon.F
  Src/pixmol.f
  Src/plcharge.F
  Src/poison.F
  Src/post_scf_work.F
  Src/precision.F
  Src/projected_DOS.F
  Src/proximity_check.F
  Src/pseudopotential.f
  Src/pxf.F90
  Src/radfft.f
  Src/radial.f
  Src/rdiag.F
  Src/read_xc_info.F
  Src/readsp.F
  Src/redcel.F
  Src/reinit.F
  Src/reoptical.F
  Src/reord.f
  Src/rhoofdsp.f
  Src/savepsi.F
  Src/scfconvergence_test.F
  Src/setatomnodes.F
  Src/setspatial.f
  Src/setup_hamiltonian.F
  Src/setup_kscell.F
  Src/shaper.f
  Src/show_distribution.f
  Src/siesta.F
  Src/siesta_analysis.F
  Src/siesta_end.F
  Src/siesta_forces.F
  Src/siesta_init.F
  Src/siesta_move.F
  Src/siesta_options.F90
  Src/sorting.f
  Src/spher_harm.f
  Src/state_analysis.F
  Src/state_init.F
  Src/struct_init.F
  Src/vmatsp.f
  Src/vmb.F
  Src/write_md_record.F
  Src/write_subs.F
  Src/writewave.F
  Src/wxml/m_wxml_array_str.f90
  Src/wxml/m_wxml_buffer.f90
  Src/wxml/m_wxml_core.f90
  Src/wxml/m_wxml_dictionary.f90
  Src/wxml/m_wxml_elstack.f90
  Src/zm_broyden_optim.F
  Src/zm_fire_optim.F
  Src/zmatrix.F
  Tests/Makefile
  Util/Contrib/APostnikov/Makefile
  Util/Denchar/Src/Makefile
  Util/Denchar/Src/atompla.f
  Util/Denchar/Src/denchar.f
  Util/Denchar/Src/local_reinit.f
  Util/Denchar/Src/readpla.f
  Util/Denchar/Src/readsts.f
  Util/Gen-basis/Makefile
  Util/Gen-basis/gen-basis.F
  Util/HSX/iohs.F
  Util/Helpers/Makefile
  Util/Optimizer/Makefile
  Util/TBTrans/Makefile
  Util/TBTrans/green4.F
  Util/TBTrans/m_tbt_gf.F90
  Util/TBTrans/m_tbt_options.F90
  Util/TBTrans/mkqgrid.f
  Util/TBTrans/reinit_tb.F
  Util/TBTrans/tbtrans.F
  Util/VCA/Makefile
  Util/Vibra/Src/Makefile
  Util/Vibra/Src/fcbuild.f
  Util/Vibra/Src/klines.f
  Util/Vibra/Src/recoor.f
  Util/Vibra/Src/vibrator.f
  version.info
  Src/atom.F
  Src/forhar.F
  Src/hsparse.F
  Src/meshdscf.F
  Src/parallelsubs.F
  Src/rhooda.F
  Src/rhoofd.F
  Src/sparse_matrices.F
  Src/timer.F90
  Src/vmat.F






-----------------------------------------------------------------------
2011-01-07  15:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-367
Initialized pointers in moreParallelSubs. Timer call

* Several pointers were used without nullification in routine copyfile in
file moreParallelSubs.F90.

* A "turn-off" call to timer was needed in cdiag in case of early termination.

modified:
  Src/cdiag.F
  Src/moreParallelSubs.F90

-----------------------------------------------------------------------
2010-11-30  13:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-366
Work around bugs in Intel compilers: FoX generics, k-grid

* Work around a bug in Intel12 compiler in k-grid setup

A dummy internal write is used to re-focus the compiler
treatment of a few integer variables.

modified:
  Src/find_kgrid.F
  Src/kgrid.F
  Src/kgridinit.F

* Avoid use of generics in declarations in FoX format routine

The use of generic functions in declaration statements was confusing
the Fortran compiler (version >= 11). They have been replaced by calls
to the specific versions.

modified:
  Src/FoX/fsys/fox_m_fsys_format.F90

-----------------------------------------------------------------------
2010-11-26  15:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-365
Fix setting of applied electric field in parallel

Due to a programming error, the user-specified electric
field was not correctly set in non-master nodes.

Thanks to Alexander Vozny for the bug report.

modified:
  Src/m_efield.F

-----------------------------------------------------------------------
2010-11-18  08:45:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-364
Clarify the output of the timing routine

The timing routine now prints zeros instead of NaNs in the
communications section if the variable MPI_TIMING is not defined,
and an informational note.

modified:
  Src/m_timer.F90

-----------------------------------------------------------------------
2010-11-18  08:40:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-363
Modify bonds routine to print real locations of neighbors

In routine bonds (called at the beginning and at the end of the
program) we now print the real location of the neighbor atom in space,
and not, as in earlier versions, the location of the equivalent
representative in the unit cell.

modified:
  Src/bonds.f

-----------------------------------------------------------------------
2010-11-12  16:20:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-362
Merge 3.0 fixes: ps reparametrization, getopts, ioncat, atm manual

* Cosmetic fixes in Gen-basis/{ioncat,ionplot.sh}

modified:
  Util/Gen-basis/ioncat.f
  Util/Gen-basis/ionplot.sh

* Fix test in m_getopts

A double if test gives problems with some compilers when
bounds checking is in effect.

modified:
  Src/m_getopts.f90

* Improved grid for re-parametrization of pseudopotentials

When the option Reparametrize.Pseudos is in effect, the program
resamples the pseudopotential data into a new logarithmic grid with
parameters chosen so that the grid-point separation at the typical rcs
for orbitals is small enough (of the order of 0.01 bohr). The previous
choice of parameters resulted in grid-point separations of the order
of 0.005 bohr near the origin, which apparently is not fine enough for
s orbitals, leading to oscillations in the gradient near the origin.

A new set of default parameters has been chosen to provide a finer
grid spacing (1.e-5 bohr) near the origin and 0.01 bohr around r=10
bohr. This results in grids with around 10000 points, which is still
manageable.

( Also, a few extra diagnostic files are produced if the option
  Write.Ion.Plot.Files is in effect, and the .psdump file now
  contains the core charge )

modified:
  Src/atmparams.f
  Src/atom.f
  Src/basis_specs.f
  Src/pseudopotential.f
  Docs/siesta.tex

* Update atom manual

- Include a mention of the "fractional atomic number" capability.

- Update the link to Jose Luis Martins' version of the atom program, and
  the contact information in the README file.

modified:
  Pseudo/atom/Docs/atom.tex
  Pseudo/atom/README

-----------------------------------------------------------------------
2010-10-01  10:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-361
Improved documentation of VDW-KBM functional

(J. Soler)

modified:
  Docs/siesta.tex
  Src/SiestaXC/atomxc.F90
  Src/SiestaXC/cellxc.F90
  Src/SiestaXC/siestaxc.F90
  Src/SiestaXC/vdwxc.F90
  Src/SiestaXC/xcmod.f90

-----------------------------------------------------------------------
2010-08-05  15:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-360
(Admin) Incorporate logs of recent patches from 3.0 branch

The siesta-3.0 branch can be considered as a sort of "bug-fix" branch
for "trunk". Hence, periodic merges are needed. This merges
have up to now been done in a "cherry-picking" manner, since 3.0
contains other material that is not supposed to go into trunk. This
has the unfortunate feature that the patch logs are not incorporated
into the trunk, and a "bzr missing" command will keep reporting
spurious differences.

The logs of all the recently applied patches, corresponding to 3.0
patches up to 3.0-rc2, have now been incorporated by doing a normal
merge followed by "bzr revert ." to remove all file changes (changes
already incorporated in local revnos from 349 up to this one).  This
has the effect of marking those patches in siesta-3.0 as "known" to
this branch, and will simplify the porting of future patches from the
3.0 branch. Note that the patch logs do not appear in "bzr log" unless
the "-n0" option is used. This is desirable, as a casual user might
find the output confusing.

Note that revno 355 in this branch already incorporated (without
explicit mention in the commit log, due to an oversight) the relevant
3.0 patches up to 3.0-rc1.

The version string has been set to trunk-360 in both version.info and
siesta.tex.

-----------------------------------------------------------------------
2010-08-05  14:40:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-359
Fixes for portability (FoX str, pulay, MD rewind, reshape)

* The PGI compiler had trouble with the "str" function exported from
  FoX. The call has been replaced by an internal write to an auxiliary
  variable.

* In m_pulay, some compilers evaluated both sub-clauses of an "and"
  expression, even if the first was .false.. This led to a division by
  zero in a mod operation. The expression has been replaced by more
  robust code.

* The MD file repositioning code in iomd.f gave problems in some
  systems. It has been removed, and substituted by an explicit
  'position="append"' clause in the open statement.

* In SiestaXC/mesh3d.F90, work around a gfortran bug in the reshape
  intrinsic by specifying a zero lower bound. The bug only appears
  if bounds checking is in effect.

modified:
 Src/m_pulay.F90
 Src/siesta_cmlsubs.F90
 Src/iomd.f
 Src/SiestaXC/mesh3d.F90

-----------------------------------------------------------------------
2010-08-05  14:05:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-358
Cosmetic fixes (larger fields in atm files, vibra manual)

* Use larger output fields for atm diagnostic files

The atm program generates, among others, the files FOURIER_QMAX and
ECONF_DIFFS, which contain information useful for optimization
runs. The output fields were quite tight and sometimes
overflowed. They have beeen made larger.

modified:
  Pseudo/atom/prdiff.f
  Pseudo/atom/wrapup.f

* Clarify the meaning of the supercell options in the Vibra manual

New wording to make it clear that the supercell options refer
to the number of augmentation shells around the unit cell.

modified:
  Util/Vibra/Docs/vibra.tex

-----------------------------------------------------------------------
2010-08-05  14:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-357
Compute and print band-structure energy. Updates to Util/COOP/mprop

* The band-structure energy Ebs = Tr(DM*H) is now computed at every 
  iteration and printed at the beginning and end of the SCF cycle, both
  in the output file and in the CML file. The calculation is done in  
  compute_dm, so DM is the "output DM" from the diagonalization of H.

* The mprop program has been updated to output the integrated
  band-structure energy as a function of energy as a third column in
  the integrated-dos file. The " -n " option has been documented.

* Creation of Util/COOP/Docs, and addition of some notes on the units
  and meaning of the COOP and COHP curves.

added:
  Util/COOP/Docs/
  Util/COOP/Docs/UnitsAndMeaningOfCurves.txt
  Util/COOP/Tests/README
modified:
  Src/Makefile
  Src/compute_dm.F
  Src/m_energies.F90
  Src/write_subs.F
  Util/COOP/README
  Util/COOP/main_vars.f90
  Util/COOP/mprop.f90
  Util/COOP/subs.f90

-----------------------------------------------------------------------
2010-08-05  13:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-356
Make the HSX format the default for H,S files

The old HS format was highly inefficient, as each piece of data was
written to its own record. In addition, it only contained information
about the inter-orbital vectors Xij if k-points were used in the
calculation.

The new HSX file format was introduced at the time of the first
COOP/COHP implementation. It is more tightly packed, and the real
arrays (H, S, and Xij) are written in single-precision.

The HSX format is now the default in Siesta (TranSiesta has its own
format).

The programs hsx2hs and hs2hsx in Util/HSX are provided to facilitate
the transition. Note however that an HS file written by Siesta during
a Gamma-only calculation will not contain information about the
inter-orbital vectors Xij, and hs2hsx will refuse to create an HSX
file from it.

See Util/HSX/README for more details.

The file iohs.F has been moved to Util/HSX from the main source
directory.

added:
  Util/HSX/hs2hsx.f90
  Util/HSX/hsx2hs.f90
  Util/HSX/makefile
renamed:
  Src/iohs.F => Util/HSX/iohs.F
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/setup_hamiltonian.F
  Util/HSX/README
  Util/HSX/hsx_m.f90

-----------------------------------------------------------------------
2010-08-05  10:55:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-355
Hook to output the initial charge density

If the fdf variable SaveInitialChargeDensity is "true", the program
generates a RHO_INIT (and a RhoInit.grid.nc file if netCDF is compiled
in) containing the charge density used to start the first
self-consistency step, and it stops. Note that if an initial density
matrix (DM file) is used, it is not normalized. This is useful to
generate the charge density associated to "partial" DMs.

modified:
  Docs/siesta.tex
  Src/dhscf.F
  Src/setup_hamiltonian.F
  Src/siesta_options.F90

-----------------------------------------------------------------------
2010-08-05  10:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-354
Fixes and new functionality in Pulay mixing

* The "kick" functionality intended to "shake" periodically the Pulay
mixing procedure was incorrectly implemented. This has now been fixed,
with the added feature that the Pulay history is completely reset
after a kick.

* Additionally, support has been added to specify whether the first
density-matrix residual of the SCF cycle and the first residual after
a kick are included in the Pulay history. It can be argued that in
these cases the "output" DM might be significantly different from the
"input" DM. To preserve backwards compatibility, these residuals are
kept in the Pulay history unless the fdf variable

      DM.Pulay.Avoid.First.After.Kick

is set to "true" in the input file.

* The above changes have forced a temporary disabling of the "Pulay on
  file" feature, which will be re-implemented in a form that works
  well in parallel.

* Updated the manual.

(A. Garcia)

renamed:
  Src/m_pulay.F => Src/m_pulay.F90
modified:
  Src/mixer.F
  Src/siesta_options.F90
  Src/m_pulay.F90
  Docs/siesta.tex

-----------------------------------------------------------------------
2010-08-05  10:00:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-353
Fixes and improvements in the optical spectra code

* Fixed a bug in optical.F: the call to subroutine kgridinit nwas
  causing problems and providing results that were not compatible any
  longer with those of subroutine kgrid.

* Modified call to subroutine transition_rate: wmin and wmax passed to
  subroutine so that only the relevant transition probabilities are
  explicitly calculated.

* Added a new test (Tests/si-optical) to exercise the optical code.

(Daniel Sanchez Portal)

added:
  Tests/Reference-xml/si-optical.xml
  Tests/Reference/si-optical.out
  Tests/si-optical/
  Tests/si-optical/makefile
  Tests/si-optical/si-optical.fdf
  Tests/si-optical/si-optical.pseudos
modified:
  Docs/CHANGES
  Src/optical.F
  Src/transition_rate.F

-----------------------------------------------------------------------
2010-08-04  15:40:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-352
Updates and fixes to the TranSiesta/tbtrans code (F.D. Novaes)

This patch includes bug fixes (in TranSiesta and tbtrans), a cleanup
involving removal of dead code, proper declarations of variables, and
a new prototype test framework for TranSiesta and tbtrans.

1. Fixed the issues related to the density matrix in a TS run, due to the
changes in new_dm.F
  
* The new module m_ts_iodm.F is the equivalent of m_iodm.F, created to
handle .TSDE files. These, are just like .DM files but where the Escf
sparse matrix and the Fermi Energy are written at the end of the
file. The makefile was modified in order to include this module.

* The new_dm module now has a cleaner Transiesta related structure.
The possibility of doing a "continuation run" (where a .TSDE file is
read and the run starts with a TS calculated density matrix), is
handled by calling the routine read_dynamic_ts_dm.  Since Transiesta
also stores and reads Escf, the variable EDM_tmp has been created and
is used in the same way as D_tmp.  The routine change_sparsity is also
used for Escf. But these parts of the code have not been tested yet,
since it would require a change in the sparsity., by atomic
rearrangements.
  

added:
  Src/m_ts_iodm.F
modified:
  Src/Makefile
  Src/new_dm.F


2. Changed the way mixH or mixDM are internally handled. Added a
global_vars module.

* Created the module m_ts_global_vars.f90 that contains the TS
variables that are accessed in different parts of the code and are not
passed as dummy arguments.

* Considerable changes were made in the way the possibility of mixing
either the density matrix or the hamiltonian is handled internally.
The VIn and VOut pointers are still used, but now, instead of
allocating some memory and copying the values of Dscf (H) to them,
they directly point to either the Dscf and Dold matrices OR to H and
HOld. The latter vector is allocated only whe mixH=.true., and this
implies that in this case more memory will be required since Dold is
also allocated because it is used in other parts of the code.  In any
case, this leads to a smaller amount of allocated memory. The coding
is clearer also, specially at the siesta_forces routine.


added:
  Src/m_ts_global_vars.f90
modified:
  Src/Makefile
  Src/compute_dm.F
  Src/dhscf.F
  Src/m_ts_iodm.F
  Src/m_ts_options.F90
  Src/mixer.F
  Src/new_dm.F
  Src/scfconvergence_test.F
  Src/setup_hamiltonian.F
  Src/siesta_forces.F
  Src/state_init.F
  Src/write_subs.F

3. Cleaning of m_ts modules; set grid variables to be defined with
grid_p; and smaller changes.

* Removed unused variables and dummy arguments (all m_ts modules).
Also specified what is used from each module with the idiom "use
MODULE, only:"

* For the TSVHFix and TSvoltage2 subroutines (m_ts_in_siesta.F90
module), fixed the precision of the "v" variable (real space
potential) to be grid_p.

* The following cosmetic declaration changes were made:

real*8 --> real(dp)
complex*16 --> complex(dp)
double precision --> real(dp)

where "dp" comes from the precision module.

* IOnode was incorrectly set to be node=1, now it is node=0
  (m_ts_in_siesta.F)

* Removed the initH variable from several routines. (new_dm,
scfconvergence_test, setup_hamiltonian,siesta_forces)
  
  
modified:
  Src/compute_dm.F
  Src/m_ts_contour.F
  Src/m_ts_electrode.F90
  Src/m_ts_in_siesta.F
  Src/m_ts_io.F90
  Src/m_ts_options.F90
  Src/m_ts_scattering.F
  Src/new_dm.F
  Src/scfconvergence_test.F
  Src/setup_hamiltonian.F
  Src/siesta_forces.F

4. Assortment of changes/fixes in TBTrans.

* The original version of TBTrans (by M. Brandbyge) was not
parallelized.  Some of the original properties computed by tbtrans
(the transmission function and the pdos) have been "ported" to work
also in the parallelized version of the code, but some have not. Those
who have not, have been, for now, deleted (atompdos, coop and NetCDF
related things).

* The transmission function is now multiplied by two in the
case of non spin-polarized calculations. As a consequence, the
computed current is multiplied too.

* The printed value of the pdos (averaged over all the k-points), when 
running in parallel with more than one node, was not correct: only the values 
coming from the node=0 were being printed. This has been fixed.

* Some smaller changes were done on the way the results are written in the output 
files (e.g. including blank lines in between values for each k-point, so that 
the file can be directly plotted with xmgrace).  Also changed the name of the 
routine "Tsiokp" (m_tbt_kpoints.F90) to "get_kp_on_node" since it represents 
better what it really does.

removed:
  Util/TBTrans/atompdos.F
  Util/TBTrans/coop.f
  Util/TBTrans/OutputRegionData.F
  Util/TBTrans/OutputRegionData.NoLowdin.F
  Util/TBTrans/netcdfwrite.F
modified:
  Util/TBTrans/Makefile
  Util/TBTrans/m_tbt_gf.F90
  Util/TBTrans/m_tbt_kpts.F90
  Util/TBTrans/m_tbt_options.F90
  Util/TBTrans/tbtrans.F

5. Created a test directory (ts_fast) to test TranSIESTA and
TBTrans. (F.D.Novaes/A.Garcia)

* An automatic test for transiesta and tbtrans can be run by going to 
the $OBJDIR/Tests directory, and typing:

  make ts

and to clean:

  make clean_ts

For now, only the tests contained in the ts_fast directory will be
executed, and more tests with similar structure will be added in the
near future.  The script first runs the electrode calculation, then
the scattering region calculation and finally tbtrans. If during any
of these steps there is an error message sent to stderr, the script
will stop and the following step will not start. The error message is
printed to an output file (err_elec.out or err_scat.out or
err_tbt.out). It only creates the "completed" file if it reaches the
end.

Parallel compilations can be tested by changing to the ts_fast directory 
and (for example) typing:
 
  make TS="/opt/openmpi.gcc.gfortran/bin/mpirun -np 2 ../../../transiesta"

By default, tbtrans will be (re)compiled using the arch.make located
in the $OBJDIR.  To use an already compiled version of tbtrans (again,
inside the ts_fast directory) type:
  
  make TBT=/some/path/to/tbtrans

NOTE: Since the compilation of tbtrans is automatic and unattended,
you will need to specify in your arch.make the linear algebra libraries
needed for tbtrans in your system. For example:

  TBTRANS_LINALG=linalg.a # Or maybe only: zgeev_lapack.a zgesv_lapack.a

* The functionality for the TS tests is kept in the new file scrip_ts.mk.

added:
  Tests/script_ts.mk
  Tests/ts_fast/
  Tests/ts_fast/H.psf
  Tests/ts_fast/elec.fast.fdf
  Tests/ts_fast/makefile
  Tests/ts_fast/scat.fast.fdf
  Tests/ts_fast/script.sh
modified:
  Tests/Makefile

-----------------------------------------------------------------------
2010-08-04  15:10:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-351
Fix for out-of-box atoms in meshsubs

In InitAtomMesh, during the calculation of the relative position of an
atom with respect to the grid, make sure we consider the equivalent
position inside the cell, even if the atom is outside.

(Possible problem detected by P. Ordejon, fixed by J. Soler)

modified:
  Src/meshsubs.F

-----------------------------------------------------------------------
2010-08-03  15:35:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-350
Port several small patches from 3.0 branch up to 3.0-rc2

* Fix initialization of target_stress in some cell-only relaxations
  
When using the RelaxCellOnly option in tandem with Broyden relaxation,
the target stress was not properly initialized.

(Thanks to Marcos Verissimo Alves for pointing out the bug and fix)

  modified:
    Src/cell_broyden_optim.F

* Print value of dipole if applying correcting field
  
If the SlabDipoleCorrection option is active, print the computed
value of the total system dipole at every iteration, to help
diagnose possible problems.

Added note in the manual warning about the use of non-corrected
density matrices with this option.
  
(+ fix MPI wrap of output in m_efield)

  modified:
    Src/Makefile
    Src/dhscf.F
    Src/m_efield.F
    Docs/siesta.tex

* Correction of error in siesta.tex (as discovered by J. Junquera)

The FDF labels DM.Energy.Tolerance and DM.Harris.Tolerance
were wrongly stated as "real" instead of "real energy", and their
default value stated with no units when its units are eV.

  modified:
    Docs/siesta.tex

-----------------------------------------------------------------------
2010-08-03  15:15:00 GMT Alberto Garcia <albertog@icmab.es>   trunk-349
Tentative fix for DM reuse bug

In some cases the re-use of the DM after a geometry change led to
large values of ddmax and instabilities in SCF convergence. The
tentative cause was the re-allocation of Dscf right after the call to
hsparse for the new geometry, and before new_dm, combined with a
"sparsity pattern change" in-place. When the re-allocation is deferred
to new_dm, and the plain "change_sparsity" routine is used, the
problem seems to disappear. 

Thanks to Oswaldo Dieguez for his sleuthing work.

More testing is needed to close the bug definitively.
  
Modified:
  Src/Makefile
  Src/new_dm.F
  Src/state_init.F

-----------------------------------------------------------------------
2010-06-23 12:20:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-348

Use DEBUG_XC preprocessor symbol to wrap SiestaXC debugging (J. Gale)

 * Comments wrapped by ! DEBUG in several SiestaXC routines (and in
   related sections of siesta_init and siesta_end) have been replaced
   by #ifdef DEBUG_XC ... #endif so that the writing of debugging files
   can be turned off easily at compile time.

   Note that this has forced the change in file extension of a few
   files in Src/SiestaXC, with concommitant changes in the makefiles.

renamed:
  Src/SiestaXC/atomxc.f90 => Src/SiestaXC/atomxc.F90
  Src/SiestaXC/cellxc.f90 => Src/SiestaXC/cellxc.F90
  Src/SiestaXC/fft3d.f90 => Src/SiestaXC/fft3d.F90
  Src/SiestaXC/fftr.f90 => Src/SiestaXC/fftr.F90
  Src/SiestaXC/siestaxc.f90 => Src/SiestaXC/siestaxc.F90
  Src/SiestaXC/vdwxc.f90 => Src/SiestaXC/vdwxc.F90
modified:
  Src/SiestaXC/lib-arch.make
  Src/SiestaXC/lib-makefile
  Src/SiestaXC/makefile
  Src/SiestaXC/mesh3d.F90
  Src/siesta_end.F
  Src/siesta_init.F
  Src/SiestaXC/atomxc.F90
  Src/SiestaXC/cellxc.F90
  Src/SiestaXC/fft3d.F90
  Src/SiestaXC/fftr.F90
  Src/SiestaXC/siestaxc.F90
  Src/SiestaXC/vdwxc.F90

-----------------------------------------------------------------------
2010-06-23 12:02:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-347

Make sure that units are closed with io_close (J. Gale)

 * 'Close' replaced by call to 'io_close' in several routines to
   prevent luns overload.

 * Unused declarations of io_assign and io_close removed from diagon.F
   and ksv.f

 (Julian Gale)

 modified:
   Src/diagon.F
   Src/ksv.f
   Src/m_timer.F90
   Src/moreParallelSubs.F90
   Src/write_orb_indx.f90
-----------------------------------------------------------------------
2010-06-23 02:19:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-346

Support for LMKLL and KBM vdW functionals in ATOM (A. Garcia)

 The pseudopotential generation program now accepts the "vl" xc code to
 request the Lee et al. (LMKLL) version of the vdW functional
 (arXiv:1003.5255v1 (2010)), and the "vk" xc code for the vdW
 parametrization of Klimes et al. (KBM) (JPCM 22, 022201 (2009)).

 The id strings in .xml pseudo files are, respectively,
 'Lee-et-al--LMKLL', and 'Klimes-et-al--KBM'. For consistency, the id
 string for the Dion functional has been extended to
 'Dion-et-al--DRSLL'

 The ATOM manual has been updated, and the version number set to
 3.3.1.

 Obsolete xc routines (pre-SiestaXC) have been removed from the
 Pseudo/atom directory.

 removed:
   Pseudo/atom/blypxc.f
   Pseudo/atom/ggaxc.f
   Pseudo/atom/ldaxc.f
   Pseudo/atom/pw92xc.f
   Pseudo/atom/pzxc.f
   Pseudo/atom/revpbexc.f
   Pseudo/atom/rpbexc.f
 modified:
   Pseudo/atom/Docs/atom.tex
   Pseudo/atom/Makefile
   Pseudo/atom/pseudoXML.f
   Pseudo/atom/velect.f
-----------------------------------------------------------------------
2010-04-20 00:53:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-345

Updated makefile dependencies (J. M. Soler)
  
modified:
  Src/Makefile
  Src/SiestaXC/makefile
  
-----------------------------------------------------------------------
2010-04-20 00:48:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-344

Added parametrization of Klimes et al for vdW-DF (J. M. Soler)
  
modified:
    Docs/siesta.tex                  ! Added VDW/KBM
    Src/SiestaXC/Testers/test1.f90   ! Call to B88 GGA exchange
    Src/SiestaXC/atomxc.f90          ! Added VDW/KBM comment
    Src/SiestaXC/cellxc.f90          ! Added VDW/KBM comment
    Src/SiestaXC/ggaxc.f             ! Added Becke-88 exchange routine
    Src/SiestaXC/siestaxc.f90        ! Added VDW/KBM comment
    Src/SiestaXC/vdwxc.f90           ! Call to B88 exchange
    Src/SiestaXC/xcmod.f90           ! Call to vdw_set_author for KBM

-----------------------------------------------------------------------
2010-04-20 00:44:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-343

Documentation completed on LMKLL flavour of vdW-DF (J. M. Soler)
  
modified:
    Docs/siesta.tex
    Src/SiestaXC/siestaxc.f90
    Src/SiestaXC/vdwxc.f90

-----------------------------------------------------------------------
2010-04-20 00:38:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-342

A bug corrected in testers (J. M. Soler)
  
modified:
    Src/SiestaXC/Testers/test2.f90  ! Avoid using DRSLL & LMKLL together
    Src/SiestaXC/Testers/test3.F90
    Src/SiestaXC/Testers/test4.F90

-----------------------------------------------------------------------
2010-04-20 00:34:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-341

Added the vdW functional flavour of K.Lee et al, arXiv:1003.5255v1 (2010) (J.M. Soler)
  
modified:
    Src/SiestaXC/Testers/test1.f90  ! Added PW86
    Src/SiestaXC/Testers/test2.f90  ! Added VDW/LMKLL
    Src/SiestaXC/Testers/test3.F90  ! Added VDW/LMKLL
    Src/SiestaXC/Testers/test4.F90  ! Added VDW/LMKLL
    Src/SiestaXC/atomxc.f90         ! Call to vdw_exchng
    Src/SiestaXC/cellxc.f90         ! Call to vdw_exchng
    Src/SiestaXC/ggaxc.f            ! Added PW86 and PW86R exchange functionals
    Src/SiestaXC/vdwxc.f90          ! Added vdw_exchng and vdw_set_author
    Src/SiestaXC/xcmod.f90          ! Call to vdw_set_author

-----------------------------------------------------------------------
2010-03-08 12:23:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-340

Update FoX to version 4.1.0 (A. Walker)
  
  Version 4.1.0 of FoX, used to produce our XML output was released 
  on 2010-02-09. This patch updates the version shipped with Siesta 
  to this version. 

  Changes that affect Siesta are that the build process for FoX can
  now take advantage of possible parallelization (make -j), we can 
  ask FoX to generate an abort signal if it kills the process and 
  the inclusion of work arounds for compiler bugs in recent versions 
  of the pgi compiler. Some of these changes existed in an (unrelased)
  version of FoX shipped with Siesta since revision 320.
 
  modified:
      Src/FoX/FoX-config.in
      Src/FoX/LICENSE
      Src/FoX/Makefile
      Src/FoX/common/FoX_common.F90
      Src/FoX/configure
      Src/FoX/wxml/FoX_wxml.f90
      Src/FoX/wxml/m_wxml_core.F90
      version.info
      
-----------------------------------------------------------------------
2010-02-04  03:50:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-339

  Fix bug in previous patch regarding CG DM extrapolation (A. Garcia)
  
  The logic of a previous patch was wrong, and the resulting
  code prevented the proper restructuring of a reused DM in
  the course of CG relaxations.
  
  To make it clear now: For "CG" calculations, the default is not to
  extrapolate the DM (unless requested by explicitly setting
  'DM.AllowExtrapolation' to "true"). The previous step's DM is reused.
  
  modified:
    Docs/siesta.tex
    Src/new_dm.F
    
-----------------------------------------------------------------------
2010-02-04  03:36:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-338

  Avoid extrapolation of DM during geometry optimization (A. Garcia)
  
  When performing a geometry optimization (CG, Broyden, etc) (idyn=0 in
  the code), there might be sudden jumps in the geometry (e.g., at the
  end of a line-minimization) that render a extrapolation of the DM
  risky. Hence DM extrapolation is turned off in this case.
  
  One might argue that DM re-use should be avoided too.
  
  modified:
    Docs/siesta.tex
    Src/new_dm.F

-----------------------------------------------------------------------
2010-02-03  02:34:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-337

Patch for problem in the iVec computers (J. M. Soler)
  
  A persistent problem in Australia's iVec supercomputers was traced to an 
  apparent ifort compiler error, producing a core dump in re_alloc's line
    array(c(1,1):c(2,1)) = old_array(c(1,1):c(2,1))
  that disappeared when substituted by
    do i = c(1,1),c(2,1)
      array(i) = old_array(i)
    enddo
  Since, in the offending call, no array copy was really neaded, the problem
  was solved insted by adding copy=.false. in that call by initMesh.
  
  Independently of the former, a number of corrections or improvements
  were done in various files, to solve small deficiencies located during
  the process of debugging the previous problem.
  
  modified:
    Src/SiestaXC/debugxc.f90   ! Corrected file name in closeDebugOutputFile
    Src/SiestaXC/ggaxc.f       ! Added spin bounds in array copy
    Src/SiestaXC/mesh3d.F90    ! Added several checks for range of iDistr
    Src/fermid.F               ! Removed a duplicated printout
    Src/meshsubs.F             ! Added copy=.false. in call to re_alloc

-----------------------------------------------------------------------
2010-02-03  02:28:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-336

Corrected call to MPI_AllReduce in SiestaXC/Testers/test4.F90 (J.M. Soler)
  
  modified:
    Src/SiestaXC/Testers/test1.f90  ! Increased number of densities tried
    Src/SiestaXC/Testers/test4.F90  ! Corrected call to MPI_AllReduce
    
-----------------------------------------------------------------------
2010-02-03  02:22:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-335

MPI_grid_real kind adapted to new standard (J.M. Soler)
  
  modified:
    Src/MPI/mpi.F   ! MPI_grid_real=DAT_double unless def GRID_SP
    
-----------------------------------------------------------------------
2010-02-03  00:17:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-334

A bug corrected by J.D.Gale in the am05 functional (J.M. Soler)
  
  modified:
    Src/SiestaXC/Testers/makefile   ! Copy ../*.mod
    Src/SiestaXC/am05.f90           ! Bug corrected
    Src/SiestaXC/ggaxc.f            ! Corrected call to am05wbs
    
-----------------------------------------------------------------------
2010-02-02  10:57:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-333

Two minor bugs found by Alberto Garcia (J.M. Soler)
  
  modified:
    Src/SiestaXC/Testers/test3.F90  ! Add MPI_Finalize
    Src/SiestaXC/Testers/test4.F90  ! Add MPI_Finalize
    Src/SiestaXC/lib-makefile       ! Add am05.o
    
-----------------------------------------------------------------------
2010-02-01  20:55:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-332

Include AM05 functional in SiestaXC/Testers (J.M. Soler)
  
  The recently-added AM05 functional has been added to those tested by the
  SiestaXC/Testers.
  
  modified:
    Src/SiestaXC/Testers/test1.f90
    Src/SiestaXC/Testers/test2.f90
    Src/SiestaXC/Testers/test3.F90
    Src/SiestaXC/Testers/test4.F90

---------------------------------------------------------------------
2010-01-15  18:40:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-331

  Two mesh-related bugs (From J.M.Soler)
  
  In routine phiOnMesh, function 'size' was used with unassociated pointers.
  This is a bug, although most compilers tolerate it. Unrelated to this,
  in routine divideBox1D, the limits of the first and last boxes was not
  correctly initialized.
  
  modified:
    Src/SiestaXC/mesh3d.F90  ! Initialize partBox(1,1) and partBox(2,nParts)
    Src/meshsubs.F           ! Check pointer associations

---------------------------------------------------------------------
2010-01-15  18:40:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-330

  Two bugs in MPI communications (From J.M.Soler)
  
  The length increase of strings XCfunc and XCauth in trunk-320-JMS-3 had not
  been considered in their MPI communication calls. Also, unrelated to this,
  a conditional return made node 0 not participate in a global broadcast,
  leaving the other nodes hunging.
  
  modified:
    Src/m_efield.F       ! Removed conditional return
    Src/read_xc_info.F   ! Corrected string length in MPI_Bcast

---------------------------------------------------------------------
2010-01-15  18:40:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-329

  Bug correction in mesh3d (From J.M.Soler)
  
  A case not taken care of, in routine sameMeshDistr, created an
  out-of-bounds condition that was noticed by J.D.Gale and others.
  Also, a use statement was added for MPI routines in m_mpi_utils.
  
  modified:
    Src/SiestaXC/mesh3d.F90  ! Bug corrected in sameMeshDistr
    Src/m_mpi_utils.F        ! Added use statement for MPI routines
    Src/meshsubs.F           ! Variable JDGdistr saved and initialized

---------------------------------------------------------------------
2010-01-15  18:10:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-328

  Print vacuum level (From J.M.Soler)
  
  The vacuum level, defined as the effective potential at grid points with
  zero density, is printed in the standard output. This is done whenever
  there are such points and either SaveElectrostaticPotential or
  SaveTotalPotential are true. This will be useful to calculate the work 
  function of a surface.
  
  added:
    Src/vacuum_level.f90      ! Computes the vacuum level
  modified:
    Docs/siesta.tex           ! Document side effect of SaveTotalPotential
    Src/Makefile              ! Add vacuum_level.o. Update dependencies
    Src/dhscf.F               ! Call vacuum_level and print it
    Src/moreParallelSubs.F90  ! Make public miscAllReduceInt

---------------------------------------------------------------------
2010-01-15  18:10:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-327

  Make doping routine call global fdf version (From J.M.Soler)
  
  An error was occurring because all nodes were calling the old (serial) fdf
  routines, which should be called only by node=0. The fdf_global version can
  handle such global calls.
  
  modified:
    Src/Makefile  ! Updated dependencies
    Src/doping.F  ! Call global fdf version

---------------------------------------------------------------------
2010-01-15  17:55:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-326

  New GGA functionals with PBE form and parameters from Capelle et al (From J.M.Soler)
  
  The four new functionals, with author labels PBE(JsJrLO), PBE(JsJrHEG), 
  PBE(GcGxLO), and PBE(GcGxHGE), have the PBE functional form, but use
  modified values for parameters beta, mu, and kappa. 
  Refs: L.S.Pedroza et al, PRB 79, 201106 (2009)
        M.M.Odashima et al, J. Chem. Theory Comp. 5, 798 (2009)
  
  modified:
    Src/SiestaXC/ggaxc.f     ! New functionals implemented
    Src/SiestaXC/xcmod.f90   ! Increased length for XCfunc and XCauth strings
    Src/atom.f               ! Let xc_check continue even if func. not known
    Src/read_xc_info.F       ! Increased length for XCfunc and XCauth strings

---------------------------------------------------------------------
2010-01-15  17:40:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-325

Document in manual the file on orbital indexes (From J.M.Soler)
  
Added to the manual documentation on file (label).ORB_INDX
  
modified:
    Docs/siesta.ind
    Docs/siesta.tex   ! File ORB_INDX documented.
    
---------------------------------------------------------------------
2010-01-15  17:40:00 GMT Jose A Torres <jose.torres.alonso@uam.es>  trunk-324

Write orbital indexes  (From J.M.Soler)
  
  To assist users in interpreting files like (label).DM and (label).HS, a new
  file called (label).ORB_INDX is written with info on the orbital index order.
  
  added:
    Src/write_orb_indx.f90   ! Writes (label).ORB_INDX
  
  modified:
    Src/Makefile             ! Added write_orb_indx.o + Dependencies updated
    Src/atmfuncs.f           ! Orbital symmetry names completed up to g orbitals
    Src/compute_dm.F         ! Added call to write_orb_indx
    
---------------------------------------------------------------------
2010-01-15  17:02:00 GMT  Jose A Torres <jose.torres.alonso@uam.es>  trunk-323

Name of functional updated in AM05XC to correctly be AM05 (From J. Gale)

modified:
  Src/SiestaXC/ggaxc.f
  
---------------------------------------------------------------------
2010-01-15  16:43:00 GMT  Jose A Torres <jose.torres.alonso@uam.es>  trunk-322

Changes to the default precision of grid magnitudes (From A. Garcia)

The grid functions (charge densities, potentials, etc) are now in
double precision by default. The 'phi' array that holds the values of
the basis orbitals on the real-space grid is kept in single precision.

The following pre-processing symbols at compile time control the 
precision selection:

#ifdef GRID_SP
    integer, parameter :: grid_p = sp
    integer, parameter :: phi_grid_p = sp
#elif defined(GRID_DP)
    integer, parameter :: grid_p = dp
    integer, parameter :: phi_grid_p = dp
#else
    integer, parameter :: grid_p = dp
    integer, parameter :: phi_grid_p = sp
#endif

GRID_DP will lead to a sizable memory increase, as 'phi' is the main
user of memory on the grid. On the other hand, the gains in accuracy
are negligible, as the operations over 'phi' are accumulated in double
precision variables.

GRID_SP recovers the old Siesta default. It will not free much
memory, and it will show some numerical differences.

modified:
  Docs/siesta.ind
  Docs/siesta.tex
  Src/meshsubs.F
  Src/precision.F

---------------------------------------------------------------------
2010-01-15  16:43:00 GMT  Jose A Torres <jose.torres.alonso@uam.es>     trunk-321

 Fixed the precision of real and complex variables in m_ts* modules. (From F.D.Novaes)
  
  * For the TSVHFix and TSvoltage2 subroutines (m_ts_in_siesta.F90 module),
    fixed the precision of the "v" variable (real space potential) 
    to be grid_p.
  
  * In all the modified modules, the following changes were made:
  
    real*8 --> real(dp)
    complex*16 --> complex(dp)
    double precision --> real(dp)
  
    where "dp" comes from the precision module.   
  
  modified:
    Src/m_ts_aux_rout.F
    Src/m_ts_contour.F
    Src/m_ts_electrode.F90
    Src/m_ts_in_siesta.F
    Src/m_ts_io.F90
    Src/m_ts_scattering.F

---------------------------------------------------------------------
2009-12-07  18:43:00 GMT  Jose A Torres <jtorres.sp@gmail.com>     trunk-320

 Make WriteXML option consistent (XML.Write) and document (From A. Walker)

 Document the two new XML options: XML.AbortOnErrors and
 XML.AbortOnWarnings in siesta.tex (documentation is in the
 XML appendix).

 Rename undocumented WriteXML option to XML.Write for
 consistancy. Document this option in siesta.tex.
 
 modified:
  Docs/siesta.tex
  Src/siesta_cmlsubs.F90
 
---------------------------------------------------------------------
2009-12-07  18:28:00 GMT  Jose A Torres <jtorres.sp@gmail.com>     trunk-319

Update FoX library and add XML.AbortOnErrors and XML.AbortOnWarnings (From A. Walker)

It is sometimes useful for warnings or errors generated by the FoX
libary to result in an abort to generate a core dump or stack trace to
see where in Siesta the call causing the error is being made. It is
now possible to turn on this behaviour at runtime using two new fdf
boolean tags:

 XML.AbortOnErrors  XML.AbortOnWarnings

Both are boolean and default to .false. (which mirrors the current
stopping behaviour).

These features have been made possible by an update in the FoX library
that adds an interface to allow errors and warnings to result in an
abort signal. In the update there is also a fix to work around a PGI
bug for the overloaded wxml interfaces (aparently not used in Siesta)
and a change to the prng to avoid using initalised data in prng_init.

added:
  Src/FoX/arch.make
modified:
  Src/FoX/Makefile
  Src/FoX/common/FoX_common.F90
  Src/FoX/common/m_common_error.F90
  Src/FoX/common/makefile
  Src/FoX/fsys/fox_m_fsys_abort_flush.F90
  Src/FoX/utils/fox_m_utils_uuid.F90
  Src/FoX/utils/makefile
  Src/FoX/wcml/m_wcml_molecule.F90
  Src/FoX/wcml/makefile
  Src/FoX/wxml/m_wxml_core.F90
  Src/FoX/wxml/m_wxml_overloads.F90
  Src/FoX/wxml/makefile
  Src/siesta_cml.f90
  Src/siesta_cmlsubs.F90

------------------------------------------------------------------------------
2009-12-04  16:21:00 GMT  Jose A Torres <jtorres.sp@gmail.com>      trunk-318

Fixes to compilation of Utils (From A. Garcia)

After the merge of SiestaXC the building of many Util programs was broken.
The problems have been fixed.

modified:
  Pseudo/atom/Makefile
  Pseudo/atom/divdif.f
  Util/Denchar/Src/Makefile
  Util/Gen-basis/Makefile
  Util/Helpers/Makefile
  Util/Optimizer/Makefile
  Util/STM/ol-stm/Src/Makefile
  Util/STM/simple-stm/plstm.f
  Util/TBTrans/Makefile
  Util/VCA/Makefile

------------------------------------------------------------------------------
2009-11-27  19:56:00 GMT  Jose A Torres <jtorres.sp@gmail.com>      trunk-317

Minor change in cellxc.f90 to make it compatible with xlf

In cellxc.f90 
The code:
timeDisp=huge(timeDisp)  
Seems to give compilation problems when using xlf
It has been replaced by
timeDisp=huge(1.0_dp)  
 
modified:
  Src/SiestaXC/cellxc.f90 

------------------------------------------------------------------------------
2009-11-27  19:35:00 GMT  Jose A Torres <jtorres.sp@gmail.com>      trunk-316

Position of checking statement corrected in cellxc.f90 

The variable GGA was being used before being defined in 
SiestaXC/cellxc.f90. This modification fixes that bug. 
The following block:
"  if (present(dVxcdD) .and. GGA) &
    call die(errHead//'dVxcdD available only for LDA')
"
Has been moved to a new position, just after GGA has been defined.
 
modified:
  Src/SiestaXC/cellxc.f90 

------------------------------------------------------------------------------
2009-11-27  18:56:00 GMT  Jose A Torres <jtorres.sp@gmail.com>      trunk-315

Modularize efield and doping modules. Restructure CML interfaces. (From A. Garcia)

* The code in efield.F (now m_efield.F) has been split in several
  routines. 

* The code in doping.F has been split in several routines.

* Siesta_cml is now the main interface to CML in Siesta.
  Siesta_cmlsubs is a client of siesta_cml and only exports
  siesta_cml_init and siesta_cml_exit.
  
  For unknown reasons, it has been necessary to declare all the
  symbols in siesta_cml explicitly "public" and add the "private"
  global statement to avoid compiler crashes (intel V10) upon
  compiling several modules.  A number of explicit "only" clauses have
  been added to a few CML import statements in several modules.

removed:
  Src/efield.F
added:
  Src/m_efield.F
modified:
  Src/Makefile
  Src/dhscf.F
  Src/doping.F
  Src/post_scf_work.F
  Src/setup_hamiltonian.F
  Src/siesta_cml.f90
  Src/siesta_cmlsubs.F90
  Src/siesta_end.F
  Src/siesta_move.F
  Src/state_init.F
  
------------------------------------------------------------------------------
2009-11-27  18:45:00 GMT  Jose A Torres <jtorres.sp@gmail.com>      trunk-314

Fix test scripts for correct executable path (From A. Garcia)

* Some scripts in Tests/Scripts still referred to the old "Src"-style
  siesta executable.

* Tests/test.mk had a path to the executable which assumed that it ran
  under the default Obj directory.

modified:
  Tests/Scripts/matterhorn-gm.sge
  Tests/Scripts/matterhorn-mpich.sge
  Tests/Scripts/nano.pbs
  Tests/Scripts/nano4.sh
  Tests/Scripts/simple_parallel.sh
  Tests/test.mk
  
------------------------------------------------------------------------------
2009-11-25  09:34:00 GMT  Jose A Torres <jtorres.sp@gmail.com>      trunk-313

siestaXC.f90 renamed siestaxc.f90 (From J. Soler)

To avoid case ambiguities, that cause compilation problems, the name of file
siestaXC.f90 has been renamed as siestaxc.f90

renamed:
  Src/SiestaXC/siestaXC.f90 => Src/SiestaXC/siestaxc.f90
modified:
  Src/SiestaXC/lib-00-README  ! siestaXC.mod -> siestaxc.mod
  Src/SiestaXC/lib-makefile   ! siestaXC.f90,o -> siestaxc.f90,o
  Src/SiestaXC/makefile       ! siestaXC.f90,o -> siestaxc.f90,o

------------------------------------------------------------------------
2009-11-23  09:54:00 GMT Jose A Torres <jtorres.sp@gmail.com>    trunk-312

Support for the Armiento and Mattson's  functional added (From J. Gale)

Support for the AM05 functional has been added to routines in SiestaXC 
and Pseudo. This is done using the AM05 subroutines distributed by 
Armiento and Mattson, under the terms of the conditions contained within 
the header to their software allowing modification and redistribution 
provider the original copyright header remains. 

A new module, am05, contained within the file SiestaXC/am05.f90, has been 
added containing the code from Armiento and Mattsson. Within ggaxc.f90 
a wrapper has been added, am05xc, to pass the variables from ggaxc to 
am05 subroutines and handle the return arguments appropriately. 

In the atom program the two-letter symbol "am" has been added for AM05.
In SIESTA the GGA Authors are "AM05".

A test of the AM05 functional added in h2o_am05.

added:
  Pseudo/atom/am05.f
  Src/SiestaXC/am05.f90
  Tests/Pseudos/H_am05.psf
  Tests/Pseudos/O_am05.psf
  Tests/Reference/h2o_am05.out
  Tests/h2o_am05/
  Tests/h2o_am05/README
  Tests/h2o_am05/h2o_am05.fdf
  Tests/h2o_am05/h2o_am05.pseudos
  Tests/h2o_am05/makefile
modified:
  Docs/siesta.tex
  Pseudo/atom/Docs/atom.tex
  Pseudo/atom/pseudoXML.f
  Pseudo/atom/velect.f
  Src/Makefile
  Src/SiestaXC/atomxc.f90
  Src/SiestaXC/cellxc.f90
  Src/SiestaXC/ggaxc.f
  Src/SiestaXC/makefile
  Src/SiestaXC/siestaXC.f90
  Src/SiestaXC/xcmod.f90
  Src/atom.f
  
------------------------------------------------------------------------
2009-11-10  20:30:00 GMT Jose M Soler <jose.soler@uam.es>      trunk-311

Avoid repetition of routine name in allocation report

Since the introduction of the routine name in the allocation report, in
revno 301, some arrays appeared with a repeated routine name, since this
is also given in the array name. Also, the module name has been added in
calls to re_alloc, within module neighbour.

modified:
  Src/SiestaXC/atomxc.f90   ! Call to alloc_default commented out
  Src/SiestaXC/cellxc.f90   ! 'routine' removed from call to alloc_default
  Src/matel.f               ! 'routine' removed from call to alloc_default
  Src/mneighb.f             ! Module name used in calls to re_alloc
 

------------------------------------------------------------------------
2009-11-10 18:25:00 GMT Jose A. Torres <jtorres.sp@gmail.com>   trunk-310

Increased parameter nr in vdwxc, to avoid an out-of-bounds condition(J. Soler)

An out of bounds condition was occurring in vdwxc when called by atom
pseudopotential generation program. With ifort, this lead to program
crash or to an overflow of the system memory. To solve this, parameter 
nr been increased from 1024 to 2048, and a check has been added.

modified:
  Src/SiestaXC/vdwxc.f90   ! Parameter nr increased

------------------------------------------------------------------------
2009-11-10 17:59:00 GMT Jose A. Torres <jtorres.sp@gmail.com>   trunk-309

Clarification of the use of *_last geometry information (A. Garcia)

The variables xa_last (formerly xalast), ucell_last, and scell_last
are used to hold the information related to the last geometry for
which the electronic structure has been computed. This is necessary
since the "siesta_move" routine updates the geometry after every step.
By using the "*_last" variables instead of "xa", "ucell", and "scell",
we make sure that "siesta_analysis", when calculating the
polarization, optical properties, etc, uses the coordinates actually
used to compute the electronic structure.

The *_last variables are set at the beginning of "siesta_move", before
the actual displacements. Due to a bug in the program, however, this
was being done only at the final scheduled step ('fincoor'), instead
of inconditionally after every step. Thus they could be used undefined
if, for example, a relaxation finishes before the scheduled number of
steps (which is typical).

While fixing this bug, it became apparent that some other sections of
"siesta_analysis" are using the "predicted" coordinates (the output of
coordinates in various formats) instead of the last "used"
coordinates. This can be considered a feature or a bug.

Similarly, the computation of the spin polarization uses a density
matrix that is actually the result of a mixing after the last SCF
step.

(Fix prepared by A. Garcia after the discovery of the bug by J. Gale)

modified:
  Src/atomlist.f
  Src/born_charge.F
  Src/local_DOS.F
  Src/siesta_analysis.F
  Src/siesta_geom.F90
  Src/siesta_move.F
 
------------------------------------------------------------------------
2009-11-10  17:53:00 GMT Jose A. Torres <jtorres.sp@gmail.com> trunk-308

Fix bug in electric field initialization (J. Junquera)

When using the ExternalElectricField option (block), a bug prevented
the actual use of the field to generate the potential ramp on the grid
(but not the calculation of an extra contribution to the energy).


modified:
  Src/efield.F

------------------------------------------------------------------------
2009-11-06  19:34 GMT Jose A. Torres <jtorres.sp@gmail.com>     trunk-307

Error fixed for MPI_Waitall, Call to write_raw_efs limited to I/O node (J.Gale)

Introduced some patches from J.Gale's branch:

* Error in mpi_siesta.f90 fixed for MPI_Waitall. The interface had 
  the wrong set of arguments passed through.

    +     call MPI_WAITALL(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES, IERROR)
    ---
    -     call MPI_WAITALL(COUNT, ARRAY_OF_REQUESTS, INDEX, STATUS, IERROR)

* Call to write_raw_efs from state_analysis now limited to I/O node only.

    +       if (IOnode) call write_raw_efs(stress,na_u,fa,FreeE)
    ---
    -       call write_raw_efs(stress,na_u,fa,FreeE)

* Some comments changed in Src/m_timer.F90


modified:
  Src/MPI/mpi_siesta.f90   !  
  Src/m_timer.F90
  Src/state_analysis.F

------------------------------------------------------------------------
2009-11-03  11:15:00 GMT Jose M Soler <jose.soler@uam.es>      trunk-306
Correct number of orbital nodes with 'nodes' option

The (mainly obsolete) 'nodes' option for basis orbital generation was
producing orbitals with one excess radial node (i.e. one and two nodes
for double zeta, instead of zero and one node). Corrected.

A goto statement, out of a start-stop-timer piece of code, lead to
a program die within timer in some cases. Corrected.

modified:
  Src/atom.f        ! Radial nodes decresed for 'nodes' option
  Src/m_timer.F90   ! A small correction of output format
  Src/rdiag.F       ! Added call to stop_timer within rdiag3 section

------------------------------------------------------------------------
2009-10-15  21:00:00 GMT Jose M Soler <jose.soler@uam.es>      trunk-305
Match arguments between re_alloc and de_alloc calls

For a correct accounting of array allocations, both the 'name' and
'routine' arguments should be identical (including case sensitivity)
in the corresponding calls to re_alloc and de_alloc of an array.
The two arguments are combined into an internal name as 
trim(routine)//' '//name, so that (name='rho',routine='dhscf') 
is equivalent to (name='dhscf rho'). This is the name printed in
the allocation report.

When the array is allocated and deallocated in different subroutines, 
it is clearer not to use the 'routine' argument, or give it the value 
of the array 'owner' (for example its module name). 

Our most complicated case is that of arrays declared in one or more 
subroutines and allocated in a subroutine called by them (as done in
find_kgrid). In this case, the 'routine' name must be that of the
allocating subroutine, but the arrays of the different calling
routines will be reported as a single array. Thus, array kpoint of 
routine kpoint_grid and array kpoints_pdos of routine kpoint_pdos 
will be reported together as array points of routine find_kgrid.

I see no solution if more than one called subroutine (not in the 
same module) were allocating or deallocating an array, but there
is no such a case in siesta.

For the previous reasons, until now, only the 'name' argument was used.
But this made it difficult to identify the siesta routines allocating
many arrays. So from now on, the whole routine+name will be used.

The calls to printmemory have been commented out: its output has
become unrealistic, since most allocations occur in re_alloc and
they are no longer transmitted to routine memory.

modified:
  Src/SiestaXC/fft3d.f90
  Src/SiestaXC/mesh3d.F90
  Src/alloc.F90
  Src/atomlwf.F
  Src/bands.F
  Src/basis_types.f
  Src/bonds.f
  Src/cgvc_zmatrix.F
  Src/detover.F
  Src/dhscf.F
  Src/fft.F
  Src/find_kgrid.F
  Src/fire_optim.F
  Src/forhar.f
  Src/hsparse.f
  Src/kinefsm.f
  Src/ksv.f
  Src/m_broyden_mixing.f
  Src/m_fire_mixing.f
  Src/m_iodm.F
  Src/m_pulay.F
  Src/m_sparse.F
  Src/memory.F
  Src/meshmatrix.F
  Src/molecularmechanics.F90
  Src/moreParallelSubs.F90
  Src/new_dm.F
  Src/nlefsm.f
  Src/old_atmfuncs.f
  Src/outcoor.f
  Src/overfsm.f
  Src/pdos.F
  Src/pdosg.F
  Src/pdosk.F
  Src/pdoskp.F
  Src/phirphi.f
  Src/poison.F
  Src/pseudopotential.f
  Src/reord.f
  Src/rhoofd.f
  Src/rhoofdsp.f
  Src/savepsi.F
  Src/setup_hamiltonian.F
  Src/siesta_analysis.F
  Src/siesta_end.F
  Src/siesta_init.F
  Src/siesta_move.F
  Src/spher_harm.f
  Src/state_init.F
  Src/vmat.f
  Src/vmatsp.f
  Src/zm_broyden_optim.F
  Src/zm_fire_optim.F
  Src/zmatrix.F

------------------------------------------------------------------------
2009-10-13  08:05:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-304
Array indexp distributed among parallel processors (J. Soler)

* Array indexp translates the mesh index from the extended supercell
  to the part of unit cell stored locally by each node. It has been 
  distributed, so that now it translated to myBox from myExtBox, which
  are my processor's mesh box and the same box extended by lateral 
  'wings'.

* Documentation of meshsubs has been considerably extended


------------------------------------------------------------------------
2009-10-12  16:05:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-303
Add dependency line in SiestaXC. Add missing Supercell docs

* A dependency for timer.o was missing in the SiestaXC makefile, thus
breaking the multithreaded compilation ("make -j N") feature. (A. Walker)

* The documentation for the Supercell option had been inadvertently
  left out of the manual after the reorganization.

------------------------------------------------------------------------
2009-10-12  13:35:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-302
Assorted fixes after vdw merge

* Fix copy operation for modules in SiestaXC, to work around down-casing
  by Intel compiler and the possible need of visibility of included modules
  for other compilers.  (Thanks to A. Walker)

* Add XC dependency to TranSiesta compilation (F.D. Novaes)

* Wrap pre-broadcast section in rdiag (J. Gale)

* Trap for potential out of bounds access to string in m_timer.F90 (J. Gale)

* Format change in atomlist (J. Gale)
      
  Format of write statement modified to allow for the fact that the 
  number of orbitals and projectors is much larger than the number of
  atoms, often leading to overflow.

* License header update in SiestaXC directory.
* Use lib-arch.make to compile stand-alone library, for clarity.

------------------------------------------------------------------------
2009-10-05  14:15:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-301
New siestaXC library including van der Waals functional

Implementation of the non local van der Waals density functional 
of Dion et al (PRL 92, 246401 (2004), PRL 103, 096102 (2009)).

The codes for the new functional are 

XC.functional           VDW
XC.authors              DRSLL

in Siesta and 'vw' (or 'vf') in Atom.

All the exchange-correlation routines have been placed in a library
called siestaXC, whose unique entry point is module m_siestaXC. The
sources are in subdirectory Src/SiestaXC, whose makefile allows to
create a self-contained distribution in file siestaXC.tgz, that can
be used in programs other than siesta. The library sources that are
used by siesta also outside the library (like alloc.F90) remain in
Src, and are copied by SiestaXC/makefile into siestaXC.tgz.

The library is used to compile siesta itself, with a scheme similar
to that used for MPI, fdf and FoX. Pseudo/atom has been also adapted
to use the siestaXC library.

The implementation of the non local van der Waals density functional
has led to a whole rewritting of cellxc and a major one of atomxc.
File xc has been splitted in m_atomxc, m_ldaxc, and m_ggaxc, which
are now modules. The VDW-specific routines are in module m_vdwxc.

The new parallelization of cellxc has led to several new modules, of
which mesh3d is the largest one. It allows new distributions of mesh
points among processors, that can change dynamically. Other relevant
modules are fftr, for 3-D FFTs of real functions. fft3d has changed
to allow (complex) 3-D FFTs using the new distributions of mesh points.
Module mesh1d provides radial (1-D) mesh utilities. Module m_debugXC
writes reports debugXC.node$$ with details of mesh distributions.

The new m_timer module, together with changes in MPI/mpi_siesta, allows
the profiling of MPI communication times, for each routine that calls 
timer, after compiling with -DMPI_TIMING. Routine timer itself remains 
external, but it uses m_timer operationally.

The full accounting and reporting of allocated arrays is now done in
module alloc, and printed in (SystemLabel).alloc. The old 'memory'
routine now passes information to alloc for this accounting, rather
than the other way around. Therefore, the 'total' allocation sizes
given by memory routine are no longer complete, though they are still
printed.

(Jose Soler (UAM), with help by Alberto Garcia (ICMAB), Rogeli Grima
(BSC) , and Jose Maria Cela (BSC))


------------------------------------------------------------------------
2009-09-29  10:30:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-300
TranSiesta updates. Assorted fixes and cleanup. Update outputs and banner.

* Make local copy of reinit in Util/Denchar
* Add comment to the manual re: MeshSubDivisions
* Put unit of current in tbtrans. Updated outputs in Tests/transiesta
* Merge changes to TS code by F. Novaes
* Change Copyright dates. Now they are of the form 1996- 
* Remove xmlparser/Test directory. Remove test-xml fossils
* Update out and xml reference files. Update Tests/Makefile
* Fix script.mk and Tests/partial/script.sh

------------------------------------------------------------------------
2009-09-29  10:30:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-299
Update of TS section of manual. Assorted fixes.

* Update of the TranSiesta section of the manual (P. Ordejon, F. Novaes)

* Fixes and streamlined compilation of tbtrans program in Util/TBTrans
  (F. Novaes, A. Garcia)

* Update of 'doping' routine for doped slabs (P. Ordejon)

* New 'si2x1h-dipole' test for the dipole correction feature (P. Ordejon)

* Fixes to the building system (A. Walker, A. Garcia)

* Fixes in 'bands.F' routine (A. Walker, J. Gale)

* Added Util/WFS/info_wfsx.f program (A. Garcia)

* New utility Util/Helpers/get_chem_labels (A. Garcia)

* Added zero-point-motion to Util/Vibra/Src/vibrator.f (J. Gale)

* Fix to avoid the handling of 'reduced_vlocal' when reading .ion files.
  (A. Garcia)

* Remove obsolete files from Src/fdf and clarify usage (A. Garcia)
 
------------------------------------------------------------------------
2009-09-11  11:30:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-298
Re-organization of the manual. Building fixes. Update of Contrib utils

* The manual has been thoroughy re-sectioned, and some obscure points
clarified.

* In some cases, it has been necessary to make minor changes to the
code to be consistent with the behavior implied by the manual:

-- The forces file (.FA) is always created.  

-- There is no longer a coupling of the WriteCoorStep and WriteMDXMol
   options.

* Fix of the long-standing "mis-feature/bug" in the generation of
  perturbative polarization orbitals. The fix is turned off by
  default, unless the variable PAO.OldStylePolOrbs is set to
  ".false.".  (See manual.)

* Changes to streamline compilation, and new version of
  the arch.make template in Src/Sys/DOCUMENTED_TEMPLATE.make
  There are minor changes needed in arch.make files:

  -  Use of NETCDF_INCFLAGS instead of simply INCFLAGS
  -  Deprecation of the use of DEFS instead of FPPFLAGS

  A new Util/build_all.sh script automates the building
  of all the utility programs.

* Simplification of TranSiesta compilation:

      The target "transiesta" in the makefile defines its
      own -DTRANSIESTA pre-processor flag, so the user does
      not need to worry about it.
      
      Additionally, the makefile checks whether the last
      compilation taking place in the building directory
      was a "plain siesta", or a "transiesta", and complains
      in case of a mismatch. 

* Removal of all remaining mentions to the "Src" directory in the
  automated tests in Tests.

* Update of Andrei Postnikov's utilities in Util/Contrib/APostnikov to
  V. 0.3, and integration into the standard building mechanism.

(Alberto Garcia, with help from E. Artacho, J. Soler, O. Dieguez, and
J. Junquera.  The polarization-orbital fix is due to E. Anglada.)


------------------------------------------------------------------------
2009-09-02  13:50:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-297
Code to treat slabs with net dipole and charged slabs (P. Ordejon)

If the FDF option 'SlabDipoleCorrection' is set to "true", Siesta
calculates the electric field required to compensate the dipole of the
system. The potential added to the grid corresponds to that of a
dipole layer at the middle of the vacuum layer. For slabs, this
exactly compensates the electric field at the vacuum, created by the
dipole moment of the system, thus allowing to deal with asymmetric
slabs (including systems with an adsorbate on one surface) and compute
properties such as the work funcion of each of the surfaces.

The FDF option SimulateDoping, if "true", instructs the program to add
a background charge density to simulate doping.  The new "doping"
routine calculates the net charge of the system, and adds a
compensating background charge that makes the system neutral. This
background charge is constant at points of the mesh near the atoms,
and zero at points far from the atoms.  This simulates situations like
doped slabs, where the extra electrons (holes) are compensated by
oposite charges at the material (the ionized dopant impurities), but
not at the vacuum.  This serves to simulate properly doped systems in
which there are large portions of vacuum, such as doped slabs.

New test: sic-slab

During the implementation of these features, a bug related to the 
calculation of the distance between Bravais planes was discovered
and fixed in efield.

------------------------------------------------------------------------
2009-08-30  17:15:00 GMT Alberto Garcia <albertog@icmab.es>    trunk-296
TS manual and updates. Building rationalization. Hsparse speedup

* Added TranSIESTA sections to the manual (Docs/siesta.tex) (by
  J.A. Torres).

* TranSIESTA and TBTrans updates (by F.D. Novaes):

- Reimplementation of getGF_Tri, that obtains the Green's Function
 using the fact that the Hamiltonian is tridiagonal.

- Fixed the generation of listudg in the transiesta routine
 (m_ts_in_siesta.F).  Now, when the TS.UpdateDMCR is set to
 .false. the cross terms between the electrodes and the contact region
 of the density matrix are also updated in the TS iteration
 process. If set to .true., only the elements of the contact region
 are changed during the self consistent cycle.

- In weightDM and weightDMC (m_ts_scattering.F), changed the weights
 of the cross terms elements, since when using Tri_Diag the
 non-equilibrium contributions are zero the way it used to be.

- In new_dm.F, added a condition that does not sets the energy-density
 matrix to zero in the first iteration of the SCF cycle.

- (with A. Garcia) New building scheme for TBTrans.

* Building rationalization (by A. Garcia):

- Move auxiliary programs from Src to individual directories in Util

 -- gen-basis and ioncat now live in Util/Gen-basis
 -- mixps and fractional have been moved to Util/VCA
 -- The programs to test the MPI installation are now in Util/MPI_test

- Update building mechanisms in Util/STM

(Some of the above building improvements use new functionality in
the fdf and MPI makefiles that allows these modules to be compiled in
"private subdirectories" anywhere: see Denchar and TBTrans for examples.)

* Hsparse has been dramatically speeded-up by removing a superfluous
  inner loop (by A. Garcia).

* Other updates to the manual by A. Garcia
 

** CHANGES ALONG siesta-2.6 series of trunk

-----------------------------------------------------------------------
2009-08-20  09:25:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.32
Documentation updates. Building and cosmetic fixes. Eggbox checker.

* Added a draft of release_notes_3.0

* New experimental directory Docs/ExtraDocs containing files with
  information relevant to a specific feature. They should complement
  the "manual", which is really a reference manual and not very useful
  for feature discovery. This is work in progress and subject to major
  changes.

* Updated the content of a number of README files.

* Updated several sections of Docs/siesta.tex.

* Created new Util/test-xml directory to keep a separate version of
  the XML checker.

* New Util/Scripting/eggbox_checker.py script for eggbox diagnostics.

* Added Src/Sys/DOCUMENTED-TEMPLATE.make to help users with the subtle
  points of arch.make generation. More documentation about the
  building process in several places.

* Warn about deprecation of PHONON interface.

* Update siesta.tex with DM reuse information. Better header
  information in new_dm.F. Remove references to iodm in Siesta
  files. It is still needed for some utility programs.

* Clarify target of 'goto' in atomlwf (this was a bug introduced in
  previous patches).

* Give the Src/obj_setup.sh the ability to override the Src link in
  the object directory. Now it should be possible to completely update
  the object directory even if it moves.

* Proper test for gfortran macros
  
  gfortran now defines the __GFORTRAN__ macro, so it is 
  no longer necessary to define GFORTRAN in makefiles, but
  it is still supported. The proper idiom for the gfortran 
  test in f2kcli is now:
  
  #if  !defined(GFORTRAN) && !defined(__GFORTRAN__)

* Removed the Src/filter debug directory.

* Updates to some makefiles and many cosmetic fixes.

-----------------------------------------------------------------------
2009-08-14  16:20:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.31
Speed-up of density-matrix building in diagk

By computing only the products of eigenvector components which are
really needed, the building of the density-matrix has been
significantly speeded-up in diagk.  A similar idea can be applied in
diagkp and diag2k (here saving in memory too), but these are not
implemented yet.

NOTE that the diagk_file version of the routine is still significantly
faster, and should be the method of choice when NetCDF is compiled in.

modified:
  Src/diagk.F

-----------------------------------------------------------------------
2009-08-07  16:20:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.30
Assorted fixes, dealing mostly with the building system

* (IMPORTANT) The default building directory is now Obj, instead of Src.
  This change is necessary to support multiple compilation with the
  same source. See Obj/README for more details.

* Many fixes to smooth compilation in several systems, notably on IBM
  computers. 

* The default makefile in Pseudo/atom is now the 'modern' version with
  CML support.

* Clearer diagnostics in case of FoX configuration problems. 

* Removed obsolete .make files from Src/Sys. Added 64bit versions of
  the MareNostrum files.

* The 'MaximumWallClockTime' option is no longer available.

* Fixes in the NetCDF iodm* routines to properly handle a pointer.

removed:
  Src/Sys/eth-hreidar-mpi.make
  Src/Sys/lahey-lam.make
  Src/Sys/lahey-mpich.make
  Src/Sys/lahey-nolibs.make
  Src/Sys/lahey.make
  Src/Sys/osfdxml-mpich.make
  Src/Sys/osfdxml.make
  Src/Sys/osfdxmlcdf.make
  Src/Sys/pgf90-lam.make
  Src/Sys/pgf90-mpich.make
  Src/Sys/pgf90-nolibs.make
  Src/Sys/pgf90.make
  Src/Sys/sgi-altix.make
  Src/Sys/sgi.make
  Src/Sys/sgi64-cdf.make
  Src/Sys/sgi64-lam-cdf.make
  Src/Sys/sgi64-lam.make
  Src/Sys/sgi64-mpi_fermat.make
  Src/Sys/sgi64-mpich-cdf.make
  Src/Sys/sgi64-mpich.make
  Src/Sys/sgin32-mpi.make
  Src/Sys/sun-nolibs.make
  Src/Sys/t3e.make
  Util/COOP/precision.f
added:
  Obj/
  Obj/README
  Src/Sys/marenostrum-mpi-64.make
  Src/Sys/marenostrum-mpi-netcdf-64.make
renamed:
  Pseudo/atom/makefile => Pseudo/atom/makefile-old
  Pseudo/atom/makefile-xml => Pseudo/atom/Makefile
  Src/Sys/marenostrum-mpi.make => Src/Sys/marenostrum-mpi-32.make
  Util/COOP/sys.f90 => Util/COOP/sys_local.f90
  Util/Vibra/Vibra/ => Util/Vibra/Src/
modified:
  Docs/siesta.ind
  Docs/siesta.tex
  Src/FoX/configure
  Src/Makefile
  Src/Sys/README
  Src/Sys/cscs-cray-mpi.make
  Src/Sys/cscs-cray.make
  Src/Sys/cscs-ibm-blanc.make
  Src/Sys/finisterrae.make
  Src/Sys/marenostrum-mpi-netcdf-32.make
  Src/iodm_netcdf.F90
  Src/iodmhs_netcdf.F90
  Src/molecularmechanics.F90
  Src/obj_setup.sh
  Src/siesta_options.F90
  Src/timer.F
  Util/COOP/Makefile
  Util/COOP/mprop.f90
  Util/Denchar/Src/Makefile
  Util/DensityMatrix/makefile
  Util/Grid/makefile
  Util/Projections/makefile
  Util/Vibra/Src/Makefile
  Util/WFS/makefile
  Util/pdosxml/makefile
  Util/pseudo-xml/makefile
  Pseudo/atom/makefile-old
  Pseudo/atom/Makefile
  Src/Sys/marenostrum-mpi-32.make

-----------------------------------------------------------------------
2009-07-03  14:00:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.29
TranSiesta: New saving options and file format (M. Paulsson, F.D. Novaes)

  * Changed format and filenames for saved TSHS files.
  * Enabled transiesta to save a TSHS file for each step in a FC run.
  * Transiesta keyword TS.onlyS (T/F) to save overlap matrix in .TSHS
  file format and quit without any SCF cycle.
  * New "onlyS" option to stop after generating the overlap matrix.
  * Disabled proximity check for onlyS run.

(+ Fix a few glitches in FoX-enabled compilation of TranSiesta)

Thanks to M. Paulsson and F.D. Novaes for this patch.

** NOTE: The Intel compiler V. 11.{0,1} does not compile correctly
         this version.
         
removed:
  Util/TBTrans/TSiohs2.F
modified:
  Src/Makefile
  Src/m_ts_electrode.F90
  Src/m_ts_io.F90
  Src/m_ts_options.F90
  Src/proximity_check.F
  Src/setup_hamiltonian.F
  Src/siesta_forces.F
  Src/state_init.F
  Src/write_subs.F
  Util/TBTrans/Makefile
  Util/TBTrans/TSiohs.F
  Util/TBTrans/work.pcl


-----------------------------------------------------------------------
2009-06-24  12:50:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.28
Update of CMLComp output. Integration of FoX library (A. Walker, T. White)

A subset of the FoX library has been integrated into the source tree.
It is configured and built by the Siesta Makefile, and is compatible
with the use of VPATH for multiple compilation.

The XML output from Siesta now conforms to the CMLComp subset of
version 2.2 of the Chemical Markup Language (CML).

A new directory Util/CMLComp has been created to hold the ccViz tool
to convert the XML output file into an XHTML file that can be opened
with any browser.

FoX is also used (optionally) by atm to produce pseudopotential files
in XML format, replacing the older wxml library by A. Garcia.

Thanks to Andrew Walker and Toby White for most of the technology
involved in this patch. A. Garcia fixed a few issues of the
interaction of FoX with the rest of the build process.

NOTE: The output reference XML files in Tests/Reference-xml have
been updated. A review of the test list and a final check is due
before release.


-----------------------------------------------------------------------
2009-06-24  12:25:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.27
Fix TranSiesta compilation issue after recent patches (F.D. Novaes)

A compilation error occurred because "found" variable is no longer used
in mixer.F (chages in io of density matrix)
  
Made "found" an optinal argument in TSiodm of the m_ts_io.F90 module.
     
In new_dm.F, in the call for TSiodm made explicit the use of the
optional "found", since it is used to determine if it should start
with a TS calculation, or a diagon calcualtion.
 
In mixer.F, the call for TSiodm no longer uses the "found" variable.
  
modified:
  Src/m_ts_io.F90
  Src/mixer.F
  Src/new_dm.F


-----------------------------------------------------------------------
2009-06-24  12:15:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.26
Fix behavior of extra pdos sampling for gamma case

The new "extra sampling" feature for the PDOS
incorrectly changed the behavior of the program for
gamma-only calculations. Now "gamma_pdos" is set to
.true. if the user does not specify any extra
sampling requirements.

Thanks to Jaime Ferrer for spotting the bug.

modified:
  Src/kpoint_pdos.F90

-----------------------------------------------------------------------
2009-06-15  12:45:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.25
Fix bug in verlet restart in parallel (A. Aguado)

The variable old_dt was read by Node zero from the VERLET_RESTART
file, but was not broadcast to the other nodes.

Symptoms of this bug were crashes with a Cholesky-type error, poor
energy conservation, and bad self-consistency of the density matrix
when running restarted microcanonical simulations in parallel.

Thanks to Andres Aguado <aguado@metodos.fam.cie.uva.es>
for diagnosing and fixing the bug.

modified:
  Src/dynamics.f

-----------------------------------------------------------------------
2009-06-15  12:45:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.24
Fixes: denchar, pathscale_mpi. DM(HS) history files. Makefiles

* Added nano .make and script files. Fixed ag test.

- The ag test had a very small MeshCutoff, and crashed.
- Added netCDF-enabled .make file for nano.
- Updated README file in Src/Sys
- Added pbs and sh scripts for test execution on nano.

* More complete DM and DMHS history files

The DM and DMHS history files have now names of
the form DM-NNNN.nc and DMHS-NNNN.nc, respectively,
to hold information for all geometry steps. This
expanded history option is turned off by default.

(+ experimental analysis scripts in Util/SCF)

* Better makefiles for some Util subdirectories

The WFS, DensityMatrix, and pseudo-xml subdirectories
of Util now have makefiles instrumented to use the
new OBJDIR variable.

* Cosmetic fix for Pathscale MPI

File mpi.F was not processed correctly by the Pathscale compiler.

* Fix double empty-line bug in denchar

The 2D data files contained extra blank lines in between blocks.

* Proper citation for ATOM in Pseudo/atom/README


added:
  Src/Sys/nano-intel-mpi-cdf.make
  Tests/Scripts/nano.pbs
  Tests/Scripts/nano4.sh
  Util/SCF/README
  Util/SCF/g_dm.py
  Util/SCF/g_dm3.py
  Util/SCF/g_els_out.py
  Util/SCF/g_hh.py
  Util/SCF/g_hist.py
  Util/WFS/makefile
modified:
  Docs/siesta.ind
  Docs/siesta.tex
  Pseudo/atom/README
  Src/MPI/mpi.F
  Src/Sys/README
  Src/iodm_netcdf.F90
  Src/iodmhs_netcdf.F90
  Src/state_init.F
  Tests/ag/ag.fdf
  Util/Denchar/Src/rhoofr.f
  Util/DensityMatrix/makefile
  Util/pseudo-xml/makefile
  version.info


-----------------------------------------------------------------------
2009-06-15  11:00:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.23
Implementation of PBEsol functional (J. Gale)

Implemented the PBE functional for solids of Perdew et al, PRL 100,
136406 (2008).

The xc_authors string in Siesta is 'PBEsol'.  In atom, the two-letter
symbol is 'ps'

The XML interface in Pseudo/atom and the converter in Util/pseudo-xml
have been updated.

  Docs/siesta.tex
  Pseudo/atom/Docs/atom.tex
  Pseudo/atom/makefile-xml
  Pseudo/atom/pseudoXML.f
  Pseudo/atom/velect.f
  Pseudo/atom/xc.f
  Src/atom.f
  Src/xc.f
  Util/pseudo-xml/xml2psf_helper.f

-----------------------------------------------------------------------
2009-06-15  11:00:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.22
Optional k-point sampling for PDOS calculations (J. Gale)

Separate grid of K-points introduced for PDOS so that greater
resolution can be achieved.  To do this, a new module based on the SCF
kpoint module has been introduced with separate data structures for
the PDOS k-points. In the case that no PDOS grid is specified then the
SCF grid is used as present.

Handle the case where a gamma point calculation is performed for the
SCF and then a non-gamma calculation is requested for the PDOS
evaluation. Here the need for the auxiliary cell is trapped in
siesta_init by a call to the new routine init_projected_dos.  If
do_pdos is true, then the gamma flag is set to be false if gamma_pdos
is false.

Note added to the manual to suggest that PDOS evaluations be performed
using a restart if the SCF case involves the gamma point while the
PDOS grid involves general k-points.

(AG added the si_pdos_kgrid test)

added:
  Src/kpoint_pdos.F90
  Tests/Reference-xml/si_pdos_kgrid.xml
  Tests/Reference/si_pdos_kgrid.out
  Tests/si_pdos_kgrid/
  Tests/si_pdos_kgrid/makefile
  Tests/si_pdos_kgrid/si_pdos_kgrid.fdf
  Tests/si_pdos_kgrid/si_pdos_kgrid.pseudos
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/projected_DOS.F
  Src/siesta_init.F

-----------------------------------------------------------------------
2009-05-07  10:35:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.21
Parallel fixes: Diag.ParallelOverK for wf generation; idle nodes

* Patches in diagg and diagk for the corner case in which a node has no 
assigned orbitals (Julian Gale).

* The option to parallelize over k-points is only implemented for the
SCF loop. The bands routine had already been coded to fall back on the
standard parallelization over orbitals, but the wwave routine (used to
generate wavefunctions for analysis) had not. This bug has been
corrected, and now both routines print a warning to the user when the
Diag.ParallelOverK option is used.

modified:
  Src/bands.F
  Src/diagg.F
  Src/diagk.F
  Src/writewave.F
  Docs/siesta.tex
  Docs/siesta.ind

-----------------------------------------------------------------------
2009-04-02  12:55:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.20
More flexible compilation of Util code

By a simple change to the makefiles (involving an OBJDIR variable that
can be set to "Src" or to the name of the optional compiler-dependent
object directory), the code in Util can be compiled with multiple
options.

The use of VPATH within Util also allows the re-use of common utility
files such as f2kcli.F90.

Work in progress. Really a temporary solution util Util is integrated in
the architecture-or-compiler-dependent object directories.

+ The pdos program in Util/pdosxml has been renamed to pdosxml.

removed:
  Util/COOP/f2kcli.F90
  Util/pdosxml/f2kcli.F90
added:
  Util/Projections/makefile
renamed:
  Util/pdosxml/pdos.f90 => Util/pdosxml/pdosxml.f90
modified:
  Util/COOP/Makefile
  Util/Grid/makefile
  Util/Vibra/Vibra/Makefile
  Util/Vibra/Vibra/vibrator.f
  Util/pdosxml/README
  Util/pdosxml/makefile
  Util/pdosxml/pdosxml.f90

-----------------------------------------------------------------------
2009-04-02  12:50:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.19
New version of denchar in Util/Denchar

A new version of denchar, able to process complex wavefunctions and
multiple k-points, has been put back in the Util/Denchar/Src directory.
It can be compiled by re-using code in the top Src directory. 

(Thanks to Pablo Ordejon)

removed:
  Src/denchar.F
  Src/m_denchar_geom.f
  Src/m_denchar_init.F
  Src/m_denchar_io.F
  Src/m_denchar_neighb.f
  Src/m_denchar_work.f
  Util/Denchar/README-Source
added:
  Util/Denchar/Src/
  Util/Denchar/Src/Makefile
  Util/Denchar/Src/README
  Util/Denchar/Src/atompla.f
  Util/Denchar/Src/colinear.f
  Util/Denchar/Src/denchar.f
  Util/Denchar/Src/fdf/
  Util/Denchar/Src/fdf/makefile
  Util/Denchar/Src/itochar.f
  Util/Denchar/Src/length.f
  Util/Denchar/Src/matvect.f
  Util/Denchar/Src/neighb.f
  Util/Denchar/Src/planed.f
  Util/Denchar/Src/ranger.f
  Util/Denchar/Src/readpla.f
  Util/Denchar/Src/readsts.f
  Util/Denchar/Src/readwaves.f
  Util/Denchar/Src/redata_denchar.f
  Util/Denchar/Src/reinit.f
  Util/Denchar/Src/rhoofr.f
  Util/Denchar/Src/stsofr.f
  Util/Denchar/Src/wavofr.f
  Util/Denchar/Src/wrout.f
modified:
  Docs/siesta.tex
  Src/Makefile
  Util/Denchar/Docs/CHANGES
  Util/Denchar/Docs/denchar.tex


-----------------------------------------------------------------------
2009-04-02  12:45:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.18
Added general-purpose optimizer in Util/Optimizer

Alpha version of the general-purpose optimization program, useful,
among other things, for pseudopotential and basis-set generation.

added:

  Util/Optimizer/
  Util/Optimizer/Examples/
  Util/Optimizer/Examples/Basis-Optim-Bond/
  Util/Optimizer/Examples/Basis-Optim-Bond/H.psf
  Util/Optimizer/Examples/Basis-Optim-Bond/O.psf
  Util/Optimizer/Examples/Basis-Optim-Bond/SWARM_PARAMS
  Util/Optimizer/Examples/Basis-Optim-Bond/TEMPLATE
  Util/Optimizer/Examples/Basis-Optim-Bond/VARS
  Util/Optimizer/Examples/Basis-Optim-Bond/run_script.sh
  Util/Optimizer/Examples/Basis_Harris/
  Util/Optimizer/Examples/Basis_Harris/DeltaRho.grid.nc
  Util/Optimizer/Examples/Basis_Harris/H.psf
  Util/Optimizer/Examples/Basis_Harris/O.psf
  Util/Optimizer/Examples/Basis_Harris/PARAMS
  Util/Optimizer/Examples/Basis_Harris/README
  Util/Optimizer/Examples/Basis_Harris/TEMPLATE
  Util/Optimizer/Examples/Basis_Harris/VARS
  Util/Optimizer/Examples/Basis_Harris/run_script.sh
  Util/Optimizer/Examples/Basis_Optim/
  Util/Optimizer/Examples/Basis_Optim/H.psf
  Util/Optimizer/Examples/Basis_Optim/O.psf
  Util/Optimizer/Examples/Basis_Optim/PARAMS
  Util/Optimizer/Examples/Basis_Optim/README
  Util/Optimizer/Examples/Basis_Optim/TEMPLATE
  Util/Optimizer/Examples/Basis_Optim/VARS
  Util/Optimizer/Examples/Basis_Optim/run_script.sh
  Util/Optimizer/Examples/Basis_Optim_Accel/
  Util/Optimizer/Examples/Basis_Optim_Accel/DeltaRho.grid.nc
  Util/Optimizer/Examples/Basis_Optim_Accel/H.psf
  Util/Optimizer/Examples/Basis_Optim_Accel/O.psf
  Util/Optimizer/Examples/Basis_Optim_Accel/PARAMS
  Util/Optimizer/Examples/Basis_Optim_Accel/README
  Util/Optimizer/Examples/Basis_Optim_Accel/TEMPLATE
  Util/Optimizer/Examples/Basis_Optim_Accel/VARS
  Util/Optimizer/Examples/Basis_Optim_Accel/run_script.sh
  Util/Optimizer/Examples/Pseudo-Optim-Constrained/
  Util/Optimizer/Examples/Pseudo-Optim-Constrained/PARAMS
  Util/Optimizer/Examples/Pseudo-Optim-Constrained/PSGEN.TEMPLATE
  Util/Optimizer/Examples/Pseudo-Optim-Constrained/README
  Util/Optimizer/Examples/Pseudo-Optim-Constrained/SWARM_PARAMS
  Util/Optimizer/Examples/Pseudo-Optim-Constrained/Test.inp
  Util/Optimizer/Examples/Pseudo-Optim-Constrained/VARS
  Util/Optimizer/Examples/Pseudo-Optim-Constrained/run_script.sh
  Util/Optimizer/Makefile
  Util/Optimizer/README
  Util/Optimizer/amoeba.f
  Util/Optimizer/io.f
  Util/Optimizer/minimizer.f90
  Util/Optimizer/parse.f
  Util/Optimizer/precision.f90
  Util/Optimizer/simplex.f90
  Util/Optimizer/swarm.f90
  Util/Optimizer/sys.f
  Util/Optimizer/vars_module.f90

-----------------------------------------------------------------------
2009-04-02  12:40:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.17
New utility programs and features 

* Orbital projection program

Integrated a new version of the "orbmol" program, by Rurali and
Lorente, including the k-points functionality later implemented by
Tabares and Ordejon. The program is now called "orbmol_proj", and
is more economical in memory and hopefully run-time. 

The program uses the new WFSX wavefunction format (the new program
wfs2wfsx.f can be used for legacy data).

* New tool for creation of partial density matrices

A new program 'dm_creator' has been created in Util/COOP.
Given an HSX and a WFSX file, and an optional energy range, dm_creator
computes a "partial density matrix" with only those states in the
energy range. This density matrix can then be used with Denchar
for plotting (or for other more or less devious applications...)

* Scripting

- New cutoff.py example script
- Enhancements to the ASE interface:
     - "copy" method for Atom class
     - pseudopotential handler for ListOfAtoms

* Enhanced WFS utilities

The wavefunction-handling programs have been moved to Util/WFS. Added
wfsnc2wfsx (useful for New-Diagk calculations) and wfs2wfsx.

* Enhanced grid utilities in Util/Grid

- Increase bounds of work array in Util/Grid/libfft.f
- Added octave/matlab scripts for plane averages

* New Util/HSX directory

Up to now it only contains an experimental module hsx_m.f90 to process HSX files.

* New program dm_filter in Util/DensityMatrix

The DM filter program produces a new density-matrix in which only the
contributions of specified orbitals are retained (with minor modifications it can
delete those and keep the rest).

added:
  Util/COOP/dm_creator.F90
  Util/COOP/iodm_netcdf.F90
  Util/COOP/write_dm.f
  Util/DensityMatrix/README
  Util/DensityMatrix/dmfilter.f90
  Util/Grid/average_x.m
  Util/Grid/average_z.m
  Util/HSX/
  Util/HSX/hsx_m.f90
  Util/Projections/
  Util/Projections/Example/
  Util/Projections/Example/Na-on-Na-4A/
  Util/Projections/Example/Na-on-Na-4A/Na.psf
  Util/Projections/Example/Na-on-Na-4A/coo.gplot
  Util/Projections/Example/Na-on-Na-4A/coo.mpr
  Util/Projections/Example/Na-on-Na-4A/molecule.fdf
  Util/Projections/Example/Na-on-Na-4A/orbmol.gplot
  Util/Projections/Example/Na-on-Na-4A/orbmol.input
  Util/Projections/Example/Na-on-Na-4A/pdos.mpr
  Util/Projections/Example/Na-on-Na-4A/system.fdf
  Util/Projections/Example/Na-on-Na-6A/
  Util/Projections/Example/Na-on-Na-6A/Na.psf
  Util/Projections/Example/Na-on-Na-6A/coo.gplot
  Util/Projections/Example/Na-on-Na-6A/coo.mpr
  Util/Projections/Example/Na-on-Na-6A/molecule.fdf
  Util/Projections/Example/Na-on-Na-6A/orbmol.gplot
  Util/Projections/Example/Na-on-Na-6A/orbmol.input
  Util/Projections/Example/Na-on-Na-6A/pdos.mpr
  Util/Projections/Example/Na-on-Na-6A/system.fdf
  Util/Projections/README
  Util/Projections/orbmol_proj.f90
  Util/Scripting/cutoff.py
  Util/WFS/
  Util/WFS/wfs2wfsx.f
  Util/WFS/wfsnc2wfsx.f90
renamed:
  Util/readwf.f => Util/WFS/readwf.f
  Util/readwfx.f => Util/WFS/readwfx.f
  Util/wfsx2wfs.f => Util/WFS/wfsx2wfs.f
modified:
  Src/diagk_file.F
  Src/iowfs_netcdf.F90
  Util/COOP/Makefile
  Util/COOP/README
  Util/COOP/io_hs.f90
  Util/COOP/mprop.f90
  Util/COOP/subs.f90
  Util/DensityMatrix/cdf2dm.f90
  Util/DensityMatrix/dm2cdf.f90
  Util/DensityMatrix/makefile
  Util/Grid/libfft.f
  Util/Scripting/Siesta/Interface.py


-----------------------------------------------------------------------
2009-04-02  11:00:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.16
Assorted new (small) features

* Write Neutral-atom potential on the grid

If the fdf symbol SaveNeutralAtomPotential is set to 'True', the neutral-atom
potential is written to file SystemLabel.VNA (and optionally to Vna.grid.nc)
This feature is exercised in the h2o test.

* Warnings for multiple images at Gamma, with optional forcing of supercell

For a gamma-point calculation, it is still possible to have overlap of multiple
images. This could be because the cell is not big enough, if the user wants
to save CPU time and sacrifice a bit of accuracy.

This is harmless for the calculation of the electronic structure, as the program
just adds up all the relevant matrix elements, with phase factor 1.

For a COOP/COHP calculation, the resulting xij array is *wrong*, as
only the vector for one representative of the class of interactions is
kept. Thus a warning is produced by hsparse.

A new fdf symbol, "ForceAuxCell", has been introduced to allow the user to 
request a (more expensive) "k-point" calculation with an auxiliary cell if
needed. At this point, the very first iteration might give different results,
since the initial normalization of the density-matrix is different.

* Update the Src/ioncat.f program

It can now process the core charge and the charge associated to the
local pseudopotential

* Write also a (new format) HSX file whenever an HS file is requested.

* Add new .make files to Src/Sys

* Show message from 'die' also on standard error

* Disallow repeated species labels

* Use species label instead of atomic symbol in dump files.

* Set near-zero lattice vector components to zero

If the LatticeParameters option is used, and due to roundoff error in the
trigonometry, some components of the lattice vectors turned out very small
but non-zero. Now they are set to zero for cosmetic reasons.

* Disallow the use of non-diagonal supercells

Their use is not well-defined in all cases.





-----------------------------------------------------------------------
2009-04-02  10:30:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.15
Assorted fixes (hsparse warnings, xc_check...)

* Fix for overzealous multiple-image detection in hsparse

Hsparse raised a warning regarding connectivity of multiple images
without actually checking that the currently considered neighbor did
indeed overlap with the base atom.

* Add missing line in Util/Grid/grid2cube.f
  (P. Ordejon)

* Initialize nspin_data in Util/pdosxml/m_pdos.f90. Update cli code.
  (Reported by P. Ordejon)

* Fix revPBE section in xc_check in atom.f

* Fixed calculation of fermi level for charged systems in Util/COOP/mprop.f90
  (Thanks to Manuel Cobian)

* Fixed labels and file names in some tests.
  (Reported by I. Silanes, IFCA)

* Fix declarations in function numb in chempot
  (Thanks to Manuel Cobian)

* Increase the number of fields for energy differences in Pseudo/atom/prdiff.f
  (Reported by V. Maslyuk)

added:
  Tests/pd_ice/pd_ice.pseudos
renamed:
  Tests/h3po4_atomlists_1 => Tests/h3po4_1
  Tests/h3po4_atomlists_1/h3po4.fdf => Tests/h3po4_1/h3po4_1.fdf
  Tests/h3po4_atomlists_1/h3po4.pseudos => Tests/h3po4_1/h3po4_1.pseudos
  Tests/h3po4_atomlists_2 => Tests/h3po4_2
  Tests/h3po4_atomlists_2/h3po4.fdf => Tests/h3po4_2/h3po4_2.fdf
  Tests/h3po4_atomlists_2/h3po4.pseudos => Tests/h3po4_2/h3po4_2.pseudos
  Tests/h3po4_atomlists_3 => Tests/h3po4_3
  Tests/h3po4_atomlists_3/h3po4.fdf => Tests/h3po4_3/h3po4_3.fdf
  Tests/h3po4_atomlists_3/h3po4.pseudos => Tests/h3po4_3/h3po4_3.pseudos
  Tests/pd_h2o => Tests/pd_ice
modified:
  Pseudo/atom/prdiff.f
  Src/atom.f
  Src/chempot.F
  Src/hsparse.f
  Tests/h3po4_1/makefile
  Tests/h3po4_2/makefile
  Tests/h3po4_3/makefile
  Tests/pd_ice/makefile
  Tests/ptcda/ptcda.fdf
  Util/COOP/io_hs.f90
  Util/COOP/main_vars.f90
  Util/COOP/mprop.f90
  Util/Grid/grid2cube.f
  Util/pdosxml/f2kcli.F90
  Util/pdosxml/m_pdos.f90
  Tests/h3po4_1/h3po4_1.fdf
  Tests/h3po4_2/h3po4_2.fdf
  Tests/h3po4_3/h3po4_3.fdf


-----------------------------------------------------------------------
2009-03-28  17:20:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.14
Added a translator for pseudopotential files in XML format

Directory Util/pseudo-xml contains code by J. Junquera and A. Garcia
to convert pseudopotential files in the XML format designed by
Junquera, Garcia, and Verstraete (to be published) to ".psf" format.
  
Also:
 - Use of "force_underflow" to avoid very small numbers in output.
 - Use exact traditional marker messages in psf file.

added:
  Util/pseudo-xml/Fe.xml
  Util/pseudo-xml/io.f
  Util/pseudo-xml/makefile
  Util/pseudo-xml/pseudopotential.f
  Util/pseudo-xml/sys.f90
  Util/pseudo-xml/xml2psf.f90
  Util/pseudo-xml/xml2psf_helper.f
renamed:
  Src/pseudo-xml => Util/pseudo-xml
modified:
  Docs/siesta.tex
  Pseudo/atom/pseudoXML.f
  Util/README
  Util/pseudo-xml/README


-----------------------------------------------------------------------
2009-03-19  11:00:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.13
Fix evaluation of atomic radial functions near r=0

Spherical functions with l=0 must have a zero gradient at the
origin. However, after a change somewhere between v0.9 and v0.11, the
splines used have been constructed using the "natural" boundary
condition of zero second derivative. This causes numerical problems
stemming from the discontinuity of the gradient, notably extraneous
forces when atoms move slightly away from exact grid-point positions.

The problem has been fixed by specifying explicitly "yp1=0" in the
construction of the splines. It has also been necessary to augment the
rad_setup_d2 and radial_read_ascii functions with extra arguments, so
that tables in .ion or .ion.nc files can be processed adequately.

The changes affect the orbitals and the projectors (their tables
contain R(r)/r**l, so they have zero derivative at zero for all l),
the pseudocore charge, the local pseudopotential charge density, and
Vna.  Only the "reduced Vlocal" function (which is not really used by
Siesta) uses a natural spline, as it has a finite slope at r=0 (maybe
because this is not a "volume function" but a synthetic one).

A related problem is the extrapolation to r=0 of magnitudes computed
on the radial grid. Typically the construction procedure starts or
ends with the first non-zero value of the radius, and a final
extrapolation is done. This can be linear, quadratic, or "flat"
(involving just a copy of the value at the first nonzero
radius...). In particular, a "flat" extrapolation was used for the
pseudocore charge (which led again to extraneous contributions to
forces) and for the effective charge density associated to the local
pseudopotential (in this case there does not seem to be a sizable
contribution to the forces).  A quadratic extrapolation is now used
for those magnitudes.

The gradient was not computed properly in a "danger area" with an
approximate radius 2* r_c /500, where 500 is the number of points in
the interpolation table and r_c is the cutoff of the function
considered. Thus for a very localized pseudo-core charge (rc=1.5 bohr)
the effects might be felt when the atoms move by up to around 0.006
bohr from a grid point. 

The bug might have affected phonon calculations starting from
high-symmetry atomic positions, since a very small displacement might
then give meaningless results. Other effects might be extra noise in
molecular dynamics calculations when an atom falls by chance in the
"danger area", and puzzlingly high residual forces for particular
values of atomic coordinates, which might have complicated the analysis
of the eggbox effect.

Credits: D. Sanchez Portal found the spline issue. A. Garcia coded the
         fix, found the extrapolation bug, and analyzed the issues involved.

+: The "ioncat" program has been updated to process the pseudo-core charge
   and the local-pseudopotential charge density.
+: A new function rchlocal has been added to atmfuncs.f

modified:
  Src/atmfuncs.f
  Src/atom.f
  Src/basis_io.F
  Src/electrostatic.f
  Src/ioncat.f
  Src/radial.f
  Docs/siesta.tex

-----------------------------------------------------------------------
2009-03-19  10:00:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.12
Fix of non-collinear-spin patch

Due to an oversight, the patch leading to version 2.6.9 was missing
two essential fdf calls relating to spin polarization in module m_spin.
Requests for spin-polarized or non-collinear-spin calculations were
silently ignored. 

This has now been fixed and the documentation of the m_spin module
improved.

Thanks to Oswaldo Dieguez for reporting the bug.

modified:
  Src/m_spin.F90
  Docs/siesta.tex

-----------------------------------------------------------------------
2009-03-16  16:30:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.11
Re-design of DM re-use code plus reallocation bug fix

* A redesigned m_new_dm module prepares a starting density matrix for a
new geometry iteration. This DM can be:

1. Synthesized directly from atomic occupations (not idempotent)
2. Read from file
3. Extrapolated from (two) previous steps
3.a The DM of the previous iteration

In cases 2 and 3, a check is done to guarantee that the structure
of the read or extrapolated DM conforms to the current sparsity.
If it does not, the information is re-arranged.

Special cases:
       Harris: The matrix is always initialized
       Force calculation: The DM should be written to disk
                          at the time of the "no displacement"
                          calculation and read from file at
                          every subsequent step.
       Variable-cell calculation:
         If the auxiliary cell changes, the DM is forced to be
         initialized (conceivably one could rescue some important
         information from an old DM, but it is too much trouble 
         for now). NOTE that this is a change in policy with respect
         to previous versions of the program, in which a (blind?)
         re-use was allowed.


* The physical dimensions of the DM array were not allowed to shrink
upon reallocation, thus introducing mismatches between the actual size
and what several subroutines expected. This bug, which affected with
particular severity spin-polarized calculations, has now been fixed.

* New symbols for control of DM reuse and extrapolation

The FDF symbols:

DM.AllowReuse          (default .TRUE.)
DM.AllowExtrapolation  (default .TRUE.)

control whether the DM can be re-used from one geometry step to another, and
whether it can be extrapolated using information from the two previous steps.

If DM.AllowReuse is .false., the DM is not read from file even if DM.UseSaveDM is .true.

The default for ReinitialiseDM has been changed to ".true.". Hence the DM is
reset (and not read from file) when the auxiliary supercell shape changes, as sanity
dictates.

* Re-design of new_dm and extrapol

    * Use new functionality in module m_sparse to simplify the logic and
    hide the ---old index arrays.
    
    * Initdm is now part of the new_dm module.
    
    (* While debugging a hard-to-track zeroth allocation of DMsaved made a
    note in alloc.F90)

* Split of read/write functionality in iodm. Sparsity module. Input check

    * A new module m_iodm based in iodm has been added (the old code remains).
      Reading and writing are now done by separate routines, read_dm and write_dm,   
      respectively. 
    
    * New module m_sparse, containing code to check for sparsity changes and
      to re-structure a sparse matrix to conform to a new pattern (inspired by
      code in extrapol).
    
    * Initdm now calls read_dynamic_dm, which generates a completely fresh
      DM.  Then the input sparsity pattern is compared to the current one,
      and updated if needed. If the file cannot be used, perform a proper bailout
      (supersedes a previous patch by Emilio and Andrew on iodm.f)


removed:
  Src/extrapol.F
  Src/initdm.F
added:
  Src/compute_norm.F
  Src/m_iodm.F
  Src/m_sparse.F
modified:
  Docs/CHANGES
  Src/Makefile
  Src/alloc.F90
  Src/diagk.F
  Src/hsparse.f
  Src/iodm.F
  Src/mixer.F
  Src/new_dm.F
  Src/post_scf_work.F
  Src/siesta_init.F
  Src/siesta_options.F90
  Src/sparse_matrices.F90
  Src/state_init.F
  Src/version.F90
  version.info

------------------------------------------------------------------
2009-02-22  22:00:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.10
Fixed non-collinear spin calculation in parallel
  
  * The diagonalization with mixed spins requires doubling
  the effective blocksize for scalapack. This has been
  fixed.
    
  Credits: Volodymyr Maslyuk, Alberto Garcia
  
  Note that the option Diag.ParallelOverK cannot yet
  be used with non-collinear spin.
  
  Other fixes:
  
  * In non-collinear spin calculations there is no CML output.
  Thus the relevant CML module should not be opened.

  New test:  fe_noncol_kp  
  
added:
  Tests/fe_noncol_kp/
  Tests/fe_noncol_kp/fe_noncol_kp.fdf
  Tests/fe_noncol_kp/fe_noncol_kp.pseudos
  Tests/fe_noncol_kp/makefile
modified:
  Docs/siesta.tex
  Src/Makefile
  Src/cdiag.F
  Src/diag2g.F
  Src/diag2k.F
  Src/diagon.F
  Src/m_spin.F90
  Src/mulliken.F
  Tests/fe_clust_noncollinear/fe_clust_noncollinear.fdf

------------------------------------------------------------------
2009-02-06  14:30:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.9
Implementation of new filtering logic

See the manual for instructions on how to use the new
FDF symbols FilterCutoff and FilterTol.

* Note that there are no safeguards for failures of the filtering
routine. In particular, if FilterTol is set to a "large" value, some
orbitals will not be filtered correctly, and the tables will be
corrupted.

* The implementation of automatic meshcutoff is not ready yet.

* Updated the "filter" tests.

* In atom, moved the call to 'comcore' after orbital setup.  This is
needed to apply an orbital-determined cutoff to the partial-core
charge. The orbitals themselves are generated with the "raw" core
charge from the pseudopotential file, and then filtered. Then the PCC
is filtered.

* Apart from the fdf symbols discussed in the manual, the following
undocumented ones can be used for now: (see the code)

PCC.Filter
PAO.Filter
VNA.Filter

(booleans). Fine-tune which things are filtered.
(make sure other options and defaults are compatible)

XXX.FilterFactor: fine-tune the default factors used

XXX.FilterCutoff: fine-tune the cutoff

XXX.FilterTol: set the diagnostic Kin Energy tolerance
for an estimate of the hardness of the function. This
defaults to 0.003 Ry.

removed:
  Tests/Reference-xml/pb_filter_all.xml
  Tests/Reference-xml/pb_filter_basis.xml
  Tests/Reference-xml/pb_filter_pcc.xml
  Tests/Reference-xml/pb_filter_vna.xml
  Tests/Reference/pb_filter_all.out
  Tests/Reference/pb_filter_basis.out
  Tests/Reference/pb_filter_nopcc.out
  Tests/Reference/pb_filter_pcc.out
  Tests/Reference/pb_filter_vna.out
  Tests/Reference/var_cell_filter.out
  Tests/pb_filter_basis/
  Tests/pb_filter_basis/makefile
  Tests/pb_filter_basis/pb_filter_basis.fdf
  Tests/pb_filter_basis/pb_filter_basis.pseudos
  Tests/pb_filter_nopcc/
  Tests/pb_filter_nopcc/makefile
  Tests/pb_filter_nopcc/pb_filter_nopcc.fdf
  Tests/pb_filter_nopcc/pb_filter_nopcc.pseudos
  Tests/pb_filter_pcc/
  Tests/pb_filter_pcc/makefile
  Tests/pb_filter_pcc/pb_filter_pcc.fdf
  Tests/pb_filter_pcc/pb_filter_pcc.pseudos
  Tests/pb_filter_vna/
  Tests/pb_filter_vna/makefile
  Tests/pb_filter_vna/pb_filter_vna.fdf
  Tests/pb_filter_vna/pb_filter_vna.pseudos
  Tests/var_cell_filter/
  Tests/var_cell_filter/makefile
  Tests/var_cell_filter/var_cell_filter.fdf
  Tests/var_cell_filter/var_cell_filter.pseudos
  Tests/var_cell_stress/
  Tests/var_cell_stress/makefile
  Tests/var_cell_stress/var_cell_stress.fdf
  Tests/var_cell_stress/var_cell_stress.pseudos
added:
  Docs/filtering.CHANGES
  Tests/Reference-xml/pb_filter_cutoff.xml
  Tests/Reference-xml/pb_filter_tol.xml
  Tests/Reference/pb_filter_cutoff.out
  Tests/Reference/pb_filter_tol.out
  Tests/pb_filter_tol/
  Tests/pb_filter_tol/makefile
  Tests/pb_filter_tol/pb_filter_tol.fdf
  Tests/pb_filter_tol/pb_filter_tol.pseudos
renamed:
  Tests/pb_filter_all => Tests/pb_filter_cutoff
  Tests/pb_filter_all/pb_filter_all.fdf => Tests/pb_filter_cutoff/pb_filter_cutoff.fdf
  Tests/pb_filter_all/pb_filter_all.pseudos => Tests/pb_filter_cutoff/pb_filter_cutoff.pseudos
modified:
  Docs/CHANGES
  Docs/siesta.ind
  Docs/siesta.tex
  Src/atom.f
  Tests/pb_filter_cutoff/makefile
  Tests/std-Makefile
  version.info
  Tests/pb_filter_cutoff/pb_filter_cutoff.fdf

------------------------------------------------------------------
2008-12-06  17:50:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.8
Optimize and fix COOP/COHP/PDOS analysis program

The mprop program in Util/COOP has been revamped to decrease
drastically the amount of memory needed and to speed up execution.
Now it should be competitive with, and more flexible than, Siesta's
built-in PDOS computation.

In the process of optimization several bugs were found and fixed.
Users are advised to revise the results of old calculations,
particularly if k-points or multiple-zeta orbital were used.

(+ The OCCS file needs to be opened at the right place in diagk)


added:
  Tests/Reference-xml/si64_coop.xml
  Tests/Reference/si64_coop.out
modified:
  Src/diagk.F
  Tests/si64_coop/si64_coop.fdf
  Util/COOP/Makefile
  Util/COOP/Tests/n_chain/coo.N-N.gplot
  Util/COOP/io_hs.f90
  Util/COOP/main_vars.f90
  Util/COOP/mprop.f90
  Util/COOP/read_curves.f90
  Util/COOP/subs.f90

------------------------------------------------------------------
2008-11-28  16:15:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.7
Assorted bug fixes: iodm, pdos, fdf, cdf_fft

* Fix latest patch for iodm.F (formatting, messages)
* Fix long-standing bug in pdos XML output
* Cosmetic fix in experimental file Util/Grid/cdf_fft.f90
* Fix obscure bug in fdf

modified:
  Src/fdf/fdf.f
  Src/iodm.F
  Src/wxml/m_wxml_text.F90
  Util/Grid/cdf_fft.f90

   	------------------------------------------------------------
   	revno: 271
   	committer: Alberto Garcia <albertog@icmab.es>
   	branch nick: trunk-ag
   	timestamp: Mon 2008-10-27 22:42:54 +0100
   	message:
   	  Do not use volume factor in cdf_fft
   	  
   	  The factor only makes sense for charge-density files.
   	  
   	  modified:
   	    Util/Grid/cdf_fft.f90
   	------------------------------------------------------------
   	revno: 270
   	committer: Alberto Garcia <albertog@icmab.es>
   	branch nick: trunk-ag
   	timestamp: Mon 2008-10-27 22:37:48 +0100
   	message:
   	  Close the output channel in fdf_shutdown 
   	  
   	  If fdf is re-invoked, an error was triggered because
   	  fdf_shutdown did not close the previous run's output channel.
   	  Bug spotted by Eduardo Hernandez.
   	  
   	  modified:
   	    Src/fdf/fdf.f
   	------------------------------------------------------------
   	revno: 269
   	committer: Alberto Garcia <albertog@icmab.es>
   	branch nick: trunk-ag
   	timestamp: Mon 2008-10-27 22:35:55 +0100
   	message:
   	  Fix a long-standing bug in pdos xml output
   	  
   	  In Src/wxml/m_wxml_text.F90, the arguments to the sign function were
   	  reversed, causing badly formatted records in the pdos xml file.
   	  Thanks to Rogeli Grima for spotting the bug.
   	  
   	  modified:
   	    Src/wxml/m_wxml_text.F90


------------------------------------------------------------------
2008-11-28  14:25:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.6
Avoid MPI deadlock when DM file is not acceptable (A. Walker)

        Since r263.1.1 it was possible for the test 
    
         if ( maxnd .lt. ndmax ) then
           okdim = .false.
           ... skip DM reading ...
    
    
        to be true on some nodes and false on others 
        as ndmax was local to the node. This condition
        leads to some nodes to wait at globalize_max
        in m_pulay.F (near line 53) and the other to wait 
        at the MPI_Wait in iodm.F (near line 293). Avoid 
        this by detecting whether maxnd and ndmax are
        different between nodes. The test is done on all nodes and 
        all must be ok to use the .DM file.
    
        modified:
          Src/iodm.F
          version.info

------------------------------------------------------------------
2008-10-15  10:50:00 GMT Alberto Garcia <albertog@icmab.es>	 2.6.5
Assorted fixes (deprecated constructs, zmatrix, cg restarts) (A. Walker)

	-------------------------------------------------------------------------
	2008-10-13	Andrew Walker	2.6.4--awalker-trunk-fixes-5
	Remove use of features deleted in Fortran 95
	
	Specifically, one use of PAUSE and one GOTO an
	ENDDO statment. GOTO now jumps to the next line
	and the PAUSE is replaced to an (MPI safe) call
	to die().
	
	modified:
	  Docs/CHANGES.awalker-trunk-fixes
	  Src/atomlwf.F
	  Src/m_ts_aux_rout.F
	  version.info
	
	-------------------------------------------------------------------------
	2008-10-13	Andrew Walker	2.6.4--awalker-trunk-fixes-4
	Simple bugfix for fixed cell restarts.
	
	In the case of a tightend ftol after a sucessful CG run, relaxed
	is set to .true. by the read from iocg. This results in the test
	for convergence being skipped within conjgr. Setting relaxed to
	.false. here avoids this. In the case of a variable cell relaxed
	is set below anyway and the converence test is always performed.
	A better solution (moving the test out into a seperate routine)
	will follow in a later version. 
	
	modified:
	  Docs/CHANGES.awalker-trunk-fixes
	  Src/cgvc.F
	  version.info
	
	-------------------------------------------------------------------------
	2008-10-13	Andrew Walker	2.6.4--awalker-trunk-fixes-3
	NAG issues with transiesta
	
	Even with -dcfuns the NAG f95 compiler does not like the
	"non-standard double precision complex intrinsic function"
	dcexp. Use the generic exp instead.
	
	modified:
	  Docs/CHANGES.awalker-trunk-fixes
	  Src/m_ts_electrode.F90
	  Src/m_ts_in_siesta.F
	  Src/m_ts_scattering.F
	
	-------------------------------------------------------------------------
	2008-10-13	Andrew Walker	2.6.4--awalker-trunk-fixes-2
	Fix errors in some zmatrix tests
	
	According to the documentation and code in zmatrix.F the
	fdf flags to control zmatrix force tolerance and optimizer
	step size are ZM.ForceTolLength, ZM.ForceTolAngle,
	ZM.MaxDisplLength and ZM.MaxDisplAngle - in some tests
	they were shortened to ...Ang and ...Len. This patch
	corrects this. The values in the tests were set to the 
	defaults so test output is not changed.
	
	modified:
	  Docs/CHANGES.awalker-trunk-fixes
	  Tests/benzene/benzene.fdf
	  Tests/fire_benzene/fire_benzene.fdf
	  Tests/h2oZ/h2oZ.fdf
	  Tests/zmatrix/zmatrix.fdf
	
	-------------------------------------------------------------------------
	2008-10-13	Andrew Walker	2.6.4--awalker-trunk-fixes-1
	Make obj_setup.sh executable.
	
	This needs to be executed in order to do VPATH make.
	
	added:
	  Docs/CHANGES.awalker-trunk-fixes
	modified:
	  Src/obj_setup.sh*
	  version.info
	

------------------------------------------------------------------
2008-09-12  13:45:00 Alberto Garcia <albertog@icmab.es>	 2.6.4
Extended Ordejon-Mauri ordern functional to atoms with odd number of electrons

Patch by: Emilio Artacho <emilio@esc.cam.ac.uk>
timestamp: Sat 2008-08-30 18:38:45 +0100
  
In the initial assigning of LWF centers to atoms, it assigns n/2 to
atoms with n even, and (n+1)/2 or (n-1)/2 in an alternating sequence
to atoms with odd number. The sequence runs in the order of input in
the atomic coordinates block; the user can control the assignment by
defining the order there.
  
modified:
  Docs/siesta.tex
  Src/atomlwf.F

------------------------------------------------------------------
2008-09-12  13:25:00 Alberto Garcia <albertog@icmab.es>	 2.6.3
Siesta moves on with fresh DM instead of stopping when wrong DM file

Patch by: Emilio Artacho <emilio@esc.cam.ac.uk>
timestamp: Thu 2008-08-28 15:53:19 +0100
  
Simple patch removing chkdim calls in iodm.F and substituting them by
if statements. If the dimensions are wrong it sends back found=.false.
  
There is a 'goto' statement introduced to minimise impact on present
structure (pending the up-and-coming revision of DM handling)
  
modified:
  Src/iodm.F

------------------------------------------------------------------
2008-09-11  11:50:00 Alberto Garcia <albertog@icmab.es>	 2.6.2
Incorporate new filtering functionality

Pending the merge of the new atom-clean structure, the new filtering
functionality of Jose Soler and Eduardo Anglada has been incorporated
temporarily into this branch.

The filtering routines are in Src/m_filter.f90, a self-contained
module with no dependencies. A new subdirectory Src/filter with
the same code is meant to serve as a test framework for now.
Eventually it would be turned into a "library" subdirectory, 
and Src/m_filter.f90 removed.

The old filtering routines have been removed.
Minimal documentation has been added to Docs/siesta.tex.

removed:
  Src/filter.f90
  Src/filter_subs.f
added:
  Src/filter/
  Src/filter/README
  Src/filter/ba-6s-orb.dat
  Src/filter/core.dat
  Src/filter/f2kcli.F90
  Src/filter/m_filter.f90
  Src/filter/m_getopts.f90
  Src/filter/makefile
  Src/filter/test_filter.f90
  Src/filter/ti-3p-orb.dat
  Src/filter/ti-4p-orb.dat
  Src/m_filter.f90
modified:
  Docs/CHANGES
  Docs/siesta.ind
  Docs/siesta.tex
  Src/Makefile
  Src/atom.f
  Src/version.F90
  version.info


2008-09-11  11:10:00 GMT  Alberto Garcia <albertog@icmab.es>	2.6.1
Fix bug related to vna introduced at a previous patch

A patch introduced in 2.5.29 in meshsubs.F was wrong. Vna must
be kept in "gradients" calculations. Its intent has been set 
to "inout" and the extra initialization removed.

The bug was spotted by Rogeli Grima.

modified:
  Src/meshsubs.F
  Src/version.F90
  version.info

____________________________________________________________________
** CHANGES ALONG siesta@uam.es--2006/siesta-devel--reference--2.5
--------------------------------------------------------------------

2008-07-18  08:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-33

Summary: Fix in dhscf.F . Added OUT directories int Tests/transiesta 

(F.D. Novaes) 

* Corrected the position of MPI #endif in dhscf.

* Added output files of transiesta runs in OUT directories
and of tbtrans runs in OUT_TBT in the tests located in Tests/transiesta

2008-07-16  15:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-32

Summary: Added tests for Transiesta and /Util/TBTrans (F.D. Novaes)

Tests/transiesta contains some (not quite automatic)
tests for transiesta and tbtrans.

Util/TBTrans contains the source code for tbtrans.

README_TRANSIESTA in the top directory explains
the basic features and organization for transiesta.

2008-07-16  07:40:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-31

Summary: Added support for Lapack routine zgesv for transiesta

For systems without pre-compiled libraries, zgesv_lapack.f has
been added to Src/Libs. It is added by default to linalg.a

2008-07-15  08:40:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-30

Summary: Merge of Transiesta code -- F. D. Novaes version

Brief Description: 

The TranSIESTA code consists in a a set of additional routines for the
SIESTA package for the computation of electronic transport
properties. It was originally developed by Mads Brandbyge, Jose-Luiz
Mozos, Pablo Ordejon, Jeremy Taylor and Kurt Stokbro (Phys. Rev. B 65,
165401 (02)), and first implemented in the SIESTA 1.3p version.

The present distribution was adapted to the SIESTA 2.5 structure. With
respect to the first implementation, it has the additional feature of
allowing for the use of a k-point sampling other than the gamma point
(for the 2D Brillouin zone perpendicular to the transport
direction). These modifications were done by F. D. Novaes
(fdnovaes@icmab.es)

Source code Structure: 

In this implementation, the original TranSIESTA routines were grouped
in a set of modules, that all begin with m_ts (m_ts_electrode.F90,
e.g.), together with the addition of some new subroutines. These
modules are located in the Src directory.  The interface for
TranSIESTA also requires the modification of some of the SIESTA
routines. Presently, this is controlled by compilation directives
(#ifdef TRANSIESTA), so that only when compiling with the -DTRANSIESTA
FPPFLAGS option that the objects will contain the modifications.

Compiling:

Add -DTRANSIESTA to the FPPFLAGS variable in the arch.make file, and
type 

make transiesta

The Makefile was modified in such a way to link the m_ts modules and
create a binary called transiesta.


2008-07-08  13:45:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-29

Summary: Patches by A. Walker: undefined variables and pointers, intents

The original names of the patch files are retained for reference.

* NAG-01-null.patch -- makes various undefined pointers disassociated
(in fft3d.F, dfscf.f, pseudopotential.f, hsparse.f, optical.F,
writewave.F and zmatrix) and wraps a pointer declaration that is only
used under -DMPI with the ifdef in optical.F.

* NAG-02-intent.patch -- attempts to deal with a couple of issues with
the intent of variables. Intent(out) results in the variable being
undefined at the start of the called subroutine (and in the caller, if
it is not changed). In vmb.F there is a call to fixed with a couple of
variables being used in two places (on intent(in) and another
intent(out)) - I don't know what the strictly correct behavior is in
this case, but under NAG this results in the intent(in) variable being
undefined in fixed. I've worked around this with a pair temporary
variables. The alternative is to rework the interface to fixed using
intent(inout). The second issue is similar and in meshsubs.f: Vna
ended up undefined if gradient was true. I've dealt with this by
setting Vna to 0.0, but a reworking using intent(inout) may also be a
better solution.

* NAG-03-dhfcs.patch -- deals with a couple of pointers in
dhscf.F. These need to have the save attribute or they will be
undefined rather than disassociated on the second and subsequent
calls. I've also added a comma to a data block.

* NAG-04-filter.patch Changes the dimensions of f0 from nr to n so to
avoid a mismatch in array dimensions of x in the call to the
interpolation function at line 169. As far as I can tell this is the
correct fix: yold is known at the xold positions and ynew will be
calculated at the xnew positions, so ynew (which is f0) should be of
the same dimensions as xnew (which is x), and yold (f) should be of
the same dimensions as xold (r).

* NAG-05-init -- In dynamics.f initialize magv and magf in the uphill
case. In forhar.f initialize stressl array. In m_cell.f initialize
celli as it is used in the case of a zmatrix molecule without a cell
before the box size is calculated. In m_kinetic.F90 initialize
thermostat parameters.


2008-06-29  22:45:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-28

Summary: Minor cosmetic fixes to avoid compilation warnings

*   Fix cycle statement in m_denchar_work.f

*   Fix cycle statements in pdos routines -- warning in atomlwf.F

*   Some debugging support for KB generation

If Atom.Debug.KB.Generation is "true", 'AtomLabel-KBproj'.index
files are produced showing the non-interpolated projectors.

*   Fixes for NAG compiler contributed by Toby White:

chempot: intent of mu in numb routine.
writewave: remove references to paste routine
fft3d.F: explicit array-ness of trigs in calls to setup routines.

2008-06-29  22:40:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-27

Summary: Fixed bug affecting MP occupation smearing.

Fixed a bug (reported by Francois Willaime of CEA/Saclay)
which affected calculations in metals using the Hermite-Gauss
broadening scheme proposed by Methfessel and Paxton
(OccupationFunction MP).

The following test on state occupancy was performed:

if (qe.gt.occtol)

where qe is the state occupancy, and occtol, the tolerance (set to
10**-12 by default).  If one uses the Methfessel-Paxton smearing, qe
may take negative values and this test therefore yields wrong results.

The bug has be fixed by replacing the test by 

if (abs(qe).gt.occtol)

in all diag*.F routines.


2008-06-29  18:20:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-26

Summary: Remove residual (k,-k) pairs of k-points

The original algorithm sometimes left pairs of k-points related
by inversion. A new routine "trim_kpoint_list" in find_kgrid.F
now takes care of them.

A file NON_TRIMMED_KP_LIST is created with the "raw" list produced
by the first part of the process, for debugging purposes.

NOTE: Some pairs are *still* not removed properly. A fix is in the works.

Credits: Eduardo Machado (CEA) implemented a preliminary version
         modifying the original algorithm.

* Write KP file unconditionally (regardless of WriteKpoints setting)

2008-06-29  18:15:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-25

Summary: Assorted geometry-related cosmetic fixes

* Do not pretend to update zmatrix info during MD runs

The zmatrix form of structural information is only kept up
to date when performing geometry relaxations. In molecular
dynamics runs, only the cartesian coordinates are updated, and
the zmatrix variables are kept frozen at their initial values.

This is potentially confusing, so a warning is now issued and
the zmatrix "updates" are no longer printed.

* Fix shape script in Utils/MD

* Compute bond information for all server steps

  If the server option is used, the program will compute the bond-length
  information at every step. 

  The first file has now extension ".BONDS_INITIAL", and every successive 
  one, simply ".BONDS". The final one is still "SystemLabel.BONDS_FINAL".

* More flexibility and error detection in reading of atomic coordinates

(Patch by Andrew Walker)

In coor.F, new logic has been implemented to detect malformed input lines
in the AtomicCoordinatesAndAtomicSpecies block. As a by-product, comments
and blank lines can now be present in the block.


(Unrelated)

* Temporarily move xml-pseudopotential to xmlparser directory
  The file is not ready for production, but could interfere with the
  automatic dependency analysis.

2008-06-29  17:45:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-24

Summary: Generalized SCF convergence criteria. Optional enforcement

New criterion for SCF convergence based on the Harris energy. This
is useful if only energies are needed, as the Harris energy tends
to converge faster than the Kohn-Sham energy.

This new criterion joins the two already implemented:

- The standard criterion is based on the convergence of the density
matrix, with the relevant parameter being DM.Tolerance.

- Optionally, one can require that the total energy changes are
also below a prescribed tolerance:

DM.RequireEnergyConvergence T

In this case, DM.EnergyTolerance is the total-energy tolerance

The new criterion is requested by

DM.RequireHarrisConvergence  T

DM.HarrisTolerance is the harris-energy tolerance (default 1e-4 eV)

(Note that DM convergence is not needed in this case).

The user is responsible for using the correct energies in further
processing, e.g., the Harris energy if the Harris criterion is used.

To help in basis-optimization tasks, a new file BASIS_HARRIS_ENTHALPY
is provided, holding the same information as BASIS_ENTHALPY but using
the Harris energy instead of the Kohn-Sham energy. 


The energy criteria are implemented using "convergers", new objects
defined and implemented in m_convergence.f90. It is probably overkill
as of now, but it can be enhanced to provide new functionality.


*  Added Andrew Walker's patch for convergence enforcement

If the fdf symbol SCFMustConverge is set to 'true', the program will abort
if convergence is not achieved after the specified number of iterations
(set with MaxSCFIterations, or currently 50 by default).

* Added explicit support for flush and abort for gfortran in pxf.F

2008-06-29  17:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-23

Summary:  Patch by Andrew Walker for maximum wall-clock time

If MaximumWallClockTime is set (to a time specification of
the form 

     15 s
     7  mins
     2  hours
     3  days 
     ...      )

the program will abort if the specific wall-time is exceeded.
The checks are done with the granularity of the calls to 'timer' (i.e.,
there might be some slack). If the maximum time is 0 (the default), or is
negative, the time is unlimited.


* Added -DFC_HAVE_FLUSH -DFC_HAVE_ABORT to the gfortran*.make files

2008-06-29  16:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-22

Summary: Integration of new STM-images code. Better makefiles.

Util/STM/ol-stm contains the code by Pablo Ordejon and Nicolas Lorente
that implements the Tersoff-Hamann approximation to STM images, with a
previous step of extrapolation of wave functions from a reference
plane. It is thus more accurate than the simple code to be found now
in Util/STM/simple-stm.

Note that for now the fftw3 library needs to be available for this
code to work.

Bug fixes found upon integration:

- Bug fix in Util/STM/ol-stm/Src/extrapol.f: the interpretation of the
layout of the lattice vectors in the "cell" array was wrong.

- fftw3 "estimation" call moved outside a loop in extrapol.f (there is
more scope for optimization here).

* The makefiles for several utilities have been streamlined,
and the compilation of the ol-stm program uses a VPATH
functionality to avoid duplicating code in the top-level
Src directory. The old neighb/ranger routines are retained for now.

Some changes were needed to implement this correctly:

iodm.F: 

- Removed support for old-style control files.
- Wrapping of LocalToGlobalOrbital call in iodm.F in a MPI preprocessor block.

spher_harm.f: Used dot_product instead of ddot.

* Other changes:

Src/Sys/cscs-ibm-blanc.make: netcdf compilation.
Util/Grid/makefile: more targets, FC_SERIAL support.
Util/Macroave/Src/Makefile: FC_SERIAL support.

Fix for Finisterrae .make file and .sge script in Tests/Scripts.

2008-06-29  15:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-21

Summary: A faster diagk with eigenvector storage

The  new k-point-mode diagonalization routine diagk_file stores
the eigenvectors on file to avoid re-computation after fermi-level
determination. The file is in netCDF form, allowing a more
flexible dispatching of eigenvectors to and from the master node.
(At the time of building the new density matrix, the eigenvectors
are read by and transferred from the root node in blocks.)

This routine should be very useful for relatively large systems, but
the speedup is noticeable for all but the very small.

In order to use the new routine, netCDF support should be compiled in,
and the symbol UseNewDiagk must be set to "true" in the fdf
file. Specifying a number of eigenvectors to store is possible through
the symbol NumberOfEigenstates. Note that for now, for safety, all
eigenvectors for a given k-point and spin are computed by the
diagonalization routine, but only that number specified by the user
are stored. If they are insufficient, the program stops.  A rule of
thumb to select the number of eigenvectors to store is to count the
number of electrons and divide by two, and then apply a "safety
factor" of around 1.1-1.2 to take into account fractional occupations
and band overlaps.

A new file "OCCS" is produced with information about the number of
states occupied.

Note that this routine is NOT yet set up to be used for band-structure
computations, or to "write out" wavefunctions. It should only be used
in the SCF loop, i.e., from routine "diagon". 

The old diagk routine is kept, for use in smaller systems and to be
called from driver routines which provide other functionality.

The size of the transfer block is set to n_eigenvectors/Nodes (note
that the user is responsible for setting n_eigenvectors). The loops in
the density-matrix building section have been rearranged. Now each DM
scan loop (with potential inefficiencies for indirection) has more
work to do, and it is no longer cost-effective to fill the dense
matrices Dk and Ek first.

The size of the block could in principle be increased for free to
Min(no_l), and psi_block made into a pointer to Haux. Preliminary
tests seem to indicate a lower performance, however (?).

To Do:

Clarify the use of work arrays. Haux and Saux should probably be allocated
inside the diagonalization routines, and not in diagon.


* The timing sections have been split into "build HS", "eigenvalues/eigenvectors"
and "buildD" components.

2008-06-29  13:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-20

Summary: NetCDF I/O of Grid magnitudes. Density re-starts

New module iogrid_netcdf implements a general-purpose dumper
of grid magnitudes in netCDF format. If netCDF support is
enabled, files with extension .grid.nc are produced for
whatever grid magnitude is requested to be saved (charge density 
(Rho), deformation density (DeltaRho), potential, etc).

The use of grid descriptors for each node and the addressable netCDF
file format greatly simplify the communication needs for the
output of grid variables.

Module iogrid_netcdf implements a "grid descriptor calculator" for
the standard uniform distribution, but the routine which outputs
grid functions is in principle able to work with any distribution.

Util/Grid contains new utilities for conversion and analysis
of the .grid.nc files.

If the keywords SCF.Read.Charge.NetCDF or
SCF.Read.Deformation.Charge.NetCDF are true, the charge density
(respectively the deformation charge density) is read from file
Rho.IN.grid.nc (respectively DeltaRho.IN.grid.nc).

This feature allows the easier re-use of electronic-structure
information from a previous run. It is not necessary that the basis
sets are "similar" (a requirement if density-matrices are to be read
in). The deformation charge is particularly useful to give a good
starting point for slightly different geometries.

To Do:

- Improve the handling of possibly conflicting features, such as the
use of the Harris functional or the mixing of the DM after the first
iteration.

- Extend the flexibility of the reading options (to use them, for
example, in molecular dynamics or phonon calculations). Currently the
density is only read once, at the beginning of the run.

- Support reading of charge densities in FFT boxes of different sizes
  (via resampling). Auxiliary code for this is in Util/Grid/cdf_fft.f90.


-  References to the NetCDF directory under Src and to NETCDF_INTERFACE
   in the Makefile have been removed.


IMPLEMENTATION NOTES:

The grid magnitudes are stored in single precision in the .grid.nc files.


*  Added .make and script file for Finisterrae at CESGA


2008-06-29  13:00:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-19

Summary: Bug fix in grid2val. Added permute program to Macroave suite.

* Fix bug in grid2val (utility to compute values of grid functions
  at arbitrary points).

The cell vectors were declared as single precision, while in fact they
are stored as double precision by Siesta.

Added also tips on compilation.

* Added permute.F program to Macroave suite

Sometimes it is useful to have "x" as the direction perpendicular to 
the slab. Macroave is hard-wired to work with "z", so the program 
"permute.F" has been written to carry out a preliminary rotation of
the axes in the grid file. 

Streamlined the compilation steps in Util/Macroave/Src.

2008-06-29  12:50:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-18

Summary: NetCDF I/O for DM, H, and S

Experimental support for DM output in netCDF form, optionally with
complete history of a SCF cycle.

The netCDF format allows for flexible and portable I/O, and supports
the extension of arrays into a "time-record" dimension. 

A DM-only netCDF file (DM.nc) with the same information as the
traditional DM file is created if Write.DM.NetCDF is 'true' (default
with netCDF support). In this case, the DM values are written in
routine mixer (as is common practice in Siesta, despite the fact that
the resulting DM does not correspond to the last electronic structure
computed).

If WriteDMHS.NetCDF is true (default with netCDF support), a DMHS.nc
file containing the overlap matrix S, DM_in, H, and DM_out is written
to in compute_dm, right after the computation of DM_out.

The default in both cases is not to use the optional time dimension
and overwrite the previous SCF step's information.
To keep the whole history of (the last) SCF cycle, use
WriteDM.History.NetCDF  or WriteDMHS.History.NetCDF, respectively.
The DMHS history might be useful to diagnose SCF convergence issues.
(See new test Test/h2o_netcdf)

With the new DM to netCDF (dm2cdf) and netCDF to DM (cdf2dm) converters in
the Util/DensityMatrix directory, the information in the .nc files can be easily converted
to and from the legacy DM format, allowing the re-use of DM information
in computers with incompatible floating point formats.

Util/SCF/dm.py is a simple example of processing of netCDF with a Python script.

To use the netCDF functionality, Siesta must have been compiled with
the appropriate netCDF libraries.  Example .make files can be found in
the Src/Sys directory (notably gfortran-netcdf.make and
marenostrum-mpi-netcdf-XX.make files).

The .nc files can also be displayed with the shell utility "ncdump",
installed by default when the netCDF library is compiled.


IMPLEMENTATION NOTES:

- The DM, H, and S information is stored in the .nc files in *single precision*.
To change this in the future, an fdf symbol might be used to trigger the replacement
of "float" by "double" in the definition of the variables in the netCDF files. Care
should be taken to adapt all the other utilities. Single precision seems to be
perfectly adequate, however.

- No attempt has been made to optimize the memory use or allocation/deallocation
 overhead, giving priority to clarity. The netCDF format allows a huge simplification
of the MPI communications involved in the I/O, so this is a minor issue.

- The functionality is included in the iodm_netcdf.F90 and iodmhs_netcdf.F90 files.
  The new flags are stored and processed in the siesta_options.F90 module.

2008-05-06  12:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-17

Summary: Update of atom to 3.2.8: xml, optimization hooks, tutorial update.

* Integrated Javier Junquera's XML-generating routines
  Added pseudoXML.f and supporting files.
  (Note that the XML support in Siesta itself is not yet implemented, 
  pending retroffiting of the VCA and other enhancements. The relevant
  files have been put in a new directory 'Src/pseudo-xml'.

* Write pseudo wavefunctions in PSWFFMT

* Updated version.h to include the variable "atom_id", now used
  in various places to set the creator string.

* A simpler makefile has been written when XML support is not needed
so that no symbols from the main Siesta directory need to be
included. The full makefile is called makefile-xml. To use it it is
only necessary to have built libwxml.a in the Src hierarchy of Siesta
(after creating the necessary arch.make)

* ATOM now recognizes the FREE_FORMAT_RC_INPUT directive, useful
for optimization runs.

* A new estimation of ps hardness (qmax) is written to FOURIER_QMAX file.

* The fourier area calculation has been moved to the "down" section,
since the "up" potentials are not always generated.

* Avoid very small numbers that might need a three-character
exponent field in formatted output.

* The Tutorial has been brought up to date, using the version employed
in the latest Siesta schools. Note that the location of the
scripts used to run the examples has changed. They are now in the
Pseudo/atom/Tutorial/Utils directory.

* Extended the periodic-table structures in input.f and nucl_z.f


2008-05-06  10:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-16

Summary: Make the production of small ionic files optional -- fdf.log

* Files with prefix ORB, KB, CHCORE, SPLIT_SCAN, etc, and
pseudopotential dump files, which are useful for plotting basis
orbitals and other ion-related information, are now optional. To
create them, the user should set

 WriteIonPlotFiles T

in the fdf file.

Note that the same functionality is available in gen-basis.

The corresponding option variable "write_ion_plot_files" is now kept
in an "atom-specific" options module, to avoid a dependency cascade.

* Fixed the makefile sections for some auxiliary programs.

* The file "out.fdf" has been renamed to "fdf.log"

2008-04-08  16:30:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-15

Summary: Implemented a Grimme-type  molecular-mechanics potential for dispersion effects

A dispersion potential of the Grimme type (similar to the C6 type but
with a different damping function) has been implemented. See
S. Grimme, J. Comput. Chem. Vol 27, 1787-1799 (2006)).

The parameters are specified in the MM.Potentials block, using the
"Grimme" keyword.

Hooks for changing the "d" and "s6" parameters are provided
(MM.Grimme.D and MM.Grimme.S6).

A minor cosmetic addition: the kind of molecular mechanics potential
between species is now printed upon encoutering the relevant line in
the block.

2008-04-08  15:00:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-14

Summary: Changes for portability and cosmetics 

Portability:

  *  Use character(*) in MPI character modules.

       Previously character(1) was used, leading to complaints by some compilers.

Usability:

  *  Extra fdf symbol for struct_file input specification

       The manual mentions "Use.Struct.File" as the relevant alias, but
       the code used "MD.Use.Struct.File". Both are now accepted.

Makefile and makefile templates:

  *  Fix mixps section in Makefile
  *  Add .make file for snake at ICMAB
  *  Fix tabs in eth-hreidar-mpi.make

2008-03-08  23:56:00 GMT  Alberto Garcia <albertog@icmab.es>	patch-13

Summary: Remove 'multiple images' warning in gamma-point-only calculations

The calculation of the xij array (vector distances to interacting
neighbors) was enabled in 2.5.1 also for the case of gamma-point-only
calculations. This is needed for the post-processing of COOP curves.
In a gamma-point-only calculation several atoms might still
